(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_cre_jo *)

unit U_cre_jo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    cree: TButton;
    procedure creeClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.creeClick(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='FACTURE';

    FieldDefs.Clear;
    FieldDefs.Add('F_NUMERO', ftInteger, 0, True);
    FieldDefs.Add('F_CLIENT', ftString, 10, True);
    FieldDefs.Add('F_TOTAL', ftFloat, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('F_I_NUMERO', 'F_NUMERO', [] );
    CreateTable;

    Open;

    AppendRecord([1001, 'MARTIN']);
    AppendRecord([1002, 'SCHMITT']);
    AppendRecord([1003, 'BELIN']);
    AppendRecord([1004, 'DUBOIS']);
{
    AppendRecord([1001, 'Eric']);
    AppendRecord([1002, 'Luc']);
    AppendRecord([1003, 'Jean']);
    AppendRecord([1004, 'Luc']);
}
  end;

  With Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='ITEM';

    FieldDefs.Clear;
    FieldDefs.Add('I_NUM_FACT', ftInteger, 0, True);
    FieldDefs.Add('I_NUMERO', ftInteger, 0, True);
    FieldDefs.Add('I_LIBELLE', ftString, 8, True);
    FieldDefs.Add('I_CODE', ftInteger, 0, True);
    FieldDefs.Add('I_PRIX', ftFloat, 0, True);
    FieldDefs.Add('I_QUANTITE', ftFloat, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('I_I_NUMFAC', 'I_NUM_FACT', [] );
    IndexDefs.Add('I_I_LIBELL', 'I_LIBELLE', [] );

    CreateTable;
    AddIndex('I_I_NF_LIB', 'STR(I_NUM_FACT, 4, 0)+ I_LIBELLE', [ixExpression] );

    Open;

    AppendRecord([1001, 1, 'Micro',   100, 101.01, 2]);
    AppendRecord([1001, 2, 'Souris',  200, 123.02, 3]);
    AppendRecord([1001, 3, 'Listing', 300, 115.03, 4]);
    AppendRecord([1002, 1, 'Lecteur', 400, 124.04, 5]);
    AppendRecord([1003, 1, 'Laser',   500, 139.05, 6]);
    AppendRecord([1003, 2, 'Souris',  210, 178.06, 7]);
    AppendRecord([1004, 1, 'Listing', 300, 115.03, 8]);
  end;
end;

end.



