(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_md_fil *)

(* -- importer UFILTRE de CHAP8|A_FIL dans Option | Projet | Lieur *)
 
unit U_md_fil;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button2: TButton;
    Button1: TButton;
    Button3: TButton;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Table2I_NUM_FACT: TFloatField;
    Table2I_NUMERO: TFloatField;
    Table2I_LIBELLE: TStringField;
    Table2I_CODE: TFloatField;
    Table2I_PRIX: TFloatField;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Table2BeforeClose(DataSet: TDataset);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, ufiltre;

{$R *.DFM}

function f_verifie(p_valeur: Integer): Boolean;
  var l_chaine_z: String;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);
          ShowMessage('Erreur '+ StrPas(@l_chaine_z));
        end;
    f_verifie:= p_valeur= 0;
  end; (* f_verifie *)

const vi_poignee_filtre: hDbiFilter= NIL;

procedure TForm1.Button1Click(Sender: TObject);
begin
{
  ajoute_filtre(Table2, 'I_NUM_FACT= 1002.0', vi_poignee_filtre);
}
  if vi_poignee_filtre<> nil
    then Button2Click(Nil);
  ajoute_filtre(Table2, 'I_NUM_FACT= '+  Table1.FieldByName('F_NUMERO').AsString+  '.0', vi_poignee_filtre);

  f_verifie(DbiActivateFilter(Table2.Handle, vi_poignee_filtre));
  Table2.First;
  Table2.Refresh;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  f_verifie(DbiDeActivateFilter(Table2.Handle, vi_poignee_filtre));
  f_verifie(DbiDropFilter(Table2.Handle, vi_poignee_filtre));
  vi_poignee_filtre:= nil;

  Table2.Refresh;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin

  Table2.IndexName:= 'I_I_LIBELL';

end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  Button1Click(nil);
end;

procedure TForm1.Table2BeforeClose(DataSet: TDataset);
begin
  MessageBeep(0);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if vi_poignee_filtre<> nil
    then Button2Click(Nil);
end;

end.


