(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_cle_re *)

unit U_cle_re;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure Table1NewRecord(DataSet: TDataset);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs;

  {$R *.DFM}

  function f_nombre_fiches(p_table: tTable): LongInt;
    var l_proprietes_enregistrement: RECProps;
        l_table: tTable;
    begin
      l_table:= tTable.Create(nil);
      with l_table do
      begin
        DatabaseName:= p_table.DatabaseName;
        TableType:= ttdBase;
        TableName:= p_table.TableName;

        Open;
        Last;

        (* -- rcupre la proprit de l'enregistrement *)
        if DbiGetRecord(Handle, dbiNOLOCK, nil, @l_proprietes_enregistrement)= 0
           then Result := l_proprietes_enregistrement.iPhyRecNum
           else Result := -1;

        close;
        Free;
      end; (* with l_table *)
    end; (* f_nombre_fiches *)

procedure TForm1.Table1NewRecord(DataSet: TDataset);
begin
  Table1.FieldByName('F_NUMERO').AsInteger:= 1001+ f_nombre_fiches(Table1);
end;

end.
