(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_md_ajc *)

unit U_md_ajc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    Prior_: TButton;
    Next_: TButton;
    Append_: TButton;
    Post_: TButton;
    Table2A_CODE: TFloatField;
    Table2A_LIBELLE: TStringField;
    Table2A_POIDS: TFloatField;
    ajoute: TButton;
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Prior_Click(Sender: TObject);
    procedure Next_Click(Sender: TObject);
    procedure Append_Click(Sender: TObject);
    procedure Post_Click(Sender: TObject);
    procedure Table2A_POIDSSetText(Sender: TField; const Text: String);
    procedure ajouteClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  With Table2 do
  begin
    SetRangeStart;
    FieldByName('A_LIBELLE').AsString:= Table1.FieldByName('I_LIBELLE').AsString;
    FieldByName('A_CODE').AsInteger:= Table1.FieldByName('I_CODE').AsInteger;

    SetRangeEnd;
    FieldByName('A_LIBELLE').AsString:= Table1.FieldByName('I_LIBELLE').AsString;
    FieldByName('A_CODE').AsInteger:= Table1.FieldByName('I_CODE').AsInteger;

    ApplyRange;
  end;
end;

procedure TForm1.Prior_Click(Sender: TObject);
begin
  Table1.Prior;
end;

procedure TForm1.Next_Click(Sender: TObject);
begin
  Table1.Next;
end;

procedure TForm1.Append_Click(Sender: TObject);
begin
  Table1.Append;
end;

procedure TForm1.Post_Click(Sender: TObject);
begin
  Table2.Post;
  Table1.Post;
end;

procedure TForm1.Table2A_POIDSSetText(Sender: TField; const Text: String);
begin
  Table2A_LIBELLE.AsString:= Table1.FieldByName('I_LIBELLE').AsString;
  Table2A_CODE.AsInteger:= Table1.FieldByName('I_CODE').AsInteger;

  Table2A_POIDS.AsString:= Text;
end;

procedure TForm1.ajouteClick(Sender: TObject);
begin
  Table1.Append;

  Table1.FieldByName('I_LIBELLE').AsString:= 'lampe';
  Table1.FieldByName('I_CODE').AsInteger:= 1234;
  Table1.FieldByName('I_PRIX').AsFloat:= 45.89;

  Table2.Append;
  Table2A_LIBELLE.AsString:= Table1.FieldByName('I_LIBELLE').AsString;
  Table2A_CODE.AsInteger:= Table1.FieldByName('I_CODE').AsInteger;
  Table2A_POIDS.AsFloat:= 456.78;

  Table2.Post;
  Table1.Post;
end;

end.


