(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 ajoval *)
(* 21 nov 95 *)

(* essais divers LookUp *)

unit U_lootr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls, Mask,
  DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;

    DataSource1: TDataSource;
    DBGrid1: TDBGrid;

    Table2: TTable;
    DataSource2: TDataSource;
    ListBox1: TListBox;
    Button1: TButton;
    Table1I_NUM_FACT: TFloatField;
    Table1I_CODE: TFloatField;
    Table1I_PRIX: TFloatField;
    Table1I_QUANTITE: TFloatField;
    Table1_description: TStringField;
    Table3: TTable;
    procedure Table1CalcFields(DataSet: TDataset);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiErrs;

{$R *.DFM}

(* -- LookUp tri dans ordre des libells *)
(* -- charge une list-box *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  With Table2, ListBox1 do
  begin
    Items.Clear;
    Sorted:= True;

    First;
    While not Eof do
    begin
      Items.add(FieldByName('A_DESCRIPT').AsString);
      Next;
    end;
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  With Table2 do
  begin
{
    First;
    while not Eof and (FieldByName('A_DESCRIPT').AsString<>  ListBox1.Items[ListBox1.ItemIndex]) do
      Next;

    if Table1I_CODE.AsInteger<> FieldByName('A_CODE').AsInteger
      then begin
          Table1.Edit;
          Table1I_CODE.AsInteger:= FieldByName('A_CODE').AsInteger;
          Table1.Post;
        end;
}
  end; (* with Table2 *)
  If Table2.FindKey([ListBox1.Items[ListBox1.ItemIndex]])
    then
      if Table1I_CODE.AsInteger<> Table2.FieldByName('A_CODE').AsInteger
        then begin
            Table1.Edit;
            Table1I_CODE.AsInteger:= Table2.FieldByName('A_CODE').AsInteger;
            Table1.Post;
         end;
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
begin
  (* -- rcupre DESCRIPTION *)
  (* -- si index sur I_CODE *)
  If Table3.FindKey([Table1I_CODE.AsInteger])
    then Table1_description.AsString:= Table3.FieldByName('A_DESCRIPT').AsString;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var l_indice: Integer;
begin
  if Field= Nil
    then begin
        l_indice:= ListBox1.Items.IndexOf(Table1_description.AsString);

        ListBox1.ItemIndex:= l_indice;
        ListBox1.TopIndex:= l_indice;
      end;
end;

end.
