(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_flubl2 *)

unit U_flubl2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    BlobField_LoadFromStream: TButton;
    ecris: TButton;
    ajoute: TButton;
    ListBox1: TListBox;
    Table1B_NUMERO: TFloatField;
    Table1B_BLOB: TMemoField;
    Table1B_MEMO: TMemoField;
    Table1B_GRAPHIC: TBlobField;
    Edit1: TEdit;
    lis: TButton;
    taille: TButton;
    Memo_S_t_S: TButton;
    ListBox1_L_f_S: TButton;
    BlobField_LoadFromFile: TButton;
    BlobField_Assign: TButton;
    sauve: TButton;
    procedure ecrisClick(Sender: TObject);
    procedure ajouteClick(Sender: TObject);
    procedure BlobField_LoadFromStreamClick(Sender: TObject);
    procedure lisClick(Sender: TObject);
    procedure tailleClick(Sender: TObject);
    procedure Memo_S_t_SClick(Sender: TObject);
    procedure ListBox1_L_f_SClick(Sender: TObject);
    procedure BlobField_LoadFromFileClick(Sender: TObject);
    procedure BlobField_AssignClick(Sender: TObject);
    procedure sauveClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.ecrisClick(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_entier: Integer;
    l_texte: String;
    l_reel: Double;
begin
  Table1.Edit;

  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmWrite);

  l_entier:= 123;
  l_flux_blob.Write(l_entier, SizeOf(l_entier));
  l_texte:= Edit1.Text;
  l_flux_blob.Write(l_texte, 1+ Length(l_texte));
  l_reel:= 3.14;
  l_flux_blob.Write(l_reel, SizeOf(l_reel));

  l_flux_blob.Free;

  Table1.Post;
end;

procedure TForm1.lisClick(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_entier: Integer;
    l_taille: Byte;
    l_texte: String;
    l_reel: Double;
begin
  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmRead);

  l_flux_blob.Read(l_entier, SizeOf(l_entier));
  ListBox1.Items.Add(IntToStr(l_entier));

  l_flux_blob.Read(l_taille, 1);
  l_flux_blob.Read(l_texte[1], l_taille); l_texte[0]:= chr(l_taille);
  ListBox1.Items.Add(l_texte);

  l_flux_blob.Read(l_reel, SizeOf(l_reel));
  ListBox1.Items.Add(FloatToStr(l_reel));

  l_flux_blob.Free;
end;

procedure TForm1.tailleClick(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_taille: LongInt;
begin
  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmRead);
  l_taille:= l_flux_blob.Size;
  l_flux_blob.Free;

  ListBox1.Items.Add('taille: '+ IntToStr(l_taille));
end;

procedure TForm1.ajouteClick(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_texte: String;
begin
  Table1.Edit;

  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmReadWrite);

  l_flux_blob.Position:= l_flux_blob.Size;

  l_texte:= Edit1.Text;
  l_flux_blob.Write(l_texte, 1+ Length(l_texte));

  l_flux_blob.Free;

  Table1.Post;
end;

procedure TForm1.Memo_S_t_SClick(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  Table1.Edit;

  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmWrite);
  Memo1.Lines.SaveToStream(l_flux_blob);
  l_flux_blob.Free;

  Table1.Post;
end;

procedure TForm1.ListBox1_L_f_SClick(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmRead);
  ListBox1.Items.LoadFromStream(l_flux_blob);
  l_flux_blob.Free;
end;

procedure TForm1.BlobField_LoadFromStreamClick(Sender: TObject);
var l_flux_memoire: tMemoryStream;
begin
  l_flux_memoire:= tMemoryStream.Create;
  Memo1.Lines.SaveToStream(l_flux_memoire);

  Table1.Edit;
  Table1B_GRAPHIC.LoadFromStream(l_flux_memoire);
  Table1.Post;

  l_flux_memoire.Free;
end;

procedure TForm1.BlobField_LoadFromFileClick(Sender: TObject);
begin
  Table1.Edit;
  Table1B_GRAPHIC.LoadFromFile('u_flublo.~pa');
  Table1.Post;
end;

procedure TForm1.BlobField_AssignClick(Sender: TObject);
begin
  Table1.Edit;
  Table1B_GRAPHIC.Assign(Memo1.Lines);
  Table1.Post;
end;

procedure TForm1.sauveClick(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmRead);
  Memo1.Lines.LoadFromStream(l_flux_blob);
  l_flux_blob.Free;
end;

end.

