(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_masqu1 *)

unit U_masqu1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Mask;

type
  TForm1 = class(TForm)
    Button1: TButton;
    MaskEdit1: TMaskEdit;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    sauve: TButton;
    clip: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure sauveClick(Sender: TObject);
    procedure clipClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure ajoute(p_masque, p_chaine: String);
  begin
    with Form1, ListBox1.Items do
    begin
{
      Add(FormatMaskText(Edit1.Text, Edit2.text));
}
      MaskEdit1.EditMask:= p_masque;
      MaskEdit1.Text:= p_chaine;
      Add(Format('  %-15s %-15s %-15s', [p_masque, p_chaine, MaskEdit1.EditText]));
    end; (* with *)
  end; (* ajoute *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  with ListBox1.Items do
  begin
    ajoute('Ll09#AaCc;0;_', 'zzzzzzzzz');

    Add('complte:');
    ajoute('ccc;0;_', 'zzz');
    ajoute('ccc;0;_', 'z z');
    ajoute('ccc;0;_', 'zz');
    ajoute('!ccc;0;_', 'zz');

    Add('');
    ajoute('ccc;0;_', 'zzzz');
    ajoute('!ccc;0;_', 'zzzz');

    Add('ponctuations');
    ajoute('c(c)c;0;_', 'abcde');
    ajoute('c(c)c;0;_', 'a(b)cde');
    ajoute('c(c)c;0;_', 'ab(cd)e');

    Add('complte et ponctuations');
    ajoute('cc(cc)cc;0;_', 'a');
    ajoute('!cc(cc)cc;0;_', 'a');
    ajoute('cc(cc)cc;0;_', 'ab');
    ajoute('cc(cc)cc;0;_', 'abc');
    ajoute('!cc(cc)cc;0;_', 'abc');
    ajoute('cc(cc)cc;0;_', 'abcdefg');

    Add('');
    ajoute('c/c:c;0;_', 'abcd');
    ajoute('c\!c\\c;0;_', 'abcd');

    Add('?');
    ajoute('(c;0;_', 'a');
    ajoute('(cc;0;_', 'a');
    ajoute('(c;0;_', 'ab');
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  with ListBox1.Items do
  begin
    ajoute('ccc;1;_', 'zzz');
    ajoute('ccc;1;_', 'z z');
    ajoute('ccc;1;_', 'zz');
    ajoute('!ccc;1;_', 'zz');

    Add('');
    ajoute('ccc;1;_', 'abcd');
    ajoute('!ccc;1;_', 'abcd');

    Add('complte:');
    ajoute('c(c)c;1;_', 'abcde');
    ajoute('c(c)c;1;_', 'a(b)cde');
    ajoute('c(c)c;1;_', 'ab(cd)ef');
    ajoute('c(c)c;1;_', 'a(bcde');
    ajoute('c(c)c;1;_', '()abcde');

    Add('ponctuations');
    ajoute('!c(c)c;1;_', 'abcde');
    ajoute('!c(c)c;1;_', 'a(b)cde');
    ajoute('!c(c)c;1;_', 'ab(cd)ef');
    ajoute('!c(c)c;1;_', '()abcde');

    Add('manque ( ');
    ajoute('!c(c)c;1;_', 'a(bcde');

    ajoute('c\;cc;0;_', 'abc');
    ajoute('c.c,c-c_;0;_', 'abcd');
    ajoute('!ccc(c)c;1;_', 'a(bc');


    Add('complte et ponctuations');
    ajoute('cc(cc)cc;1;_', 'a');
    ajoute('cc(cc)cc;1;_', 'abc');
    ajoute('cc(cc)cc;1;_', 'a(b)c');
    ajoute('!cc(cc)cc;1;_', 'abc');
    ajoute('!cc(cc)cc;1;_', 'a(b)c');

    Add('?');
    ajoute('(c;1;_', '(a');
    ajoute('(cc;1;_', '(a');
    ajoute('(c;1;_', '(ab');
    ajoute('cccc(cc)cc;1;_', 'a)b(c');
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  with ListBox1.Items do
  begin
{
    ajoute('c:c/;0;_', 'abcde');
    ajoute('c>c<c<>c;0;_', 'abcd');
    ajoute('cc(cc)ccccccc;1;_', 'ab(cd)efghij');
}
    ajoute('!cc;0;_', 'abc');
  end;
end;

procedure TForm1.sauveClick(Sender: TObject);
begin
  ListBox1.Items.SaveToFile('e.pas');
end;

procedure TForm1.clipClick(Sender: TObject);
begin
  Maskedit1.CopyToClipBoard;
end;

end.
