(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_chpda2 *)

unit U_chpda2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1NAISSANCE: TDateField;
    procedure Table1NAISSANCEGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table1NAISSANCESetText(Sender: TField; const Text: String);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Table1NAISSANCEGetText(Sender: TField; var Text: OpenString;
  DisplayText: Boolean);
var l_date: tDateTime;
begin
  l_date:= Table1NAISSANCE.AsDateTime;

  if DisplayText
    then Text:= FormatDateTime('DD-MMM-YY', l_date)
    else Text:= FormatDateTime('DD MM YY', l_date)
end;

procedure TForm1.Table1NAISSANCESetText(Sender: TField; const Text: String);
var l_jour, l_mois, l_annee: String;
begin
  l_jour:= Copy(Text, 1, 2);
  l_mois:= Copy(Text, 4, 2);
  l_annee:= Copy(Text, 7, 2);
  Table1NAISSANCE.AsDateTime:= EncodeDate(StrToInt(l_annee), StrToInt(l_mois), StrToInt(l_jour));
end;

end.
