(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_dat200 *)

unit U_dat200;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    ListBox1: TListBox;
    Table1NUMERO: TFloatField;
    Table1NAISSANCE: TDateField;
    Edit1: TEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Table1NAISSANCEGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table1NAISSANCESetText(Sender: TField; const Text: String);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var l_chaine: String;

  procedure ajoute(p_chaine: String);
    var l_date: tDateTime;
        l_annee, l_mois, l_jour: Word;
    begin
      l_date:= StrToDate(p_chaine);
      DecodeDate(l_date, l_annee, l_mois, l_jour);
      With ListBox1.Items do
      begin
        Add(Format('%-10s %10n   %4d', [p_chaine, StrToDate(p_chaine), l_annee ]));
      end;
    end; (* ajoute *)

begin
  With ListBox1.Items do
  begin
{
    Add(FormatMaskText('99 LLL 99;1;_', '11 xyz 32')
       + '>'+ Table1DATE.Text+ '<');

    l_chaine:= '1/2/95';
    l_chaine:= Copy(l_chaine, 1, Length(l_chaine)- 3)
        + '/'+ '20'+ Copy(l_chaine, Length(l_chaine)- 1, 2);
    Add(DateTimeToStr(StrToDate(l_chaine)) );

}
    ajoute('1/2/100');
    ajoute('1/2/0100');
    ajoute('1/2/181');
    ajoute('1/2/1000');
    ajoute('1/2/1800');
    ajoute('1/2/0');
    ajoute('1/2/00');
    ajoute('1/2/000');
    ajoute('1/2/0000');
    ajoute('1/2/1900');
    ajoute('1/2/1');
    ajoute('1/2/01');
    ajoute('1/2/001');
    ajoute('1/2/0001');
    ajoute('1/2/10');
    ajoute('1/2/0010');
    ajoute('1/2/96');
    ajoute('1/2/1996');
    ajoute('1/2/2000');
  end;
end;

procedure TForm1.Table1NAISSANCEGetText(Sender: TField;
  var Text: OpenString; DisplayText: Boolean);
begin
  Text:= FormatDateTime('DD/MM/YY', Table1NAISSANCE.AsDateTime);
end;

procedure TForm1.Table1NAISSANCESetText(Sender: TField;
  const Text: String);
var l_date: tDateTime;
    l_jour, l_mois, l_annee: Word;
begin
  l_date:= StrToDate(Text);

  (* -- modifie le sicle *)
  DecodeDate(l_date, l_annee, l_mois, l_jour);
  If l_annee< 1950
    then l_annee:= l_annee+ 100;
  l_date:= EncodeDate(l_annee, l_mois, l_jour);

  Table1NAISSANCE.AsDateTime:= l_date;

  Edit1.Text:= FormatDateTime('DD/MM/YYYY', Table1NAISSANCE.AsDateTime);
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_chaine: String;
begin
  l_chaine:= FormatDateTime('DD/MM/YY', Table1NAISSANCE.AsDateTime);
  Insert('20', l_chaine, 7);
  Edit1.Text:= l_chaine;
{

  ListBox1.Items.SaveToFile('a:f.pas');
}
end;

end.
