(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_datsql *)

unit U_datsql;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, Mask;

type
  TForm1 = class(TForm)
    Button1: TButton;
    DataSource2: TDataSource;
    Query1: TQuery;
    DBGrid2: TDBGrid;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
  var l_erreur: String;
begin
  With Query1, SQL do
  begin
    Close;
    DatabaseName:= 'Flix';
    Clear;
{
    (* -- nombre de jours *)
      (* -- pas exc, mais fait la DIVISION !!! *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"> 1/26/1996 ');

      (* -- OK pour le 10/jan/0001 *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"< 19 ');

      (* -- OK pour le 10/jan/0001 *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"< 25-1-1996 ');

      (* -- OK pour le 10/jan/0001 *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"< 19 AND t."NAISSANCE"> 2');

      (* OK *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"> '+ FloatToStr( EncodeNAISSANCE(1996, 1, 25) ) );

      (* OK *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"> :ma_NAISSANCE ');
      Params[0].AsNAISSANCE:= StrToNAISSANCE('25/1/1995 ');

      (* OK *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"> :ma_NAISSANCE ');
      Params[0].AsNAISSANCE:= StrToNAISSANCE('25/1/1995 ');

      (* OK. Bien prciser le sicle *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE EXTRACT(YEAR FROM t."NAISSANCE") > 1995 ');

      (* OK *)
      Add('SELECT EXTRACT(YEAR FROM t."NAISSANCE") FROM "AFFICHE.DBF" t ');

      (* OK *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"> '+ FloatToStr( Trunc(Now- 61)) );

    (* -- guillemets *)
      (* -- la NAISSANCE existe pas, image 2 *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"> "25/1/95" ');
}
      (* OK *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"> "1/25/95" ');
{
      (* -- compris comme JAN/1/1901 *)
      Add('SELECT * FROM "AFFICHE.DBF" t ');
      Add('  WHERE t."NAISSANCE"< "1/1/1" ');
      Button2.Caption:= FloatToStr(StrToNAISSANCE('25/1/96'));
}
    TRY
    Open;
    Query1.FieldByName('NOM').Visible:= False;
    Query1.FieldByName('PRENOM').Visible:= False;
    Query1.FieldByName('POIDS').Visible:= False;
    EXCEPT
      on e: eConvertError do
        ShowMessage('OK');
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_NoSuchDa : l_erreur:= 'no such data';
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
  end;
end;

end.



