(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_memfie *)

(* -- exemple de memo *)

unit U_memfie;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    Memo1: TMemo;
    BlobStream_write: TButton;
    Table1B_NUMERO: TFloatField;
    Table1B_MEMO: TMemoField;
    Memo2: TMemo;
    MemoField_Assign_2: TButton;
    Memo_Assign: TButton;
    MemoField_L_f_S: TButton;
    MemoField_L_f_F: TButton;
    MemoField_Assing_1: TButton;
    Button1: TButton;
    BlobStream_Size: TButton;
    dbMem_Add: TButton;
    procedure BlobStream_writeClick(Sender: TObject);
    procedure MemoField_Assign_2Click(Sender: TObject);
    procedure Memo_AssignClick(Sender: TObject);
    procedure MemoField_L_f_SClick(Sender: TObject);
    procedure MemoField_L_f_FClick(Sender: TObject);
    procedure MemoField_Assing_1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BlobStream_SizeClick(Sender: TObject);
    procedure dbMem_AddClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)

{$R *.DFM}

procedure TForm1.BlobStream_writeClick(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_texte: String;
begin
  Table1.Edit;

  l_flux_blob:= tBlobStream.Create(Table1B_MEMO, bmReadWrite);

  l_flux_blob.Position:= l_flux_blob.Size;

{
  l_texte:= Memo1.Lines[0]+ chr(13)+ chr(10);
}
  l_texte:= 'Bonjour'+ chr(13)+ chr(10);
  l_flux_blob.Write(l_texte[1], Length(l_texte));

  l_flux_blob.Free;

  Table1.Post;
end;

procedure TForm1.BlobStream_SizeClick(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  l_flux_blob:= tBlobStream.Create(Table1B_MEMO, bmRead);
  Memo2.Lines.Add(IntToStr(l_flux_blob.Size));
  l_flux_blob.Free;
end;

procedure TForm1.MemoField_L_f_SClick(Sender: TObject);
var l_flux_memoire: tMemoryStream;
    l_texte: String;
begin
  l_flux_memoire:= tMemoryStream.Create;
  l_texte:= 'pi= '+ FloatToStr(3.14)+ chr(13)+ chr(10);
  l_flux_memoire.Write(l_texte[1], Length(l_texte));

  Table1.Edit;
  Table1B_MEMO.LoadFromstream(l_flux_memoire);
  Table1.Post;

  l_flux_memoire.Free;
end;

procedure TForm1.MemoField_L_f_FClick(Sender: TObject);
begin
  Table1.Edit;
  Table1B_MEMO.LoadFromFile('u_memo.~pa');
  Table1.Post;
end;

procedure TForm1.MemoField_Assign_2Click(Sender: TObject);
begin
  Table1.Edit;
  Table1.FieldByName('B_MEMO').Assign(Memo1.Lines);
  Table1.Post;
end;

procedure TForm1.Memo_AssignClick(Sender: TObject);
begin
{
  Memo2.Lines.Assign(Table1.FieldByName('B_MEMO') As tMemoField);
}
  Memo2.Lines.Assign(Table1.FieldByName('B_MEMO'));
end;

procedure TForm1.MemoField_Assing_1Click(Sender: TObject);
var l_liste: tStringList;
begin
  l_liste:= tStringList.Create;
  l_liste.Add('Ok');

  Table1.Edit;
  Table1B_MEMO.Assign(l_liste);
  Table1.Post;

  l_liste.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var l_erreur: String;
    l_chaine: String;
begin

    TRY
{
  Table1B_MEMO.GetData(@l_chaine);
}
{
  (* -- retourne (Memo) *)
  l_chaine:= Table1B_MEMO.AsString;
  Button1.Caption:= l_chaine;
}
{
      (* exc *)
      Table1.Edit;
      Table1B_MEMO.AsString:= 'Oh';;
      Table1.Post;
      (* exc *)
      Table1.AppendRecord([1, 'aha']);
}
      Button1.Caption:= IntToStr(Table1B_MEMO.DataSize);
    EXCEPT
      on e: eConvertError do
        ShowMessage('OK');
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
end;

procedure TForm1.dbMem_AddClick(Sender: TObject);
begin
  Table1.Edit;

  dbMemo1.Lines.Add('ajoute en fin');
  dbMemo1.Lines.Insert(1, 'insre');
  dbMemo1.Lines.Delete(2);

  Table1.Post;
end;

end.


