(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_gr5 *)

unit U_db_gr5;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ColWidths_: TButton;
    FixedCols_: TButton;
    cree: TButton;
    col_gauche: TButton;
    Memo1: TMemo;
    col_row: TButton;
    selection: TButton;
    Table1: TTable;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    RowHeights_: TButton;
    DBGrid2: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    Table2PRENOM: TStringField;
    Table2POIDS: TFloatField;
    Table1PRENOM: TStringField;
    Table1POIDS: TFloatField;
    procedure ColWidths_Click(Sender: TObject);
    procedure FixedCols_Click(Sender: TObject);
    procedure creeClick(Sender: TObject);
    procedure col_gaucheClick(Sender: TObject);
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure col_rowClick(Sender: TObject);
    procedure selectionClick(Sender: TObject);
    procedure RowHeights_Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Dclarations private }
    procedure on_key_down(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ColWidths_Click(Sender: TObject);
var l_indice: Integer;
    l_texte: String;
    l_total: Integer;
begin
  with tDrawGrid(dbGrid1), Memo1.Lines do
  begin
    ColWidths[1]:= 50;

    Clear;
    l_texte:= '';
    l_total:= 0;
    for l_indice:= 0 to tDrawGrid(dbGrid1).ColCount- 1 do
    begin
      l_texte:= l_texte+ IntToStr(ColWidths[l_indice])+ ', ';
      l_total:= l_total+ ColWidths[l_indice]+ 1;
    end;
    Add('ColWidths  '+ l_texte);
    Add('  total+n= '+ IntToStr(l_total));

    Add('GridWidth  '+ IntToStr(GridWidth));
    Add('Width      '+ IntToStr(dbGrid1.Width));

    (* ne s'ajuste pas
    Width:= GridWidth+ GetSystemMetrics(sm_cxvScroll)+ 1;
    *)
    exit;
    Width:= l_total+ GetSystemMetrics(sm_cxvScroll)+ 1;
  end;
end;

procedure TForm1.RowHeights_Click(Sender: TObject);
var l_indice: Integer;
    l_texte: String;
begin
  with tDrawGrid(dbGrid1), Memo1.Lines Do
  begin
    Clear;
    Add('GridHeight '+ IntToStr(GridHeight));

    l_texte:= '';
    For l_indice:= 0 to RowCount- 1 do
      l_texte:= l_texte+ IntToStr(RowHeights[1])+ ', ';
    Add('RowHeights '+ l_texte);
    Add('Height     '+ IntToStr(dbGrid1.Height));

    dbGrid1.Height:= GridHeight+ 1;
  end;
end;

type t_dbgrille= Class(tdbGrid)
    Private
    protected
      procedure Paint; Override;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); Override;
    end;

  procedure t_dbgrille.Paint;
    var l_indice: Integer;
        l_rectangle: tRect;
    begin
{
      (* OK *)
      SetScrollRange(Self.Handle, sb_Vert, 0, 0, False);
}
      Inherited Paint;

      (* -- encacre les titres de rouge *)
      For l_indice:= 0 to FieldCount- 1 do
        With CellRect(l_indice+ 1, 0) do
        begin
          SetRect(l_rectangle, Left+ 1, Top+ 1, Right- 1, Bottom- 4);
          Canvas.Brush.Color:= clRed;
          Canvas.FrameRect(l_rectangle);
        end;

      (* OK *)
      SetScrollRange(Self.Handle, sb_Vert, 1, Form1.Table1.RecordCount, False);
      SetScrollPos(Self.Handle, sb_Vert, Form1.Table1.FieldByName('NUMERO').AsInteger, True);
    end;

  procedure t_dbgrille.MouseDown(Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
    var l_ligne, l_colonne: LongInt;
    begin
      (* -- empche le clic sur les colonnes fixes *)
      tDrawGrid(Self).MouseToCell(X, Y, l_colonne, l_ligne);
      if l_colonne< tDrawGrid(Self).FixedCols
        then exit;

      Inherited MouseDown(Button, Shift, X, Y);
    end;

const g_dbgrille: t_dbgrille= nil;

procedure TForm1.creeClick(Sender: TObject);
begin
  dbGrid1.Visible:= False;

  g_dbgrille:= t_dbgrille.Create(Self);
  with g_dbgrille do
  begin
    DataSource:= DataSource1;
    Parent:= Self;
    Left:= 10; Top:= 10;
    Height:= 88; Width:= 340;

    tDrawGrid(g_dbGrille).RowHeights[0]:= 35;
{
    SetScrollRange(Self.Handle, sb_Vert, 1, Form1.Table1.RecordCount, False);
}
    OnKeyDown:= on_key_down;
  end;
end;

(* -- dfilement horizontal *)

procedure TForm1.col_gaucheClick(Sender: TObject);
begin
  tDrawGrid(dbGrid1).LeftCol:= 2;

  With Memo1.Lines, tDrawGrid(dbGrid1) do
  begin
    Clear;
    Add('LeftCol         '+ IntToStr(LeftCol));
    Add('VisibleColCount '+ IntToStr(VisibleColCount));
  end;
end;

(* -- colonnes fixes *)

procedure TForm1.FixedCols_Click(Sender: TObject);
begin
  if g_dbgrille<> nil
    then tDrawGrid(g_dbgrille).FixedCols:= 2
    else begin
        FixedCols_.Visible:= False;
        tDrawGrid(dbGrid1).FixedCols:= 2
      end;
end;

procedure TForm1.on_key_down(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if g_dbgrille<> nil
    then
      case Key of
        vk_Left : if g_dbgrille.SelectedIndex= 1
                    then Key:= 0;
        vk_Tab : if (g_dbgrille.SelectedIndex= 1) and (ssShift in Shift)
                      or
                    (g_dbgrille.SelectedIndex= g_dbgrille.FieldCount- 1) and not (ssShift in Shift)
                    then Key:= 0;
      end;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var l_nombre: Integer;
begin
  if Table2.Active
    then
      if Table1.State= dsBrowse
        then begin
            table2.GotoCurrent(Table1);
            if tDrawGrid(dbGrid1).Row> tDrawGrid(dbGrid2).Row
              then begin
                  l_nombre:= tDrawGrid(dbGrid2).Row;
                  Table2.MoveBy(-l_nombre);
                  Table2.MoveBy(l_nombre);
                end
              else
                if tDrawGrid(dbGrid1).Row< tDrawGrid(dbGrid2).Row
                  then begin
                      l_nombre:= tDrawGrid(dbGrid2).RowCount- tDrawGrid(dbGrid2).Row;
                      Table2.MoveBy(l_nombre);
                      Table2.MoveBy(-l_nombre);
                     end;
          end;
end;

(* -- ligne et colonne *)

procedure TForm1.col_rowClick(Sender: TObject);
var l_indice: Integer;
    l_texte: String;
begin
  with tDrawGrid(dbGrid1), Memo1.Lines Do
  begin
    Clear;
    Add('Col        '+ IntToStr(Col));
    Add('ColCount   '+ IntToStr(ColCount));

    Add('Row        '+ IntToStr(Row));
    Add('RowCount   '+ IntToStr(RowCount));

    With CellRect(Col, Row) do
      Add('CellRect   '+IntToStr(Left)+ ' '+ IntToStr(Right)+ ' '+ IntToStr(Width)
          + ' '+ IntToStr(Height));
  end;
end;

procedure TForm1.selectionClick(Sender: TObject);
begin
  with tDrawGrid(dbGrid1), Memo1.Lines Do
  begin
    Clear;
    Add('SelectedIndex       '+ IntToStr(dbGrid1.SelectedIndex));
    Add('SelectedField.Index '+ IntToStr(dbGrid1.SelectedField.Index));
    Add('Col                 '+ IntToStr(Col));
{
    Add('Selection     '+ IntToStr(Selection.Left)+ ' '+ IntToStr(Selection.Top)
          + ' '+ IntToStr(Selection.Right) );
}
  end;
end;

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
    Field: TField; State: TGridDrawState);
var l_rectangle: tRect;
    l_chaine_0: array[0..255] of Char;
begin
  With Rect do
  begin
    dbGrid1.Canvas.Rectangle(Left, Top, Right, Bottom);
    If (Field.FieldName= 'PRENOM')
      then dbGrid1.Canvas.Font.Style:= [fsItalic];
    SetRect(l_rectangle, Left+ 1, Top+ 1, Right- 1, Bottom- 1);
    With dbGrid1.Canvas do
      ExtTextOut(Handle, Left+ 1, Top+ 1, eto_Opaque or eto_clipped, @l_rectangle,
          StrPCopy(l_chaine_0, Field.Text), Length(Field.Text), nil);
  end;


  If (Field.FieldName= 'NOM')
    then
      if Field.AsString >= 'L'
        then begin
            with Rect do
{
              dbGrid1.Canvas.TextOut(Left+ 2, Top+ 2, Field.Text);
}
            dbGrid1.Canvas.Brush.Color:= clRed;
            dbGrid1.Canvas.FrameRect(Rect);
          end;
end;

end.


