(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_ed2 *)

unit U_db_ed2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, ExtCtrls, DBCtrls,
  StdCtrls, Mask, DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    DBEdit1: TDBEdit;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    Table1POIDS: TFloatField;
    Table1NAISSANCE: TDateField;
    Table1GRAND: TBooleanField;
    Button1: TButton;
    Button2: TButton;
    DataSource1: TDataSource;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure justifieClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type t_dbedit= class(tdbEdit)
                 private
                 protected
                   procedure CreateParams(var Params: tCreateParams); Override;
               end;

procedure t_dbedit.CreateParams(var Params: tCreateParams);
  begin
    inherited CreateParams(Params);
    Params.Style:= Params.Style and not es_AutoHScroll or es_MultiLine;
  end; (* CreateParams *)

var g_db_edit: t_dbedit;

procedure TForm1.Button1Click(Sender: TObject);
begin
  g_db_edit:= t_dbedit.Create(Self);

  with g_db_edit do
  begin
    Parent:= Self;
    Left:= Button1.Left+ Button1.Width+ 10; Top:= Button1.Top;
    Width:= 50; Height:= 29+ 29;
    DataSource:= DataSource1;
    DataField:= 'NOM';
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_DC: hDC;
    l_canvas: tControlCanvas;
begin
{
  l_dc:= GetDc(dbEdit1.Handle);
  TextOut(l_dc, 0, 0, 'JOE', 3);
  ReleaseDc(dbEdit1.Handle, l_dc);
}
  l_canvas:= tControlCanvas.Create;
  l_canvas.Control:= dbEdit1;
  l_canvas.TextOut(0, 0, 'JOE');
  l_canvas.Free;
end;

type t_dbedit_justifie= class(tdbEdit)
                          private
                            procedure wmPaint(var Message: twmPaint); message wm_paint;
                        end;

procedure t_dbedit_justifie.wmPaint(var Message: twmPaint);
  var l_canvas: tControlCanvas;
      l_dc: hDC;
      l_info_paint: TPaintStruct;
      l_rectangle: tRect;
      l_texte: String;
      l_largeur, l_debut: Integer;
  begin
    if (Field.Alignment in [taLeftJustify, taRightJustify]) or Focused
      then begin
          inherited;
          Exit;
       end;
    l_canvas := TControlCanvas.Create;
    l_canvas.Control := Self;
    l_dc := Message.DC;
    if l_dc = 0
      then l_dc := BeginPaint(Handle, l_info_paint);
    l_canvas.Handle := l_dc;

    l_canvas.Font := Font;
    with l_canvas do
    begin
      l_rectangle:= ClientRect;
      if BorderStyle = bsSingle
        then begin
            Brush.Color := clWindowFrame;
            FrameRect(l_rectangle);
            InflateRect(l_rectangle, -1, -1);
          end;
      Brush.Color:= Color;

      l_texte:= EditText;
      l_largeur:= TextWidth(l_texte);

      TextRect(l_rectangle, l_rectangle.Right- l_largeur- 3, 2, l_texte);
    end;

    l_canvas.Free;
    if Message.DC = 0
      then EndPaint(Handle, l_info_paint);
  end; (* wmPaint *)

var g_dbedit_justifie: t_dbedit_justifie;

procedure TForm1.justifieClick(Sender: TObject);
begin
  g_dbedit_justifie:= t_dbedit_justifie.Create(Self);

  with g_dbedit_justifie do
  begin
    Parent:= Self;
    Left:= Button2.Left+ Button2.Width+ 10; Top:= Button2.Top;
    DataSource:= DataSource1;
    DataField:= 'NOM';
    Field.Alignment:= taCenter;
  end;
end;

end.


