(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u__champ *)

unit U__champ;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm2 = class(TForm)
    champ: TButton;
    blob: TButton;
    sql_: TButton;
    Query1: TQuery;
    dbf: TButton;
    aff_champ_blob: TButton;
    procedure champClick(Sender: TObject);
    procedure blobClick(Sender: TObject);
    procedure sql_Click(Sender: TObject);
    procedure dbfClick(Sender: TObject);
    procedure aff_champ_blobClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form2: TForm2;

implementation
  uses u_mainte;

{$R *.DFM}

procedure TForm2.champClick(Sender: TObject);
begin
  With Form1 do
  begin
    Table2.Edit;

    Table2.FieldByName('NOM').AsString:= Table1.FieldByName('NOM').AsString;
    (Table2.FieldByName('POIDS') AS tFloatField).Value:= (Table1.FieldByName('POIDS') AS tFloatField).Value;
    Table2.FieldByName('NAISSANCE').Assign( Table1.FieldByName('NAISSANCE') );

    Table2.Post;
  end;
end;

procedure TForm2.blobClick(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  with Form1 do
  begin
{
    l_flux_blob:= tBlobStream.Create(Table1.FieldByName('LE_BLOB') AS tBlobField, bmRead);

    Table2.Edit;
    (Table2.FieldByName('LE_BLOB') AS tBlobField).LoadFromStream(l_flux_blob);
    Table2.Post;

    l_flux_blob.Free;
 }

    (* -- ou Assign *)
    Table2.Edit;
    (Table2.FieldByName('LE_BLOB') AS tBlobField).Assign(Table1.FieldByName('LE_BLOB') AS tBlobField);
    Table2.Post;
  end;
end;

procedure TForm2.sql_Click(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    DataSource:= Form1.DataSource1;
    SQL.Clear;
    SQL.Add('UPDATE "COPIE_2.DBF " ');
    SQL.Add('  SET NOM= :NOM');
    SQL.Add('  WHERE NUMERO= :NUMERO');
    ExecSQL;
  end;
end;

(*$i i_dbf *)

procedure TForm2.dbfClick(Sender: TObject);
type t_array_10= array[0..9] of char;
     t_pt_array_10= ^t_array_10;
var l_pt_dbf_1, l_pt_dbf_2: t_pt_dbf;
    l_pt_champ_1, l_pt_champ_2: Pointer;
begin
  with Form1 do
    Try
      ouvre_dbf('C:\OSCAR\COPIE_1.DBF', l_pt_dbf_1);
      lis_fiche_dbf(l_pt_dbf_1, 0);

      l_pt_champ_1:= f_pt_champ_dbf(l_pt_dbf_1, 1);

      if l_pt_champ_1<> nil
        then affiche(t_pt_array_10(l_pt_champ_1)^+ '<')
        else affiche('pb accs');

      Try
        ouvre_dbf('C:\OSCAR\COPIE_2.DBF', l_pt_dbf_2);
        lis_fiche_dbf(l_pt_dbf_2, 0);

        l_pt_champ_2:= f_pt_champ_dbf(l_pt_dbf_2, 1);
        Move(l_pt_champ_1^, l_pt_champ_2^, l_pt_dbf_1^.descripteurs_zone[1].Taille_zone);

        ecris_fiche_dbf(l_pt_dbf_2, 0);
      Finally
        ferme_dbf(l_pt_dbf_2);
      end;

    Finally
      ferme_dbf(l_pt_dbf_1);
    end;
end;

procedure TForm2.aff_champ_blobClick(Sender: TObject);
type t_array_10= array[0..9] of char;
     t_pt_array_10= ^t_array_10;
var l_pt_dbf: t_pt_dbf;
    l_pt_champ: Pointer;
begin
  Try
    ouvre_dbf('C:\OSCAR\COPIE_2.DBF', l_pt_dbf);
    lis_fiche_dbf(l_pt_dbf, 0);

    l_pt_champ:= f_pt_champ_dbf(l_pt_dbf, 5);
    affiche(t_pt_array_10(l_pt_champ)^+ '<');
   Finally
    ferme_dbf(l_pt_dbf);
  end;
end;

end.

