(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_enreg *)

unit U__enreg;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm3 = class(TForm)
    assign_: TButton;
    dbi_: TButton;
    buffer: TButton;
    dbf: TButton;
    procedure assign_Click(Sender: TObject);
    procedure dbi_Click(Sender: TObject);
    procedure dbfClick(Sender: TObject);
    procedure bufferClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form3: TForm3;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, u_mainte;

{$R *.DFM}

procedure TForm3.assign_Click(Sender: TObject);
var l_indice: Integer;
begin
  with Form1 do
  begin
    Table2.Edit;
    For l_indice:= 0 to Table1.FieldCount- 1 do
      Table2.Fields[l_indice].Assign(Table1.Fields[l_indice]);
    Table2.Post;
  end;
end;

type t_array_60= array[0..60] of char;
     t_pt_array_60= ^t_array_60;

procedure TForm3.bufferClick(Sender: TObject);
var l_pointeur_1, l_pointeur_2: Pointer;
begin
  with Form1 do
  begin
    l_pointeur_1:= Table1.ActiveBuffer;
    l_pointeur_2:= Table2.ActiveBuffer;

    Table2.Edit;
    Move(l_pointeur_1^, l_pointeur_2^, Table1.RecordSize);

    affiche(t_pt_array_60(l_pointeur_2)^+ '<'+ IntToStr(Table1.RecordSize));

{
    Move(l_pointeur_1^, l_pointeur_2^, Table1.RecordSize- 10);
}
    Table2.Post;
    affiche(t_pt_array_60(l_pointeur_2)^+ '<'+ IntToStr(Table1.RecordSize));
  end;
end;

(*$i ..\..\u\f_errdbi *)

procedure TForm3.dbi_Click(Sender: TObject);
var l_dbi: Integer;
    l_pt: Pointer;
begin
  with Form1 do
  begin
{
    Try
      GetMem(l_pt, Table1.RecordSize);

      Table1.UpdateCursorPos;
      l_dbi:= DbiGetRecord(Table1.Handle, dbiNoLock, l_pt, nil);
      affiche(t_pt_array_60(l_pt)^+ '<');
      if l_dbi<> 0
        then affiche('pb get '+ f_erreur_dbi(l_dbi) )
        else begin
            Table2.UpdateCursorPos;
            l_dbi:= DbiModifyRecord(Table2.Handle, l_pt, False);
            if l_dbi<> 0
              then affiche('pb Modify '+ f_erreur_dbi(l_dbi) );
            Table2.Refresh;
          end;
    Finally
      FreeMem(l_pt, Table1.RecordSize);
    end;
}
    Table1.UpdateCursorPos;
    Table2.UpdateCursorPos;
    l_dbi:= DbiModifyRecord(Table2.Handle, Table1.ActiveBuffer, False);
    if l_dbi<> 0
      then affiche('pb Modify '+ f_erreur_dbi(l_dbi) );
    Table2.Refresh;
  end;
end;

(*$i i_dbf *)

procedure TForm3.dbfClick(Sender: TObject);
var l_pt_dbf_1, l_pt_dbf_2: t_pt_dbf;
    l_indice: Integer;
begin
  with Form1 do
  begin
    ouvre_dbf('C:\OSCAR\'+ Table1.TableName, l_pt_dbf_1);
    ouvre_dbf('C:\OSCAR\'+ Table2.TableName, l_pt_dbf_2);

    lis_fiche_dbf(l_pt_dbf_1, 0);
    affiche(t_pt_array_60(l_pt_dbf_1^.pt_fiche)^+ '<');

    Move(l_pt_dbf_1^.pt_fiche^, l_pt_dbf_2^.pt_fiche^, l_pt_dbf_1^.en_tete.taille_fiche);
    affiche(t_pt_array_60(l_pt_dbf_2^.pt_fiche)^+ '<');
    For l_indice:= 0 to 9 do
      pChar(f_pt_champ_dbf(l_pt_dbf_2, 5))[l_indice]:= ' ';

    ecris_fiche_dbf(l_pt_dbf_2, 0);

    ferme_dbf(l_pt_dbf_2);
    ferme_dbf(l_pt_dbf_1);
  end;
end;

end.
