(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_traloc *)

(*$r+*)
unit U_traloc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Table2: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    cree_log: TButton;
    Memo1: TMemo;
    Table_log: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Table_logNUMERO_LOG: TFloatField;
    Table_logNUMERO_TRA: TFloatField;
    Table_logTYPE_TRANS: TStringField;
    initialise: TButton;
    Table_logHEURE: TFloatField;
    Table_logDONNEE: TBlobField;
    cree_table: TButton;
    Table2_aux: TTable;
    immediat: TButton;
    cree_lock: TButton;
    Table_lock: TTable;
    DataSource3: TDataSource;
    DBGrid3: TDBGrid;
    lock: TButton;
    Table_lockNUMERO: TFloatField;
    Table_lockNUMERO_TRA: TFloatField;
    Table_lockCLE: TStringField;
    Table_lockTYPE_LOCK: TStringField;
    twoPL: TButton;
    reserve: TButton;
    Wait_Die: TButton;
    Wait_Wound: TButton;
    sauve: TButton;
    procedure Table2BeforePost(DataSet: TDataset);
    procedure cree_logClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure initialiseClick(Sender: TObject);
    procedure cree_tableClick(Sender: TObject);
    procedure immediatClick(Sender: TObject);
    procedure cree_lockClick(Sender: TObject);
    procedure lockClick(Sender: TObject);
    procedure twoPLClick(Sender: TObject);
    procedure reserveClick(Sender: TObject);
    procedure Wait_DieClick(Sender: TObject);
    procedure Wait_WoundClick(Sender: TObject);
    procedure sauveClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  const vi_numero: Integer= 0;
        vi_PC: Char= 'X';

  procedure affiche(p_texte: String);
    begin
      case vi_PC of
        'A', 'X' : Form1.Memo1.Lines.Add(Format('%3d ', [vi_numero])+ p_texte);
        'B': Form1.Memo1.Lines.Add(Format('%3d       ', [vi_numero])+ p_texte);
      end; (* case *)
      inc(vi_numero)
    end; (* affiche *)

  function f_booleen(p_booleen: Boolean): String;
    begin
      if p_booleen
        then f_booleen:= 'True'
        else f_booleen:= 'False';
    end;

  function f_booleen_TF(p_booleen: Boolean): String;
    begin
      if p_booleen
        then f_booleen_TF:= 'T'
        else f_booleen_TF:= 'F';
    end;

  (* -- transactions *)

procedure TForm1.cree_logClick(Sender: TObject);
begin
  With Table_log do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='LOG.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO_LOG', ftInteger, 0, True);
    FieldDefs.Add('NUMERO_TRA', ftInteger, 0, True);
    FieldDefs.Add('TYPE_TRANS', ftString, 10, True);
    FieldDefs.Add('HEURE', ftInteger, 0, True);
    FieldDefs.Add('DONNEE', ftGraphic, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NUMLOG', 'NUMERO_LOG', []);
    IndexDefs.Add('IND_NUMTRA', 'NUMERO_TRA', []);

    CreateTable;
    Open;
    AppendRecord([0, 0, 'inconnu']);
  end;
end;

procedure TForm1.immediatClick(Sender: TObject);
begin
  If immediat.Caption= 'immediat'
    then immediat.Caption:= 'retarde'
    else immediat.Caption:= 'immediat';
end;

  const vi_transaction: Boolean= True;

  var g_numero_log, g_numero_transaction: Integer;

  procedure initialise_numeros;
    begin
      With Form1 do
      begin
        Table_log.Last;
        g_numero_log:= Table_log.FieldByName('NUMERO_LOG').AsInteger;
        g_numero_transaction:= Table_log.FieldByName('NUMERO_TRA').AsInteger;
      end;
    end;

  procedure entre_start_transaction(var pv_transaction: Integer);
    begin
      with Form1 do
      begin
        Memo1.Lines.Add('');
        affiche('Trans '+ IntToStr(g_numero_transaction+ 1)+ ': Start');

        Table_log.Last;
        g_numero_log:= Table_log.FieldByName('NUMERO_LOG').AsInteger;
        g_numero_transaction:= Table_log.FieldByName('NUMERO_TRA').AsInteger;
        inc(g_numero_log); inc(g_numero_transaction);
        pv_transaction:= g_numero_transaction;

        Table_log.AppendRecord([g_numero_log, g_numero_transaction, 'Start']);
        inc(g_numero_log);
      end;
    end; (* entre_start_transaction *)

  procedure entre_write(p_type_transaction: String; p_table: tTable);
    (* -- stocke entre Write *)
    var l_flux: tBlobStream;
        l_pt: Pointer;
    begin
      with Form1, p_table do
      begin
        affiche('Trans '+ IntToStr(Tag)+ ': '+ p_type_transaction
           + ' '+ FieldByName('NOM').AsString
           + ' '+ FieldByName('MONTANT').AsString);

        Table_log.AppendRecord([g_numero_log, Tag, p_type_transaction]);
        inc(g_numero_log);

        Table_log.Edit;
        l_flux:= tBlobStream.Create(Table_logDONNEE, bmWrite);

        l_pt:= ActiveBuffer;
        l_flux.Write(l_pt^, RecordSize);
 
        l_flux.Free;
        Table_log.Post;
      end;
    end; (* entre_write *)

  const vi_redo: Boolean= False;

  procedure recupere_write(p_table: tTable);
    (* -- relis entre Write *)
    var l_flux: tBlobStream;
        l_pt: Pointer;
    begin
      with Form1, p_table do
      begin
        affiche('  recupere_write');
        l_flux:= tBlobStream.Create(Table_logDONNEE, bmRead);

        (* -- chargement temporaire *)
        Append;

        l_pt:= ActiveBuffer;
        l_flux.Read(l_pt^, RecordSize);
        l_flux.Free;

        (* -- recherche si existe dj *)
        Table2_aux.Open;

        If Table2_aux.FindKey([FieldByName('NOM').AsString])
          then begin
              affiche('  remplace');

              Table2_aux.Edit;
              Move(l_pt^, Table2_aux.ActiveBuffer^, RecordSize);
              (* -- sinon fera Append Append *)
              Cancel;

              Table2_aux.Post;
            end
          else begin
              affiche('  ajoute');

              vi_redo:= True;
              Post;
              vi_redo:= False;
            end;
      end; (* with *)
    end; (* recupere_write *)

  procedure efface_write(p_table: tTable);
    var l_flux: tBlobStream;
        l_cle: String;
        l_pt: Pointer;
    begin
      with Form1, p_table do
      begin
        affiche('  efface_write');
        l_flux:= tBlobStream.Create(Table_logDONNEE, bmRead);

        (* -- chargement temporaire *)
        Append;

        l_pt:= ActiveBuffer;
        l_flux.Read(l_pt^, RecordSize);
        l_flux.Free;

        l_cle:= FieldByName('NOM').AsString;
        Cancel;

        if FindKey([l_cle, l_cle])
          then Delete
          else affiche('  pb: retrouve pas '+ l_cle);
      end; (* with *)
    end; (* efface_write *)

  const vi_panne: Boolean= False;

  function f_redo(p_numero_transaction: Integer): Boolean;
    (* -- recommence les critures *)
    var l_numero_log: Integer;
        l_simule_panne: Integer;
    begin
      with Form1, Table_log do
      begin
        Result:= True;
        Memo1.Lines.Add('');

        IndexName:= 'IND_NUMTRA';
        SetRange([p_numero_transaction], [p_numero_transaction]);
        First;

        l_numero_log:= 0;
        l_simule_panne:= Random(g_numero_transaction* 10);

        While not Eof do
        begin
          if vi_panne and (l_simule_panne= l_numero_log)
            then begin
                affiche('Redo: PANNE');
                CancelRange;
                Result:= False; exit;
              end;

          affiche('Redo '+ Table_logNUMERO_TRA.AsString+ ': '+ Table_logTYPE_TRANS.AsString);

          if (Table_logTYPE_TRANS.AsString= 'Write')
            then recupere_write(Table2);

          Next;
          inc(l_numero_log);
        end; (* while not Eof *)

        CancelRange;
        Table2.Refresh;
      end;
    end; (* f_redo *)

  function f_undo(p_numero_transaction: Integer): Boolean;
    var l_numero_log: Integer;
        l_simule_panne: Integer;
    begin
      with Form1, Table_log do
      begin
        Memo1.Lines.Add('');

        Result:= True;
        IndexName:= 'IND_NUMTRA';
        SetRange([p_numero_transaction], [p_numero_transaction]);
        (* -- dfait depuis la fin *)
        Last;

        l_numero_log:= 0;
        l_simule_panne:= Random(g_numero_transaction* 10);

        While not Bof do
        begin
          if vi_panne and (l_simule_panne= l_numero_log)
            then begin
                affiche('Undo: PANNE');
                CancelRange;
                Result:= False; exit;
              end;

          affiche('Undo: '+ Table_logNUMERO_TRA.AsString+ ' '+ Table_logTYPE_TRANS.AsString);

          if Table_logTYPE_TRANS.AsString= 'Pr'
            then recupere_write(Table2)
            else
              if Table_logTYPE_TRANS.AsString= 'Pr Nil'
                then efface_write(Table2);

          Prior;
          inc(l_numero_log);
        end; (* while not Eof *)

        CancelRange;
        Table2.Refresh;
      end;
    end; (* f_undo *)

  procedure entre_commit(p_transaction: Integer);
    begin
      with Form1 do
      begin
        affiche('Trans '+ IntToStr(p_transaction)+ ': Commit');

        Table_log.AppendRecord([g_numero_log, p_transaction, 'Commit']);
        inc(g_numero_log);

        (* -- maintenant que le log est crit, crit les donnes *)
        if immediat.Caption= 'retarde'
          then f_redo(p_transaction);
      end;
    end; (* entre_commit *)

  procedure entre_rollback(p_transaction: Integer);
    begin
      with Form1 do
      begin
        affiche('Trans: '+ IntToStr(p_transaction)+ ' RollBack');

        Table_log.AppendRecord([g_numero_log, p_transaction, 'RollBack']);
        inc(g_numero_log);
      end;
    end; (* entre_rollback *)

  procedure entre_check_point;
    begin
      with Form1 do
      begin
        affiche('Trans: CheckPoint');

        (* -- purge les tampons mmoire du LOG *)
        (* -- purge les tampons mmoire des tables *)

        Table_log.AppendRecord([g_numero_log, -1, 'CheckPoint']);
        inc(g_numero_log);
      end;
    end; (* entre_check_point *)

  function f_verifie_commit(p_transaction: Integer): Boolean;
    (* -- cherche Commit *)
    begin
      with Form1, Table_log do
      begin
        affiche('  Commit '+ IntToStr(p_transaction)+ ' ?');
        IndexName:= 'IND_NUMTRA';
        SetRange([p_transaction], [p_transaction]);
        First;

        While not Eof do
        begin
          if (Table_logTYPE_TRANS.AsString= 'Commit')
            then begin
                Result:= True;
                CancelRange;
                affiche('    oui');
                exit;
              end
            else Next;
        end; (* while *)

        Result:= False;
        affiche('    non');
        CancelRange;
      end; (* with *)
    end; (* f_verifie_commit *)

  procedure purge_log(p_transaction: Integer);
    begin
      with Form1, Table_log do
      begin
        affiche('Purge '+ IntToStr(p_transaction));

        IndexName:= 'IND_NUMTRA';
        SetRange([p_transaction], [p_transaction]);
        First;

        While not Eof do
          delete;

        CancelRange;
      end; (* with *)
    end; (* purge_log *)

  procedure restart_differe;
    var l_numero_transaction: Integer;
    begin
      For l_numero_transaction:= 1 to g_numero_transaction do
        if f_verifie_commit(l_numero_transaction)
          then begin
              if not f_redo(l_numero_transaction)
                then begin
                    affiche('recommencer Restart');
                    Abort;
                  end
            end
          else purge_log(l_numero_transaction)
    end; (* restart_differe *)

  procedure restart_immediat;
    var l_numero_transaction: Integer;
    begin
      For l_numero_transaction:= 1 to g_numero_transaction do
        if f_verifie_commit(l_numero_transaction)
          then begin
              if not f_redo(l_numero_transaction)
                then begin
                    affiche('recommencer Restart');
                    Abort;
                  end;
            end
          else
            if not f_undo(l_numero_transaction)
              then begin
                  affiche('recommencer Restart');
                  Abort;
                end
    end; (* restart_immediat *)

  (* -- gestion du verrouillage *)

const vi_numero_lock: Integer= 0;

procedure TForm1.cree_lockClick(Sender: TObject);
begin
  With Table_lock do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='LOCK.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger,0, True);
    FieldDefs.Add('NUMERO_TRA', ftInteger,0, True);
    FieldDefs.Add('CLE', ftString, 10, True);
    FieldDefs.Add('TYPE_LOCK', ftString, 1, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_CLE', 'CLE', []);
    CreateTable;

    Open;
    vi_numero_lock:= 0;
{
    AppendRecord([11, 'LUC', ' ']);
}
  end;
end;

  function f_verrouille(p_transaction: Integer; p_cle: String; p_type: Char): Boolean;
    var l_autre_exclusif, l_autre_partage: Boolean;
        l_meme_exclusif, l_meme_partage: Boolean;
    begin
      with Form1 do
      begin
        affiche('verrouille '+ IntToStr(p_transaction)+ ' '+ p_cle+ ' '+ p_type);

        Table_lock.SetRange([p_cle], [p_cle]);
        l_autre_exclusif:= false; l_autre_partage:= false;
        l_meme_exclusif:= false; l_meme_partage:= false;

        while not Table_lock.Eof do
        begin
{
          with Table_lock do
            affiche('While '+ FieldByName('NUMERO_TRA').AsString
                + ' '+ FieldByName('CLE').AsString+ ' '+ FieldByName('TYPE_LOCK').AsString);

}
          if (Table_lock.FieldByName('NUMERO_TRA').AsInteger= p_transaction)
            then begin
                if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'S')
                  then l_meme_partage:= True
                  else
                    if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'X')
                      then l_meme_exclusif:= True
              end
            else
              if (Table_lock.FieldByName('NUMERO_TRA').AsInteger<> p_transaction)
                then
                  if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'S')
                    then l_autre_partage:= True
                    else
                      if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'X')
                        then l_autre_exclusif:= True;
{

          if (Table_lock.FieldByName('NUMERO_TRA').AsInteger= p_transaction)
            then begin
              affiche('m');
              if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'S')
                then l_meme_partage:= True
                else
                  if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'X')
                    then l_meme_exclusif:= True
                    else affiche(Table_lock.FieldByName('TYPE_LOCK').AsString)
              end
            else begin
              affiche('a');
              if (Table_lock.FieldByName('NUMERO_TRA').AsInteger<> p_transaction)
                then
                  if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'S')
                    then l_autre_partage:= True
                    else
                      if (Table_lock.FieldByName('TYPE_LOCK').AsString= 'X')
                        then l_autre_exclusif:= True
                        else affiche(Table_lock.FieldByName('TYPE_LOCK').AsString)
                end;
}
          Table_lock.Next;
        end;
{
        affiche('aS '+ f_booleen_TF(l_autre_partage)+ ', aX '+ f_booleen_TF(l_autre_exclusif)+
          ', mS '+ f_booleen_TF(l_meme_partage)+ ', mX '+ f_booleen_TF(l_meme_exclusif));
}
        Table_lock.CancelRange;

        if l_autre_exclusif or ( l_autre_partage and (p_type= 'X') )
          then Result:= False
          else begin
              Result:= True;

              if   ( l_meme_partage and (p_type= 'S'))
                 or
                   ( l_meme_exclusif and (p_type= 'X') )
                 then (* a dj ce type de verrou *)
                 else
                   if l_meme_partage
                     then begin
                         (* -- transforme en X *)
                         Table_lock.Edit;
                         Table_lock.FieldByName('TYPE_LOCK').AsString:= 'X';
                         Table_lock.Post;
                       end
                     else
                       if l_meme_exclusif
                         then (* -- a un X et a demand un S *)
                         else begin (* -- ajoute un nouveau verrou *)
                             Table_lock.AppendRecord([vi_numero_lock, p_transaction, p_cle, p_type]);
                             inc(vi_numero_lock);
                           end;
            end;

        if not Result
          then affiche('--non');
      end;
    end; (* f_verrouille *)

  procedure deverrouille(p_transaction: Integer; p_cle: String; p_type: Char);
    var l_trouve: Boolean;
    begin
      with Form1 do
      begin
        affiche('dverrouille '+ p_cle);
        Table_lock.SetRange([p_cle], [p_cle]);
        Table_lock.First;

        while not Table_lock.Eof do
        begin
          if  (Table_lock.FieldByName('NUMERO_TRA').AsInteger= p_transaction)
             and
              (Table_lock.FieldByName('TYPE_LOCK').AsString= p_type)
            then begin
                (* -- devrait effacer
                Table_lock.Delete;
                *)
                Table_lock.Edit;
                Table_lock.FieldByName('TYPE_LOCK').AsString:= Chr(Ord(p_type)+ 32);
                Table_lock.Post;
              end;
          Table_lock.Next;
        end; (* while *)

        Table_lock.CancelRange;
      end; (* with *)
    end; (* deverrouille *)

  (* -- lecture et criture dans la Table *)

procedure TForm1.cree_tableClick(Sender: TObject);
begin
  Table2_aux.Close;

  With Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='RESEAU.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('MONTANT', ftFloat, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;

    Open;

    AppendRecord([1, 'ROY', 1000]);
    AppendRecord([2, 'LUC', 300]);
  end;
end;

procedure TForm1.Table2BeforePost(DataSet: TDataset);
var l_cle: String;
begin
  if not vi_transaction
    then exit;

  if not vi_redo
    then begin
        if immediat.Caption= 'retarde'
          then begin
              entre_write('Write', Table2);

              Table2.Cancel;
              Sysutils.Abort;
            end
          else begin
              (* -- la pr-image *)
              if Table2.State= dsInsert
                then begin
                    (* -- nouvel enregistrement: cre une pr-image NIL *)
                    entre_write('Pr Nil', Table2);
                  end
                else begin
                    Table2_aux.Open;
                    l_cle:= Table2.FieldByName('NOM').AsString;
                    if Table2_aux.FindKey([l_cle])
                      then begin
                          Table2_aux.Tag:= Table2.Tag;
                          entre_write('Pr', Table2_aux);
                        end
                      else affiche('pb trouve pas '+ l_cle);
                  end;

              (* -- l'image *)
              entre_write('Write', Table2);
              (* -- et laisse Post crire sur disque *)
            end;
        end;
end; (* TableBeforePost *)

  procedure lis(p_cle: String; var pv_valeur: Double);
    begin
      with Form1 do
        If Table2.FindKey([p_cle])
          then pv_valeur:= Table2.FieldByName('MONTANT').AsFloat
          else ShowMessage('pas cl '+ p_cle);
    end; (* lis *)

  procedure ecris(p_transaction: Integer; p_cle: String; p_valeur: Double);
    begin
      With Form1 do
        If Table2.FindKey([p_cle])
          then begin
              Table2.Edit;
              Table2.FieldByName('MONTANT').AsFloat:= p_valeur;
              Table2.Tag:= p_transaction;

              Try
                Table2.Post;
              except
                on e: eAbort do
              end;
            end
          else ShowMessage('pas cl '+ p_cle);
    end; (* ecris *)

  procedure ajoute(p_transaction: Integer; const pk_valeurs: array of const);
    begin
      Try
        Form1.Table2.AppendRecord(pk_valeurs);
      except
        on e: eAbort do
      end;
    end; (* ajoute *)

procedure TForm1.FormCreate(Sender: TObject);
begin
  Try
    Table_log.Open;
  Except
    cree_logClick(nil);
  end;

  Try
    Table_lock.Open;
  Except
    cree_lockClick(nil);
  end;

  Try
    Table2.Open;
  Except
    cree_tableClick(nil);
  end;

  initialise_numeros;
end;

procedure TForm1.initialiseClick(Sender: TObject);
begin
  affiche('rinitialise tout');
  vi_transaction:= False;

  cree_tableClick(nil);

  cree_logClick(nil);
  initialise_numeros;

  cree_lockClick(nil);

  vi_transaction:= True;
end;

procedure simule(p_type: Char);

    const k_compteur_A_fin= 150;
    var l_compteur_A: Integer;
        l_cle_A_1, l_cle_A_2: String;
        l_montant_A_1, l_montant_A_2: Double;
        l_transaction_A: Integer;

    var l_heure, l_heure_A, l_heure_B: Integer;

    var l_compteur_B: Integer;

    procedure tue_la_jeune;
      begin
        With Form1, Table_lock do
        begin
          if vi_PC= 'A'
            then vi_PC:= 'B'
            else vi_PC:= 'A';
          entre_rollback(FieldByName('NUMERO_TRA').AsInteger);
          deverrouille(FieldByName('NUMERO_TRA').AsInteger,
              FieldByName('CLE').AsString, FieldByName('TYPE_LOCK').AsString[1]);
          if vi_PC= 'A'
            then vi_PC:= 'B'
            else vi_PC:= 'A';
        end;
      end; (* tue_la_jeune *)

    procedure simule_A;
      begin
        vi_pc:= 'A';

        with Form1 do
          case p_type of
            'l' : case l_compteur_A of
                    101 : entre_start_transaction(l_transaction_A);
                    102 : if f_verrouille(l_transaction_A, l_cle_A_1, 'X')
                            then l_compteur_A:= 103- 1
                            else l_compteur_A:= 112- 1;
                    103 : lis(l_cle_A_1, l_montant_A_1);
                    104 : ecris(l_transaction_A, l_cle_A_1, l_montant_A_1- 50);
                    105 : deverrouille(l_transaction_A, l_cle_A_1, 'X');

                    106 : if f_verrouille(l_transaction_A, l_cle_A_2, 'X')
                            then l_compteur_A:= 107- 1
                            else l_compteur_A:= 112- 1;
                    107 : lis(l_cle_A_2, l_montant_A_2);
                    108 : ecris(l_transaction_A, l_cle_A_2, l_montant_A_2+ 50);
                    109 : deverrouille(l_transaction_A, l_cle_A_2, 'X');
                    110 : entre_commit(l_transaction_A);
                    111 : (* End *)
                          l_compteur_A:= k_compteur_A_fin;
                    112 : begin
                            (* RollBack  *);
                            (* -- devrait librer verrous *)
                            entre_rollback(l_transaction_A);
                            l_compteur_A:= 100;
                          end;
                  end;
            '2' : case l_compteur_A of (* -- Two Phase Lock *)
                    101 : entre_start_transaction(l_transaction_A);
                    102 : if f_verrouille(l_transaction_A, l_cle_A_1, 'X')
                            then l_compteur_A:= 103- 1
                            else (* -- reboucle: Wait *)
                                 l_compteur_A:= 102- 1;
                    103 : lis(l_cle_A_1, l_montant_A_1);
                    104 : ecris(l_transaction_A, l_cle_A_1, l_montant_A_1- 50);

                    105 : if f_verrouille(l_transaction_A, l_cle_A_2, 'X')
                            then l_compteur_A:= 106- 1
                            else l_compteur_A:= 105- 1;
                    106 : lis(l_cle_A_2, l_montant_A_2);
                    107 : ecris(l_transaction_A, l_cle_A_2, l_montant_A_2+ 50);

                    108 : entre_commit(l_transaction_A);
                    109 : deverrouille(l_transaction_A, l_cle_A_1, 'X');
                    110 : deverrouille(l_transaction_A, l_cle_A_2, 'X');
                    111 : (* End *)
                          l_compteur_A:= k_compteur_A_fin;
                  end;
            'r' : case l_compteur_A of  (* -- Two Phase Lock, rserve au dbut *)
                    101 : entre_start_transaction(l_transaction_A);
                    102 : if f_verrouille(l_transaction_A, l_cle_A_1, 'X')
                            then l_compteur_A:= 103- 1
                            else l_compteur_A:= 112- 1;
                    103 : if f_verrouille(l_transaction_A, l_cle_A_2, 'X')
                            then l_compteur_A:= 104- 1
                            else l_compteur_A:= 112- 1;

                    104 : lis(l_cle_A_1, l_montant_A_1);
                    105 : ecris(l_transaction_A, l_cle_A_1, l_montant_A_1- 50);

                    106 : lis(l_cle_A_2, l_montant_A_2);
                    107 : ecris(l_transaction_A, l_cle_A_2, l_montant_A_2+ 50);

                    108 : entre_commit(l_transaction_A);
                    109 : deverrouille(l_transaction_A, l_cle_A_1, 'X');
                    110 : deverrouille(l_transaction_A, l_cle_A_2, 'X');
                    111 : (* End *)
                          l_compteur_A:= k_compteur_A_fin;
                    112 : begin
                            entre_rollback(l_transaction_A);
                            deverrouille(l_transaction_A, l_cle_A_1, 'X');
                            l_compteur_A:= 100;
                          end;
                  end; (* case *)
            'd' : case l_compteur_A of  (* -- Two Phase Lock, TimeStamp Preemption: Wait Die *)
                    101 : begin
                            entre_start_transaction(l_transaction_A);
                            if l_heure_A= -1
                              then l_heure_A:= l_heure;
                          end;
                    102 : if f_verrouille(l_transaction_A, l_cle_A_1, 'X')
                            then l_compteur_A:= 103- 1
                            else (* -- ne peut attendre que si TimeStamp < *)
                              if l_heure_A< l_heure_B
                                then begin
                                    l_compteur_A:= 102- 1;
                                    affiche('vieille Wait');
                                  end
                                else begin
                                    l_compteur_A:= 112- 1;
                                    affiche('jeune Die');
                                  end;
                    103 : lis(l_cle_A_1, l_montant_A_1);
                    104 : ecris(l_transaction_A, l_cle_A_1, l_montant_A_1- 50);

                    105 : if f_verrouille(l_transaction_A, l_cle_A_2, 'X')
                            then l_compteur_A:= 106- 1
                            else
                              if l_heure_A< l_heure_B
                                then begin
                                    l_compteur_A:= 105- 1;
                                    affiche('vieille Wait');
                                  end
                                else begin
                                    l_compteur_A:= 112- 1;
                                    affiche('jeune Die');
                                  end;

                    106 : lis(l_cle_A_2, l_montant_A_2);
                    107 : ecris(l_transaction_A, l_cle_A_2, l_montant_A_2+ 50);

                    108 : entre_commit(l_transaction_A);
                    109 : deverrouille(l_transaction_A, l_cle_A_1, 'X');
                    110 : deverrouille(l_transaction_A, l_cle_A_2, 'X');
                    111 : l_compteur_A:= k_compteur_A_fin;

                    112 : begin
                            entre_rollback(l_transaction_A);
                            deverrouille(l_transaction_A, l_cle_A_1, 'X');
                            l_compteur_A:= 100;
                          end;
                  end; (* case *)
            'w' : case l_compteur_A of  (* -- Two Phase Lock, TimeStamp Preemption: Wound Wait *)
                    101 : begin
                            entre_start_transaction(l_transaction_A);
                            if l_heure_A= -1
                              then l_heure_A:= l_heure;
                          end;
                    102 : if f_verrouille(l_transaction_A, l_cle_A_1, 'X')
                            then l_compteur_A:= 103- 1
                            else (* -- ne peut attendre que si TimeStamp > *)
                              if l_heure_A> l_heure_B
                                then begin
                                    l_compteur_A:= 102- 1;
                                    affiche('jeune Wait');
                                  end
                                else begin
                                    affiche('Wound la jeune');
                                    tue_la_jeune;
                                    l_compteur_B:= 201;
                                    if not f_verrouille(l_transaction_A, l_cle_A_1, 'X')
                                      then affiche('pb');
                                  end;
                    103 : lis(l_cle_A_1, l_montant_A_1);
                    104 : ecris(l_transaction_A, l_cle_A_1, l_montant_A_1- 50);

                    105 : if f_verrouille(l_transaction_A, l_cle_A_2, 'X')
                            then l_compteur_A:= 106- 1
                            else
                              if l_heure_A> l_heure_B
                                then begin
                                    l_compteur_A:= 105- 1;
                                    affiche('Wait');
                                  end
                                else begin
                                    affiche('Wound la jeune');
                                    tue_la_jeune;
                                    l_compteur_B:= 201;
                                    if not f_verrouille(l_transaction_A, l_cle_A_2, 'X')
                                      then affiche('pb');
                                  end;

                    106 : lis(l_cle_A_2, l_montant_A_2);
                    107 : ecris(l_transaction_A, l_cle_A_2, l_montant_A_2+ 50);

                    108 : entre_commit(l_transaction_A);
                    109 : deverrouille(l_transaction_A, l_cle_A_1, 'X');
                    110 : deverrouille(l_transaction_A, l_cle_A_2, 'X');
                    111 : l_compteur_A:= k_compteur_A_fin;
                    112 : begin
                            entre_rollback(l_transaction_A);
                            deverrouille(l_transaction_A, l_cle_A_1, 'X');
                            l_compteur_A:= 100;
                          end;
                   end; (* case *)
          end; (* case *)

        inc(l_compteur_A);
      end; (* simule_A *)

    const k_compteur_B_fin= 250;
{
    var l_compteur_B: Integer;
}
    var l_cle_B_1, l_cle_B_2: String;
        l_montant_B_1, l_montant_B_2: Double;
        l_transaction_B: Integer;

    procedure simule_B;

      procedure affiche_total;
        begin
           affiche('LUC+ ROY= '+ FloatToStr(l_montant_B_1+ l_montant_B_2));
           if l_montant_B_1+ l_montant_B_2<> 1300
             then ShowMessage('erreur ');
        end; (* affiche_total *)

      begin (* simule_B *)
        vi_pc:= 'B';

        with Form1 do
          case p_type of
            'l' : case l_compteur_B of
                    201 : entre_start_transaction(l_transaction_B);
                    202 : if f_verrouille(l_transaction_B, l_cle_B_1, 'S')
                            then l_compteur_B:= 203- 1
                            else l_compteur_B:= 211- 1;
                    203 : lis(l_cle_B_1, l_montant_B_1);
                    204 : deverrouille(l_transaction_B, l_cle_B_1, 'S');

                    205 : if f_verrouille(l_transaction_B, l_cle_B_2, 'S')
                            then l_compteur_B:= 206- 1
                            else l_compteur_B:= 211- 1;
                    206 : lis(l_cle_B_2, l_montant_B_2);
                    207 : deverrouille(l_transaction_B, l_cle_B_2, 'S');
                    208 : affiche_total;
                    209 : entre_commit(l_transaction_B);
                    210 : (* fin *)
                          l_compteur_B:= k_compteur_B_fin;
                    211 : begin
                            (* -- devrait librer verrous *)
                            entre_rollback(l_transaction_B);
                            l_compteur_B:= 200;
                          end;
                  end; (* case *)
            '2' : case l_compteur_B of (* -- Two Phase Lock *)
                    201 : entre_start_transaction(l_transaction_B);
                    202 : if f_verrouille(l_transaction_B, l_cle_B_1, 'S')
                            then l_compteur_B:= 203- 1
                            else l_compteur_B:= 202- 1;
                    203 : lis(l_cle_B_1, l_montant_B_1);

                    204 : if f_verrouille(l_transaction_B, l_cle_B_2, 'S')
                            then l_compteur_B:= 205- 1
                            else l_compteur_B:= 204- 1;
                    205 : lis(l_cle_B_2, l_montant_B_2);
                    206 : affiche('A+ B= '+ FloatToStr(l_montant_B_1+ l_montant_B_2));
                    207 : entre_commit(l_transaction_B);
                    208 : deverrouille(l_transaction_B, l_cle_B_1, 'S');
                    209 : deverrouille(l_transaction_B, l_cle_B_2, 'S');
                    210 : (* fin *)
                          l_compteur_B:= k_compteur_B_fin;
                  end; (* case *)
            'r' : case l_compteur_B of (* -- Two Phase Lock - Rserve au dbut *)
                    201 : entre_start_transaction(l_transaction_B);
                    202 : if f_verrouille(l_transaction_B, l_cle_B_1, 'S')
                            then l_compteur_B:= 203- 1
                            else l_compteur_B:= 211- 1;
                    203 : if f_verrouille(l_transaction_B, l_cle_B_2, 'S')
                            then l_compteur_B:= 204- 1
                            else l_compteur_B:= 211- 1;

                    204 : lis(l_cle_B_1, l_montant_B_1);
                    205 : lis(l_cle_B_2, l_montant_B_2);
                    206 : affiche('A+ B= '+ FloatToStr(l_montant_B_1+ l_montant_B_2));
                    207 : entre_commit(l_transaction_B);
                    208 : deverrouille(l_transaction_B, l_cle_B_1, 'S');
                    209 : deverrouille(l_transaction_B, l_cle_B_2, 'S');
                    210 : (* fin *)
                          l_compteur_B:= k_compteur_B_fin;
                    211 : begin
                            entre_rollback(l_transaction_B);
                            deverrouille(l_transaction_B, l_cle_B_1, 'S');
                            l_compteur_B:= 200;
                          end;
                  end; (* case *)
            'd' : case l_compteur_B of (* -- Two Phase Lock - TimeStamp - Wait and Die  *)
                    201 : begin
                            entre_start_transaction(l_transaction_B);
                            if l_heure_B= -1
                              then l_heure_B:= l_heure;
                          end;
                    202 : if f_verrouille(l_transaction_B, l_cle_B_1, 'S')
                            then l_compteur_B:= 203- 1
                            else
                              if l_heure_B< l_heure_A
                                then begin
                                    l_compteur_B:= 202- 1;
                                    affiche('vieille Wait');
                                  end
                                else begin
                                    l_compteur_B:= 211- 1;
                                    affiche('jeune Die');
                                  end;
                    203 : lis(l_cle_B_1, l_montant_B_1);

                    204 : if f_verrouille(l_transaction_B, l_cle_B_2, 'S')
                            then l_compteur_B:= 205- 1
                            else
                              if l_heure_B< l_heure_A
                                then begin
                                    l_compteur_B:= 204- 1;
                                    affiche('vieille Wait');
                                  end
                                else begin
                                    l_compteur_B:= 211- 1;
                                    affiche('jeune Die');
                                  end;
                    205 : lis(l_cle_B_2, l_montant_B_2);
                    206 : affiche('A+ B= '+ FloatToStr(l_montant_B_1+ l_montant_B_2));
                    207 : entre_commit(l_transaction_B);
                    208 : deverrouille(l_transaction_B, l_cle_B_1, 'S');
                    209 : deverrouille(l_transaction_B, l_cle_B_2, 'S');
                    210 : l_compteur_B:= k_compteur_B_fin;
                    211 : begin
                            entre_rollback(l_transaction_B);
                            deverrouille(l_transaction_B, l_cle_B_1, 'S');
                            l_compteur_B:= 200;
                          end;
                  end; (* case *)
            'w' : case l_compteur_B of (* -- Two Phase Lock - TimeStamp - Wound Wait  *)
                    201 : begin
                            entre_start_transaction(l_transaction_B);
                            if l_heure_B= -1
                              then l_heure_B:= l_heure;
                          end;
                    202 : if f_verrouille(l_transaction_B, l_cle_B_1, 'S')
                            then l_compteur_B:= 203- 1
                            else
                              if l_heure_B> l_heure_A
                                then begin
                                    l_compteur_B:= 202- 1;
                                    affiche('jeune Wait');
                                  end
                                else begin
                                    affiche('Wound la jeune');
                                    tue_la_jeune;
                                    l_compteur_A:= 101;
                                    if not f_verrouille(l_transaction_B, l_cle_B_1, 'X')
                                      then affiche('pb');
                                  end;
                    203 : lis(l_cle_B_1, l_montant_B_1);

                    204 : if f_verrouille(l_transaction_B, l_cle_B_2, 'S')
                            then l_compteur_B:= 205- 1
                            else
                              if l_heure_B> l_heure_A
                                then begin
                                    l_compteur_B:= 202- 1;
                                    affiche('jeune Wait');
                                  end
                                else begin
                                    affiche('Wound la jeune');
                                    tue_la_jeune;
                                    l_compteur_A:= 101;
                                    if not f_verrouille(l_transaction_B, l_cle_B_2, 'X')
                                      then affiche('pb');
                                  end;
                    205 : lis(l_cle_B_2, l_montant_B_2);
                    206 : affiche('A+ B= '+ FloatToStr(l_montant_B_1+ l_montant_B_2));
                    207 : entre_commit(l_transaction_B);
                    208 : deverrouille(l_transaction_B, l_cle_B_1, 'S');
                    209 : deverrouille(l_transaction_B, l_cle_B_2, 'S');
                    210 : l_compteur_B:= k_compteur_B_fin;
                    211 : begin
                            entre_rollback(l_transaction_B);
                            deverrouille(l_transaction_B, l_cle_B_1, 'S');
                            l_compteur_B:= 200;
                          end;
                   end; (* case *)
          end; (* case *)

        inc(l_compteur_B);
      end; (* simule_B *)

    begin (* simule *)
      Form1.Memo1.Lines.Clear;
{
      Randomize;
}
      (* -- time out *)
      vi_numero:= 0;
      (* -- nouvelles tables *)
      Form1.initialiseClick(nil);
      vi_panne:= False;
      Form1.Table_lock.IndexName:= 'IND_CLE';

      if random> 0.5
        then begin
            l_cle_A_1:= 'LUC'; l_cle_A_2:= 'ROY';
          end
        else begin
            l_cle_A_1:= 'ROY'; l_cle_A_2:= 'LUC';
          end;

      if random> 0.5
        then begin
            l_cle_B_1:= 'LUC'; l_cle_B_2:= 'ROY';
          end
        else begin
            l_cle_B_1:= 'ROY'; l_cle_B_2:= 'LUC';
          end;

      l_heure:= 0; l_heure_A:= -1; l_heure_B:= -1;

      l_compteur_A:= 101; l_compteur_B:= 201;
      repeat
        inc(l_heure);
        if random> 0.5
          then simule_A
          else simule_B;
      until (l_compteur_A> k_compteur_A_fin) and (l_compteur_B> k_compteur_B_fin)
          or (vi_numero> 100);

      Form1.Table_lock.IndexName:= '';
    end; (* simule *)

procedure TForm1.lockClick(Sender: TObject);
begin
  simule('l');
end;

procedure TForm1.twoPLClick(Sender: TObject);
begin
  simule('2');
end;

procedure TForm1.reserveClick(Sender: TObject);
begin
  simule('r');
end;

procedure TForm1.Wait_DieClick(Sender: TObject);
begin
  simule('d');
end;

procedure TForm1.Wait_WoundClick(Sender: TObject);
begin
  simule('w');
end;

procedure TForm1.sauveClick(Sender: TObject);
begin
  Memo1.Lines.SaveToFile('a:f.pas');
end;

end.

