(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(*  001 u_varmem *)

unit U_varmem;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    confirme: TButton;
    auto: TButton;
    Edit4: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure confirmeClick(Sender: TObject);
    procedure autoClick(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const k_max= 4;
type t_ecriture= record
                   numero, nom, valeur, montant: tEdit;
                 end;
var g_ecriture: array[0..k_max] of t_ecriture;

  procedure initialise ;
    var l_ecriture: Integer;
    begin
      for l_ecriture:= 0 to k_max do
        with g_ecriture[l_ecriture] do
        begin
          numero.Text:= IntToStr(l_ecriture+ 1);
          nom.Text:= '';
          valeur.Text:= '0,00';
          montant.Text:= '0,00';
        end;
    end; (* initialise *)

procedure TForm1.FormCreate(Sender: TObject);
  var l_ecriture: Integer;

  procedure duplique(var pv_destination: tEdit; p_depart: tEdit);
    begin
      pv_destination:= tEdit.Create(self);

      with pv_destination do
      begin
        Parent:= Self; Visible:= True;
        Left:= p_depart.Left; Width:= p_depart.Width;
        Height:= p_depart.Height;
        Top:= p_depart.Top+ p_depart.Height+ k_max;
        TabStop:= p_depart.TabStop;
        Tag:= l_ecriture;
      end;
    end;

begin
  with g_ecriture[0] do
  begin
    numero:= Edit1; nom:= Edit2; valeur:= Edit3; montant:= Edit4;
  end;

  For l_ecriture:= 1 to k_max do
  begin
    duplique(g_ecriture[l_ecriture].numero, g_ecriture[l_ecriture- 1].numero);

    duplique(g_ecriture[l_ecriture].nom, g_ecriture[l_ecriture- 1].nom);
    g_ecriture[l_ecriture].nom.OnExit:= Edit2Exit;

    duplique(g_ecriture[l_ecriture].valeur, g_ecriture[l_ecriture- 1].valeur);
    g_ecriture[l_ecriture].valeur.OnExit:= Edit3Exit;
    duplique(g_ecriture[l_ecriture].montant, g_ecriture[l_ecriture- 1].montant);
  end;

  initialise;
end;

procedure TForm1.Edit2Exit(Sender: TObject);
var l_montant: Double;
begin
  with Sender As tEdit do
    if Text<> ''
      then
        if Table1.FindKey([Text])
          then begin
              l_montant:= Table1.FieldByName('MONTANT').AsFloat;
              g_ecriture[Tag].montant.Text:= FloatToStr(l_montant);
            end
          else begin
              ShowMessage('pas ce nom');
              ActiveControl:= (Sender as tEdit);
            end;
end;

procedure TForm1.Edit3Exit(Sender: TObject);
var l_montant: Double;
begin
  With Sender as tEdit do
    if Table1.FindKey([g_ecriture[Tag].nom.Text])
      then begin
          Try
            l_montant:= StrToFloat(Text);
            l_montant:= Table1.FieldByName('MONTANT').AsFloat+ l_montant;
            g_ecriture[Tag].montant.Text:= FloatToStr(l_montant);
          except
            ShowMessage('pas nombre');
            ActiveControl:= (Sender as tEdit);
          end;
        end
      else begin
          ShowMessage('pas ce nom');
          ActiveControl:= (Sender as tEdit);
        end;
end;

procedure TForm1.autoClick(Sender: TObject);
begin
  with g_ecriture[0] do
  begin
    nom.Text:= 'LUC'; valeur.Text:= 'k_max0'; Edit3Exit(valeur);
  end;
  with g_ecriture[1] do
  begin
    nom.Text:= 'ROY'; valeur.Text:= '-k_max0'; Edit3Exit(valeur);
  end;
end;

procedure TForm1.confirmeClick(Sender: TObject);
var l_ecriture: Integer;
    l_montant: Double;
begin
  l_ecriture:= 0;
  Repeat
    with g_ecriture[l_ecriture] do
      try
        if nom.Text<> ''
          then begin
              l_montant:= StrToFloat(montant.Text);

              if Table1.FindKey([nom.Text])
                then begin
                    Table1.Edit;
                    Table1.FieldByName('MONTANT').AsFloat:= l_montant;
                    Table1.Post;
                  end
                else ShowMessage('pas ce nom');
            end;
      Except
        on e: eConvertError do ShowMessage('pb conversion');
      end;
    inc(l_ecriture);
  until l_ecriture> k_max;

  initialise;
end;

end.
