(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 ud_affta *)

unit Ud_affta;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

  function f_peut_utiliser_dll: String; export;
  function f_affiche_table(Const p_nom_table: String): String; export;
  procedure quitte_dll; export;

implementation

{$R *.DFM}

  var g_poignee_tache: tHandle;
      g_est_dechargee: Boolean;

  function f_peut_utiliser_dll: String;
    begin
      ShowMessage('vrifie tche');
      if g_poignee_tache<> GetCurrentTask
        then Result:= 'DLL est utilise par une autre appli'
        else
          if g_est_dechargee
             then Result:= 'la DLL doit tre dcharge avant de pouvoir tre rutilise'
             else Result:= '';
    end; (* utilise_dll *)

  function f_affiche_table(Const p_nom_table: String): String;
    begin
      if Form1= NIL
        then begin
            ShowMessage('cree Forme');
            Form1:= tForm1.Create(nil);
          end
        else ShowMessage('Ok: Forme dj cre');

      (* -- affiche TOUJOURS de faon modale *)
      Form1.Show;

      TRY
        with Form1, Table1 do
        begin
          Close;
          DatabaseName:= 'Flix';
          TableName:= p_nom_table;
          Open;
          Result:= '';
        end;
      except
        Result:= 'pb dans ouverture / affichage';
      end;
    end; (* f_affiche_table *)

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Table1.Close;
end;

  procedure quitte_dll;
    begin
      ShowMessage('CallExitProcs');
      CallExitProcs;
      g_est_dechargee:= True;
    end; (* quitte_dll *)

begin (* initialise *)
  g_poignee_tache:= GetCurrentTask;
  g_est_dechargee:= False;
end.

