(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_graphe *)

unit U_graphe;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, StdCtrls, VBXCtrl, Chart2fx, Grids, DBGrids;

type
  TForm1 = class(TForm)
    ChartFX1: TChartFX;
    change_type: TButton;
    cree_table: TButton;
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    procedure cree_tableClick(Sender: TObject);
    procedure change_typeClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses ChartFX;

{$R *.DFM}

procedure TForm1.cree_tableClick(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='GRAPHE.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('MONTANT', ftFloat, 0, True);

    CreateTable;

    Open;

    AppendRecord([1, 'BELIN', 100]);
    AppendRecord([2, 'MARTIN', 300]);
    AppendRecord([3, 'SIRE', 200]);
  end;
end;

procedure TForm1.change_typeClick(Sender: TObject);
const vi_type: Integer= 0;
var l_indice: integer;
begin
  Screen.Cursor := CrHourGlass;
  Table1.Open;
  Table1.First;

  with ChartFX1 do
  begin
    Visible := false;

    ChartType := vi_type+ 1;
    Label1.Caption:= 'Type: '+ IntToStr(vi_type);
    vi_type:= (vi_type+ 1) mod 7;

    OpenData[COD_VALUES] := MakeLong(1, Table1.RecordCount);
    ThisSerie := 0;

    l_indice := 0;

    while not Table1.Eof do
    begin
      Value[l_indice]:= Table1.FieldbyName('MONTANT').AsFloat;
      Legend[l_indice]:= Table1.FieldByname('NOM').AsString;

      inc(l_indice);
      Table1.Next;
    end;

    CloseData[COD_VALUES] := 0;
    LegendWidth := 150;
    Title[CHART_TOPFT] := 'Titre';
    Visible := true;
  end; (* with ChartFX1 *)

  Screen.Cursor := CrDefault;
end;

end.
