(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_addali *)
(* 23 aou 95 *)

(*$r+*)
unit U_addali;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    AddAlias_: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure AddAlias_Click(Sender: TObject);
  private
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, dbConsts (* , u_excdbi *);

{$R *.DFM}

(* $i ..\u\i_e_dbi1 *)

function f_verifie_dbi(p_valeur: Integer): Boolean;
  var l_chaine_z: array[0..DbiMaxMsgLen] of char;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);

          ShowMessage('erreur Dbi: '+ IntToStr(p_valeur)+ ' '+ StrPas(l_chaine_z));
        end;

    f_verifie_dbi:= p_valeur= 0;
  end; (* f_verifie_dbi *)

procedure TForm1.AddAlias_Click(Sender: TObject);
var l_nom_alias, l_repertoire: String;
begin
  l_nom_alias:= Edit1.Text+ chr(0);
  l_repertoire:= 'PATH:'+ Edit2.text+ chr(0);
  AnsiToOem(@l_nom_alias[1], @l_nom_alias[1]);

  Edit3.Text:= l_nom_alias;

  f_verifie_dbi(DbiAddAlias(nil, @l_nom_alias[1], nil, @l_repertoire[1], True));
end;

end.




