(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_creicd *)

unit U_creicd;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Database1: TDatabase;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiProcs, DbiTypes, DbiErrs;

{$R *.DFM}

(*$i ..\..\u\i_e_dbi1 *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix';

    TableName:= 'CREE_CON';
    TableType:= ttdBase;

    FieldDefs.Clear;

    FieldDefs.Add('NUMERO', ftSmallInt, 0, True);
    FieldDefs.Add('CLIENT', ftString, 10, True);
    FieldDefs.Add('SOLDE', ftFloat, 0, True);

    IndexDefs.Clear;
    CreateTable;

    Open;

    AppendRecord([1, 'Joe', 3.14]);
    AppendRecord([2, 'Sam', 3.14]);
    AppendRecord([1, 'Gus', 3.14]);
    AppendRecord([4, 'Joe', 3.14]);
    Close;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_nom_table_z: String;
    l_nom_pilote_z: String;

    l_descripteur_index: IdxDesc;
begin
  FillChar(l_descripteur_index, SizeOf(l_descripteur_index), 0);

  with l_descripteur_index do
  begin
{
    (* -- index normal *)
    StrPCopy(@szTagName, 'IND_NORM');
    bPrimary:= False;
    bUnique:= False;
    bDescending:= False;
    (* -- si False: provoque erreur 'accs' ! *)
    bMaintained:= True;
    bSubSet:= False;
    bExpIdx:= False;
    iFldsInKey:= 1;
    (* -- le PREMIER champ*)
    aiKeyFld[0]:= 1;
    bCaseInsensitive:= False;
}
{
    (* --index expression *)
    StrPCopy(@szTagName, 'IND_EXPR');
    bPrimary:= False;
    bUnique:= False;
    bDescending:= False;
    (* -- si False: provoque erreur 'accs' ! *)
    bMaintained:= True;
    bSubSet:= False;

    bExpIdx:= True;
    StrPCopy(@szKeyExp, 'CLIENT+ STR(NUMERO)');

    bCaseInsensitive:= False;
}
    (* --index expression *)
    StrPCopy(@szTagName, 'IND_COND');
    bPrimary:= False;
    bUnique:= False;
    bDescending:= False;
    (* -- si False: provoque erreur 'accs' ! *)
    bMaintained:= True;

    bSubSet:= True;
    bExpIdx:= False;
    iFldsInKey:= 1;
    (*  OK
    StrPCopy(@szKeyCond, 'NUMERO= 1');
    StrPCopy(@szKeyCond, 'CLIENT= "Joe"');
    StrPCopy(@szKeyCond, 'LEFT(CLIENT, 1)>= "J"');
    StrPCopy(@szKeyCond, 'LEFT(CLIENT, 1)>= "J" .OR. LEFT(CLIENT, 1)= "S"');
    StrPCopy(@szKeyCond, 'LEFT(CLIENT, 1)>= "J" .OR. NUMERO= 1');
    *)
    StrPCopy(@szKeyCond, 'LEFT(CLIENT, 1)>= "J" .AND. NUMERO= 1');

    aiKeyFld[0]:= 1;

    bCaseInsensitive:= False;
  end;

  f_verifie_dbi(DbiAddIndex(
        (* DOIT tre Connected *)
        Database1.Handle,

        nil,
        StrPCopy(@l_nom_table_z, 'CREE_CON'),
        StrPCopy(@l_nom_pilote_z, 'DBASE'),

        l_descripteur_index,
        ''
        ) );
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix';

    TableName:= 'CREE_CON';
    TableType:= ttdBase;
{
    IndexName:= 'IND_NORM';
    IndexName:= 'IND_EXPR';
}
    IndexName:= 'IND_COND';
    Open;
  end;
end;

end.
