(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_credb2 *)
(* 30 aou 95 *)

(*$r+*)
unit U_credb2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Database1: TDatabase;
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiProcs, DbiTypes, DbiErrs;

{$R *.DFM}

  (* $i ..\u\i_e_dbi1 *)

function f_verifie_dbi(p_valeur: Integer): Boolean;
  var l_chaine_z: array[0..DbiMaxMsgLen] of char;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);
          ShowMessage('erreur Dbi: '+ IntToStr(p_valeur div 256)+ ' '+ + IntToStr(p_valeur mod 256)+ ' '+ StrPas(l_chaine_z));
        end;

    f_verifie_dbi:= p_valeur= 0;
  end; (* f_verifie_dbi *)

procedure TForm1.Button1Click(Sender: TObject);
const k_field_max= 3;
var l_descripteur: CrTblDesc;
    l_descripteurs_colonnes: array[1..k_field_max] of FldDesc;
begin
  FillChar(l_descripteur, SizeOf(l_descripteur), 0);

  FillChar(l_descripteurs_colonnes, SizeOf(l_descripteurs_colonnes), 0);
  with l_descripteurs_colonnes[1] do
  begin
    iFldNum:= 1;
    StrPCopy(@szName, 'NOM');
    iFldType:= FldDbChar;
    iUnits1:= 5;
  end;
  with l_descripteurs_colonnes[2] do
  begin
    iFldNum:= 2;
    StrPCopy(@szName, 'AGE');
    iFldType:= FldDbNum;
    iUnits1:= 2;
    iUnits2:= 0;
  end;
  with l_descripteurs_colonnes[3] do
  begin
    iFldNum:= 3;
    StrPCopy(@szName, 'HAUTEUR');
    iFldType:= FldDbFloat;
    iUnits1:= 5;
    iUnits2:= 1;
  end;

  With l_descripteur do
  begin
    StrPCopy(@szTblName, 'C:\OSCAR\CREE_DBI.DBF');
    StrPCopy(@szTblType, 'DBASE');

    iFldCount:= k_field_max;
    pFldDesc:= @l_descripteurs_colonnes;

    iIdxCount:= 0;
    pIdxDesc:= Nil;
  end;

  f_verifie_dbi(DbiCreateTable(Database1.Handle, True, l_descripteur));
end;

end.



