(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_credel *)

unit U_credel;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    Table2: TTable;
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiErrs;

{$R *.DFM}

(*$i ..\..\u\f_errdbi *)

procedure TForm1.Button1Click(Sender: TObject);
var l_erreur: String;
begin
{
  IF FileExists('C:\OSCAR\CREE_DEL.DBF')
    THEN
      IF MessageDlg('CREE_DEL.DBF Existe. Continuer ?', mtConfirmation, [mbYes, mbNo], 0)<> mrYes
        then exit;
}
  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix';

    TableName:= 'CREE_DEL';
    TableType:= ttdBase;

    TRY
      FieldDefs.Clear;

      FieldDefs.Add('NUMERO', ftSmallInt, 0, True);
      FieldDefs.Add('CLIENT', ftString, 10, True);
      FieldDefs.Add('SOLDE', ftFloat, 0, True);

      CreateTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            DbiErr_InvalidFieldName : l_erreur:= 'nom zone incorrect';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END;
  end;
end;

end.
