(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_balaye *)

unit U_balaye;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Edit2: TEdit;
    Button3: TButton;
    procedure First_Click(Sender: TObject);
    procedure Prior_Click(Sender: TObject);
    procedure Next_Click(Sender: TObject);
    procedure Last_Click(Sender: TObject);
    procedure moveby3Click(Sender: TObject);
    procedure un_indexClick(Sender: TObject);
    procedure ind_exprClick(Sender: TObject);
    procedure Open_Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-dclarations }
    procedure affiche_bof_eof;
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tForm1.affiche_bof_eof;
  begin
    If Table1.Bof
      then Edit1.Text:= 'BOF '
      else Edit1.Text:= '';

    If Table1.Eof
      then Edit1.Text:= Edit1.Text+ 'EOF';
  end;

procedure TForm1.Open_Click(Sender: TObject);
begin
  Table1.Active:= Not Table1.Active;
  affiche_bof_eof;
end;

procedure TForm1.First_Click(Sender: TObject);
begin
  Table1.First;
  affiche_bof_eof;
end;

procedure TForm1.Prior_Click(Sender: TObject);
begin
  Table1.Prior;
  affiche_bof_eof;
end;

procedure TForm1.Next_Click(Sender: TObject);
begin
  Table1.Next;
{
  Table1.Append;
}
  affiche_bof_eof;
end;

procedure TForm1.Last_Click(Sender: TObject);
begin
  Table1.Last;
  affiche_bof_eof;
end;

procedure TForm1.moveby3Click(Sender: TObject);
begin
  Table1.MoveBy(3);
  affiche_bof_eof;
end;

procedure TForm1.un_indexClick(Sender: TObject);
begin
  Table1.IndexName:= 'IND_NOM';
  Table1.Open;
end;

procedure TForm1.ind_exprClick(Sender: TObject);
begin
  Table1.IndexName:= 'IND_NOMPRE';
{
  Table1.IndexFieldNames:= 'NOM;PRENOM';
}
end;

procedure TForm1.Button1Click(Sender: TObject);
var l_nombre: Integer;
begin
  Table1.First;
  l_nombre:= 0;
  WHILE not Table1.Eof Do
  begin
    l_nombre:= l_nombre+ 1;
    Table1.Next;
  end;
  Edit1.Text:= IntToStr(l_nombre);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Table1.First;
  WHILE (Table1.FieldByName('NOM').AsString<> Edit2.Text) and not Table1.Eof Do
    Table1.Next;
  If Table1.Eof
    Then Edit2.Text:= Edit2.Text+ ' pas trouv';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Table1.Next;
  WHILE (Table1.FieldByName('NOM').AsString<> Edit2.Text) and not Table1.Eof Do
    Table1.Next;
  If Table1.Eof
    Then Edit2.Text:= Edit2.Text+ ' pas trouv';
end;

end.
