(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_navigue *)

unit U_navigu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    First_: TButton;
    Prior_: TButton;
    Next_: TButton;
    Last_: TButton;
    Edit1: TEdit;
    moveby3: TButton;
    un_index: TButton;
    ind_expr: TButton;
    Open_: TButton;
    procedure First_Click(Sender: TObject);
    procedure Prior_Click(Sender: TObject);
    procedure Next_Click(Sender: TObject);
    procedure Last_Click(Sender: TObject);
    procedure moveby3Click(Sender: TObject);
    procedure un_indexClick(Sender: TObject);
    procedure ind_exprClick(Sender: TObject);
    procedure Open_Click(Sender: TObject);
  private
    { Private-dclarations }
    procedure affiche_bof_eof;
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tForm1.affiche_bof_eof;
  begin
    If Table1.Bof
      then Edit1.Text:= 'BOF '
      else Edit1.Text:= '';

    If Table1.Eof
      then Edit1.Text:= Edit1.Text+ 'EOF';
  end;

procedure TForm1.Open_Click(Sender: TObject);
begin
  Table1.Active:= Not Table1.Active;
  affiche_bof_eof;
end;

procedure TForm1.First_Click(Sender: TObject);
begin
  Table1.First;
  affiche_bof_eof;
end;

procedure TForm1.Prior_Click(Sender: TObject);
begin
  Table1.Prior;
  affiche_bof_eof;
end;

procedure TForm1.Next_Click(Sender: TObject);
begin
  Table1.Next;
{
  Table1.Append;
}
  affiche_bof_eof;
end;

procedure TForm1.Last_Click(Sender: TObject);
begin
  Table1.Last;
  affiche_bof_eof;
end;

procedure TForm1.moveby3Click(Sender: TObject);
begin
  Table1.MoveBy(3);
  affiche_bof_eof;
end;

procedure TForm1.un_indexClick(Sender: TObject);
begin
  Table1.IndexName:= 'IND_NOM';
  Table1.Open;
end;

procedure TForm1.ind_exprClick(Sender: TObject);
begin
  Table1.IndexName:= 'IND_NOMPRE';
{
  Table1.IndexFieldNames:= 'NOM;PRENOM';
}
end;

end.
