(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)

(* 001 u_gotoke *)
(* 21 nov 95 *)

(* -- suivant, prcdent, compte *)

(*$r+*)
unit U_bookma;
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    compte: TButton;
    GetB_: TButton;
    chge_ind: TButton;
    GotoB_: TButton;
    compte_b: TButton;
    procedure compteClick(Sender: TObject);
    procedure GetB_Click(Sender: TObject);
    procedure chge_indClick(Sender: TObject);
    procedure GotoB_Click(Sender: TObject);
    procedure compte_bClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)
  var l_erreur: String;


{$R *.DFM}

procedure TForm1.compteClick(Sender: TObject);
var l_nombre: Integer;
begin
  If Table1.IndexFieldCount= 0
    then Table1.IndexName:= 'IND_NOM';

  Table1.SetKey;
  Table1.Fields[1].AsString:= Edit1.Text;
  Table1.GotoKey;
  l_nombre:= 0;

  While Not Table1.Eof and (Table1.Fields[1].AsString= Edit1.Text) do
  begin
    inc(l_nombre);
    Table1.Next;
  end;

  compte.Caption:= 'compte '+ IntToStr(l_nombre);
end;

procedure TForm1.compte_bClick(Sender: TObject);
var l_signet: tBookMark;
begin
  Table1.DisableControls;
  Table1.IndexName:= 'IND_NOM';
  l_signet:= Table1.GetBookMark;

  compteClick(Nil);

  Table1.GotoBookMark(l_signet);
  Table1.FreeBookMark(l_signet);

  Table1.IndexName:= '';
  Table1.EnableControls;
end;

const gi_signet: tBookMark= Nil;

procedure TForm1.GetB_Click(Sender: TObject);
begin
  gi_signet:= Table1.GetBookMark;
end;

procedure TForm1.chge_indClick(Sender: TObject);
begin
  With Table1 do
  begin
    If IndexName= 'IND_NOM'
      Then IndexName:= ''
      Else IndexName:= 'IND_NOM';
  end;
end;

procedure TForm1.GotoB_Click(Sender: TObject);
begin
  Try
    Table1.GotoBookMark(gi_signet);

  EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)

end;

end.
