(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_findke *)

(* FindKey *)

unit U_findke;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)
  var l_erreur: String;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Table1.IndexName:= 'IND_NOM';
  Table1.FindKey([Edit1.Text]);
{
  Table1.FindKey([Edit1.Text+ 'I']);
  TRY
    Table1.FindKey([51,3]);
  EXCEPT
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
      begin
        case ErrorCode OF
          DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
          else l_erreur:= '?? '+ e.Message;
        end;
        ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
      end;
    ON e: eDatabaseError DO
      ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
}
end;

end.
