(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_gotoin *)
(* 21 nov 95 *)

unit U_gotoin;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBEdit1: TDBEdit;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    Button1: TButton;
    procedure Edit1Change(Sender: TObject);
    procedure DBEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='CHERCIN';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;

    Open;

    AppendRecord([1, 'A']);
    AppendRecord([2, 'B']);
    AppendRecord([3, 'C']);
    AppendRecord([4, 'CA']);
    AppendRecord([4, 'CABC']);
    AppendRecord([4, 'CABDEFG']);
    AppendRecord([5, 'CB']);
    AppendRecord([6, 'D']);
    Open;
  end; (* with Table *)
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  Table1.SetKey;
  Table1.Fields[1].AsString:= Edit1.Text;
  Table1.GotoNearest;
end;

procedure TForm1.DBEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var l_texte: String;
    l_indice: Integer;

procedure cherche;
  begin
    Table1.SetKey;
    Table1.Fields[1].AsString:= l_texte;
    Table1.GotoNearest;

    dbEdit1.SelStart:= l_indice;
    Key:= 0;
  end; (* cherche *)

begin (* dbEdit1KeyDown *)
  Case KEY OF
    ORD('A')..Ord('Z'):
      begin
        dbEdit1.ClearSelection;

        l_texte:= dbEdit1.Text;
        l_indice:= dbEdit1.SelStart;

        Delete(l_texte, l_indice+ 1, Length(l_texte)- l_indice);
        l_texte := l_texte+ chr(Key);
        inc(l_indice);

        cherche;
      end;
    vk_Left, vk_Back :
      begin
        l_texte:= dbEdit1.Text;
        l_indice:= dbEdit1.SelStart;

        if l_indice> 0
          then begin
              Dec(l_indice);
              Delete(l_texte, l_indice+ 1, Length(l_texte)- l_indice);

              cherche;
            end;
      end;
    vk_Delete :
      begin
        l_texte:= dbEdit1.Text;
        l_indice:= dbEdit1.SelStart;

        Delete(l_texte, l_indice+ 1, Length(l_texte)- l_indice);

        cherche;
      end;
    vk_Shift, vk_Tab, vk_Return, vk_Menu : ;
    else Key:= 0;
  end; (* case *)
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  With ComboBox1 do
  begin
    Clear;
    Table1.First;
    While Not Table1.Eof DO
    begin
      Items.Add(Table1.Fields[1].AsString);
      Table1.Next;
    end;
  end;                                        
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  Table1.SetKey;
  Table1.Fields[1].AsString:= ComboBox1.Text;
  Table1.GotoNearest;
end;

end.
