(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_gotokc *)
(* 21 nov 95 *)

unit U_gotoma;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Table2: TTable;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

(*$i ..\..\u\f_errdbi *)
var l_erreur: String;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Table1.Close;
  Try
    Table1.AddIndex('IND_PREMAJ', 'UPPER(PRENOM)', [ixExpression]);
  except
  end;

  Table1.Open;
  Table1.IndexName:= 'IND_PREMAJ';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Table1.SetKey;
  Table1.Fields[2].AsString:= UpperCase(Edit1.Text);
  Table1.GotoKey;
end;

const valeur= 65+ 26;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Table1.Close;
  try
    Table1.DeleteIndex('IND_NOMINV');
  except
  end;

  Table1.AddIndex('IND_NOMINV', 'SUBSTR(TRIM(NOM), LEN(TRIM(NOM)), 1)+ SUBSTR(TRIM(NOM), LEN(TRIM(NOM))- 1, 1) '
      + ' +SUBSTR(TRIM(NOM), LEN(TRIM(NOM))- 2, 1)',
      [ixExpression]);

  Table1.Open;
  Table1.IndexName:= 'IND_NOMINV';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Table1.Open;
  Table1.IndexName:= 'IND_NOMINV';

  Table1.SetKey;
  Table1.Fields[1].AsString:= Edit1.Text;
  Table1.GotoNearest;
end;

procedure TForm1.Button5Click(Sender: TObject);
(* recherche le dernier *)
begin
  Table1.Open;
  Table1.IndexName:= 'IND_NOM';

  Table1.SetKey;
  Table1.Fields[1].AsString:= Edit1.Text;
  Table1.GotoNearest;

  if Table1.Fields[1].AsString= Edit1.Text
    then begin
        While Not Table1.Eof and (Table1.Fields[1].AsString= Edit1.Text) do
           Table1.Next;
        if Table1.Fields[1].AsString<> Edit1.Text
          then Table1.Prior;
      end;
end;

  function f_valeur_existe(p_valeur: String): Boolean;
    begin
      with Form1.Table2 do
      begin
        DatabaseName:= 'Flix';
        TableType:= ttdBase;
        TableName:= 'CHERCHE';
        IndexName:= 'IND_NOM';
        Open;

        SetKey;
        Fields[1].AsString:= p_valeur;
        Result:= GotoKey;

        Close;
      end;
    end; (* f_valeur_existe *)

procedure TForm1.Button6Click(Sender: TObject);
begin
  if f_valeur_existe(Edit1.Text)
    then Button6.Caption:= 'Existe'
    else Button6.Caption:= 'Existe Pas';
end;

end.

