(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_gotone *)

unit U_gotone;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    nearest: TButton;
    Edit1: TEdit;
    suivant: TButton;
    Button3: TButton;
    procedure nearestClick(Sender: TObject);
    procedure suivantClick(Sender: TObject);
    procedure NOT_KeyExclusiveClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

  (*$i ..\..\u\f_errdbi *)
  var l_erreur: String;


procedure TForm1.nearestClick(Sender: TObject);
begin
  Table1.SetKey;

  Table1.Fields[1].AsString:= Edit1.Text;

  Table1.GotoNearest;
{
  Table1.Fields[1].AsString:= Edit1.Text;
  Table1.Fields[3].AsString:= '51,3';
}
    TRY
{
      Table1.Fields[4].AsDateTime:= (* StrToDate(); *) 12.34;
      Button1.Caption:= FloatToStr(StrToDate('1/1/95'));
      Table1.FindKey(['MARTIN', 'Jean']);
}

    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* TRY *)
end;

procedure TForm1.suivantClick(Sender: TObject);
begin
  if Table1.Fields[1].AsString= Edit1.Text
    then begin
         Table1.Next;
         if Table1.Fields[1].AsString<> Edit1.Text
           then Table1.Prior;
       end;
end;

procedure TForm1.NOT_KeyExclusiveClick(Sender: TObject);
begin
  Table1.SetKey;

  Table1.KeyExclusive:= True;

  Table1.Fields[1].AsString:= Edit1.Text;
  Table1.GotoNearest;
end;

end.


