(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_filtre *)
(* 03 nov 95 *)

unit U_filtr3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ListBox1: TListBox;
    cree_tampon: TButton;
    Button3: TButton;
    indexe: TButton;
    Button1: TButton;
    procedure cree_tamponClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure indexeClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

  var g_tampon: array[0..1000] of Byte;
      g_offset: Word;

  procedure cree_le_tampon;
    var l_tampon_litteraux: array[0..1000] of Byte;
        l_offset_litteral: Word;
        l_nombre_noeuds: Word;

    function f_pt(p_offset: Word): Pointer;
      begin
        f_pt:= @g_tampon[p_offset];
      end; (* f_pt *)

    procedure ajoute_litteral(p_litteral: String);
      begin
        move(p_litteral[1], l_tampon_litteraux[l_offset_litteral], Length(p_litteral));
        inc(l_offset_litteral, Length(p_litteral)+ 1);
        l_tampon_litteraux[l_offset_litteral- 1]:= 0;
      end; (* ajoute_litteral *)

    procedure ajoute_litteral_divers(var pv_litteral; p_taille: Word);
      begin
        move(pv_litteral, l_tampon_litteraux[l_offset_litteral], p_taille);
        inc(l_offset_litteral, p_taille);
      end; (* ajoute_litteral *)

    function f_pt_ajoute_compare(p_egal: CanOp; p_majuscule: Bool; p_partiel: Word; var pv_offset: Word): pCanCompare;
      begin
        with pCanCompare(f_pt(g_offset))^ do
        begin
          (* -- la position du dbut du noeud *)
          pv_offset:= g_offset- SizeOf(CanExpr);

          NodeClass:= NodeCompare;
          CanOp:= p_egal;
          bCaseInsensitive:= p_majuscule;
          iPartialLen:= p_partiel;

          (* -- retourne l'adresse pour pouvoir remplir les offset des deux oprandes *)
          f_pt_ajoute_compare:= pCanCompare(f_pt(g_offset));

          g_offset:= g_offset+ SizeOf(CanCompare);
          inc(l_nombre_noeuds);
        end;
      end; (* ajoute_compare *)

    function f_pt_ajoute_logique(p_logique: CanOp; var pv_offset: Word): pCanBinary;
      begin
        with pCanCompare(f_pt(g_offset))^ do
        begin
          pv_offset:= g_offset- SizeOf(CanExpr);

          NodeClass:= NodeBinary;
          CanOp:= p_logique;

          f_pt_ajoute_logique:= pCanBinary(f_pt(g_offset));

          g_offset:= g_offset+ SizeOf(CanBinary);
          inc(l_nombre_noeuds);
        end;
      end; (* ajoute_compare *)

    procedure ajoute_champ(p_operation: CanOp; p_numero: Word; p_litteral: String; var pv_offset: Word);
      begin
        with pCanField(f_pt(g_offset))^ do
        begin
          pv_offset:= g_offset- SizeOf(CanExpr);

          NodeClass:= NodeField;
          CanOp:= p_operation;
          iFieldNum:= p_numero;
          iNameOffset:= l_offset_litteral;

          ajoute_litteral(p_litteral);

          g_offset:= g_offset+ SizeOf(CanField);
          inc(l_nombre_noeuds);
        end;
      end; (* ajoute_champ *)

    procedure ajoute_constante(p_operation: CanOp; p_type, p_taille: Word; p_constante: Pointer; var pv_offset: Word);
      begin
        with pCanConst(f_pt(g_offset))^ do
        begin
          pv_offset:= g_offset- SizeOf(CanExpr);

          NodeClass:= NodeConst;
          CanOp:= p_operation;
          iType:= p_type;
          iSize:= p_taille;
          iOffset:= l_offset_litteral;

          ajoute_litteral_divers(p_constante^, p_taille);

          g_offset:= g_offset+ SizeOf(CanConst);
          inc(l_nombre_noeuds);
        end;
      end; (* ajoute_constante *)

    var l_tampon_z: String;

    begin (* cree_le_tampon *)
      g_offset:= 0;

      with pCanExpr(f_pt(g_offset))^ do
      begin
        iVer:= 2;

        (* -- le premier neud est aprs l'en-tte *)
        g_offset:= SizeOf(CanExpr);
        l_nombre_noeuds:= 0;
        l_offset_litteral:= 0;

        with f_pt_ajoute_compare(CanEq, True, 1, iNodeStart)^ do
        begin
          ajoute_champ(CanField2, 1, 'NOM', iOperand1);
          ajoute_constante(CanConst2, fldZString, Length('MART')+ 1, StrPCopy(@l_tampon_z, 'MART'), iOperand2);
        end;
  {

        with f_pt_ajoute_logique(CanOR, iNodeStart)^ do
        begin
          with f_pt_ajoute_compare(CanEq, True, 1, iOperand1)^ do
          begin
            ajoute_champ(CanField2, 1, 'NOM', iOperand1);
            ajoute_constante(CanConst2, fldZString, Length('MAR')+ 1, StrPCopy(@l_tampon_z, 'MAR'), iOperand2);
          end;
          with f_pt_ajoute_compare(CanEq, True, 1, iOperand2)^ do
          begin
            ajoute_champ(CanField2, 2, 'PRENOM', iOperand1);
            ajoute_constante(CanConst2, fldZString, Length('Syl')+ 1, StrPCopy(@l_tampon_z, 'Syl'), iOperand2);
          end;
        end;
  }
        iNodeStart:= iNodeStart+ SizeOf(CanExpr);
        iNodes:= l_nombre_noeuds;

        iLiteralStart:= g_offset;

        (* -- transfre les constantes aprs les noeuds *)
        Move(l_tampon_litteraux, g_tampon[g_offset], l_offset_litteral);
        g_offset:= g_offset+ l_offset_litteral;

        iTotalSize:= g_offset;
      end; (* with "CanExpr" *)
    end; (* cree_le_tampon *)

  procedure affiche(p_chaines: tStrings);
    var l_indice: Integer;
        l_chaine: String;
    begin
      l_chaine:= '';

      for l_indice:= 0 to g_offset- 1 do
      begin
        l_chaine:= l_chaine+ IntToHex(g_tampon[l_indice], 2)+ ' ';
        if (l_indice+ 1) mod 8 = 0
          then begin
               p_chaines.Add(l_chaine);
               l_chaine:= '';
            end;
      end;
      p_chaines.Add(l_chaine);
    end; (* affiche *)

  function f_verifie(p_valeur: Integer): Boolean;
    var l_chaine_z: String;
    begin
      if p_valeur<> 0
        then begin
            DbiGetErrorString(p_valeur, @l_chaine_z);
            ShowMessage('Erreur '+ StrPas(@l_chaine_z));
          end;
      f_verifie:= p_valeur= 0;
    end; (* f_verifie *)

(* -- utilisateur *)

procedure TForm1.cree_tamponClick(Sender: TObject);
  begin
    cree_le_tampon;
  end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ListBox1.Clear;
  affiche(ListBox1.Items);
  ListBox1.Items.SaveToFile('RESU.PAS');
end;

procedure TForm1.Button3Click(Sender: TObject);
var l_poignee_filtre: hDbiFilter;
begin
{
  Table1.Close;
  Table1.DatabaseName:= 'Flix';
  Table1.TableType:= ttdBase;
  Table1.TableName:= 'CHERCHE';
  Table1.Open;
}
  Table1.First;
  if f_verifie(DbiAddFilter(Table1.Handle, 0, 1, False, @g_tampon, nil, l_poignee_filtre))
    then begin
        MessageBeep(0);
        f_verifie(DbiActivateFilter(Table1.Handle, l_poignee_filtre));
{
        f_verifie(DbiSetToBegin(Table1.Handle));
}
        Table1.First;
        Table1.Refresh;
      end;
end;

procedure TForm1.indexeClick(Sender: TObject);
begin
  Table1.IndexName:= 'IND_PRENOM';
end;

end.

