unit U_filtr4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button2: TButton;
    Edit1: TEdit;
    Button1: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, ufiltre;

{$R *.DFM}

function f_verifie(p_valeur: Integer): Boolean;
  var l_chaine_z: String;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);
          ShowMessage('Erreur '+ StrPas(@l_chaine_z));
        end;
    f_verifie:= p_valeur= 0;
  end; (* f_verifie *)

{
const vi_expression: String= ' NOM = ''MARTIN'' ';
}
const vi_poignee_filtre: hDbiFilter= NIL;

procedure TForm1.Button1Click(Sender: TObject);
begin
  (* -- opration non applicable *)
  Edit1.Text:= 'NUMERO= 2';

  (* -- opration non applicable *)
  Edit1.Text:= 'POIDS= 60';

  (* -- analyseur: erreur expression *)
  Edit1.Text:= 'POIDS= 51.3';

  ajoute_filtre(Table1, Edit1.Text, vi_poignee_filtre);
  f_verifie(DbiActivateFilter(Table1.Handle, vi_poignee_filtre));
  Table1.First;
  Table1.Refresh;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
{
  Table1.First;
}
  f_verifie(DbiDeActivateFilter(Table1.Handle, vi_poignee_filtre));
  f_verifie(DbiDropFilter(Table1.Handle, vi_poignee_filtre));
  Table1.Refresh;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Table1.IndexName:= 'IND_PRENOM';
end;

end.


