(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_sqlpar *)

unit U_sqlpar;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Query1: TQuery;
    DBGrid2: TDBGrid;
    Button2: TButton;
    Edit1: TEdit;
    Button1: TButton;
    Button5: TButton;
    ListBox1: TListBox;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  WITH Query1 DO
  begin
    Close;
    DatabaseName:= 'Flix';
    Sql.Clear;

    (* PARAM *)
    (* OK *)
    Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF"');
    SQL.Add('  WHERE NOM = :riri ');
{
    Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF"');
    SQL.Add('  WHERE NUMERO = :riri ');
    (* NOK *)
    Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF"');
    SQL.Add('  WHERE NOM = %:riri% ');
    (* NOK *)
    Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF"');
    SQL.Add('  ORDER BY = :riri ');
}
{
    (* NOK *)
    Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF"');
    SQL.Add('  ORDER BY = :riri ');
}
{
    Prepare;
}
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
{
    (* OK *)
    Params[0].AsString:= Edit1.Text;
    (* OK *)
    ParamByName('riri').AsString:= Edit1.Text;
}

    (* OK *)
    TRY

      ParamByName('riri').AsString:= Edit1.Text;
{
      ShowMessage(IntToStr(Params.Count));
}
      Open;
    except
      on e: eDbEngineError do
        with eDbEngineError(e), Errors[ErrorCount- 1] do
          ShowMessage('Dbi '+ IntToHex(ErrorCode, 4)+ ' '+ e.Message);
      on e: eDatabaseError do
        ShowMessage('DB '+ e.Message);
      else
        ShowMessage('autre ');
    end;

{
    Open;
}
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var l_indice: Integer;
begin
  with ListBox1 Do
  begin
    Clear;
    Items.Add(IntToStr(Query1.Params.Count));

    for l_indice:= 0 to Query1.Params.Count- 1 do
      with Query1.Params[l_indice] do
        Items.Add(IntToStr(l_indice)+ ' '+ Name);
  end;
end;

end.



