(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajomod *)

unit U_ajomod;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Button6: TButton;
    Button7: TButton;
    Edit2: TEdit;
    Button8: TButton;
    Button9: TButton;
    Insert_: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure DataSource1StateChange(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
  Table1.Edit;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Table1.Fields[1].AsString:= Edit1.Text;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Table1.Cancel;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Table1.Post;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Table1.Append;
end;

    function f_mode(p_etat: tDataSetState): String;
      begin
        case p_etat of
          dsInactive : Result:= 'dsInactive';

          dsBrowse : Result:= 'dsBrowse';

          dsEdit : Result:= 'dsEdit';
          dsInsert : Result:= 'dsInsert';

          dsSetKey : Result:= 'dsSetKey';

          dsCalcFields : Result:= 'dsCalcFields';
          else Result:= '??';
        end; (* case *)
      end;

procedure TForm1.DataSource1StateChange(Sender: TObject);
begin
  Edit2.Text:= f_mode(DataSource1.State);
  if DataSource1.State in [dsEdit, dsInsert]
    then Form1.Color:= clRed
    else Form1.Color:= clWhite;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Table1.Open;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Table1.Close;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  Table1.SetKey;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  Table1.SetRangeStart;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  Table1.FindKey(['Imprimante']);
end;

end.


