(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajoca3 *)

unit U_ajoca3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1LIBELLE: TStringField;
    Table1QUANTITE: TFloatField;
    DataSource1: TDataSource;
    Table1POURCENT: TFloatField;
    Edit1: TEdit;
    procedure Table1CalcFields(DataSet: TDataset);
    procedure Table1AfterOpen(DataSet: TDataset);
    procedure Table1QUANTITESetText(Sender: TField; const Text: String);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const vi_a_calcule_cumul: Boolean= False;
      vi_a_calcule_valeur_initiale: Boolean= False;
var g_cumul: Double;
    g_quantite_precedente: Integer;

procedure TForm1.Table1AfterOpen(DataSet: TDataset);
begin
  with Table1 do
  begin
{
    OnCalcFields:= NIL;
}

    First;
    g_cumul:= 0;

    while not EOF do
    begin
  {
      (* -- a dbranch CalcFields: peut pas avoir PRIX_TOTAL ! *)
      g_cumul:= g_cumul+ Table1.FieldByName('PRIX_TOTAL').AsFloat;
  }
      g_cumul:= g_cumul+ FieldByName('QUANTITE').AsFloat;
      Table1.Next;
    end;

    Edit1.Text:= FloatToStr(g_cumul);

    vi_a_calcule_cumul:= True;
{
    OnCalcFields:= Table1CalcFields;
}
    First;
    Refresh;
  end;
end;

procedure TForm1.Table1QUANTITESetText(Sender: TField; const Text: String);
begin
  g_quantite_precedente:= Table1QUANTITE.AsInteger;
  Table1QUANTITE.AsString:= Text;
  vi_a_calcule_valeur_initiale:= True;
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
begin
  if vi_a_calcule_cumul
    then begin
        if vi_a_calcule_valeur_initiale
          then begin
             g_cumul:= g_cumul+ (Table1QUANTITE.AsInteger- g_quantite_precedente);
             vi_a_calcule_valeur_initiale:= False;
             Edit1.Text:= FloatToStr(g_cumul);
           end;
        Table1POURCENT.AsFloat:= Int(Table1QUANTITE.AsFloat / g_cumul* 1000)/ 10 ;
      end;
end;

end.


