(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_aff_ev *)

unit U_aff_ev;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm2 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form2: TForm2;

const vi_action: String= '';
procedure affiche(p_texte, p_suite: String);

implementation
  uses u_eveajo;

{$R *.DFM}

    function f_mode(p_etat: tDataSetState): String;
      begin
        case p_etat of
          dsInactive : Result:= 'dsInactive';

          dsBrowse : Result:= 'dsBrowse';

          dsEdit : Result:= 'dsEdit';
          dsInsert : Result:= 'dsInsert';

          dsSetKey : Result:= 'dsSetKey';

          dsCalcFields : Result:= 'dsCalcFields';
          else Result:= '??';
        end; (* case *)
      end;

const vi_entier: Integer= 0;

procedure affiche(p_texte, p_suite: String);
  begin
    Form2.Memo1.Lines.Add(Format('%3d %-12s %-10s %-23s %s',
        [vi_entier, vi_action, f_mode(Form1.Table1.State), p_texte, p_suite]) );

    inc(vi_entier);
  end; (* affiche *)

procedure TForm2.Button1Click(Sender: TObject);
const vi_nom: Char= 'A';
begin
  Memo1.Lines.SaveToFile(vi_nom+ '.PAS');
  vi_nom:= succ(vi_nom);
  Close;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Memo1.Clear;
  vi_entier:= 0;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  Form1.Show;
end;

end.
