(* 001 f_courant *)
(* 17 jan 96 *)

  function f_courant(p_table: tTable): LongInt;
    var CursorProps: CurProps;
        RecordProps: RECProps;
    begin
      with p_table do
      begin
        if not active
          then begin
              Result:= $7FFFFFFF;
              Result:= 99;
            end
          else begin
             (* -- 0 si pas Paradox ou dBase *)
             Result := 0;

             (* --  ferm. Peut pas arriver ici *)
             if State = dsInactive
               then DBError(SDataSetClosed);

             (* -- rcupre iSeqNums du Curseur *)
             if DbiGetCursorProps(Handle, CursorProps)<> 0
               then Result:= 97
               else begin
                   (* -- met  jour Delphi *)
                   UpdateCursorPos;

                   (* -- rcupre la proprit de l'enregistrement *)
                   if DbiGetRecord(Handle, dbiNOLOCK, nil, @RecordProps)= 0
                     then
                       case CursorProps.iSeqNums of
                         0: Result := RecordProps.iPhyRecNum;  { dBASE   }
                         1: Result := RecordProps.iSeqNum;     { Paradox }
                       end (* case *)
                     else Result:= 98;
                 end;
           end;
      end; (* with p_table *)
    end; (* f_courant *)

(* -- fin f_courant *)

