(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_cle_un *)

unit U_cle_un;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    Table1F_NUMERO: TFloatField;
    Table1F_CLIENT: TStringField;
    Table1F_TOTAL: TFloatField;
    procedure Table1F_NUMEROValidate(Sender: TField);
    procedure Table1BeforeEdit(DataSet: TDataset);
    procedure Table1NewRecord(DataSet: TDataset);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

  {$R *.DFM}

function f_cle_existe(p_valeur: Integer): Boolean;
  begin
    with Form1, Table2 do
      f_cle_existe:= FindKey([p_valeur]);
  end; (* f_nouvelle_cle *)

const vi_cle: Integer= 0;

procedure TForm1.Table1BeforeEdit(DataSet: TDataset);
begin
  MessageBeep(0);
  vi_cle:= Table1F_NUMERO.AsInteger;
end;

procedure TForm1.Table1F_NUMEROValidate(Sender: TField);
begin
  If f_cle_existe(Table1F_NUMERO.AsInteger)
      and (Table1F_NUMERO.AsInteger<> vi_cle)
    then begin
        ShowMessage('La cl '+ Table1F_NUMERO.AsString+ ' existe dj');
        Abort;
      end;
end;

procedure TForm1.Table1NewRecord(DataSet: TDataset);
begin
  vi_cle:= -1;
end;

end.
