(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_md_ef2 *)

(*$r+*)
unit U_md_ef2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Button1: TButton;
    Table1F_NUMERO: TFloatField;
    Table1F_CLIENT: TStringField;
    Table1F_TOTAL: TFloatField;
    Table2I_NUM_FACT: TFloatField;
    Table2I_NUMERO: TFloatField;
    Table2I_LIBELLE: TStringField;
    Table2I_PRIX: TFloatField;
    Table2I_QUANTITE: TFloatField;
    Table3: TTable;
    procedure Button1Click(Sender: TObject);
    procedure Table1BeforeDelete(DataSet: TDataset);
    procedure Table1F_NUMEROValidate(Sender: TField);
    procedure Table1F_NUMEROSetText(Sender: TField; const Text: String);
    procedure Table1BeforePost(DataSet: TDataset);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
{
  (* -- pour bloquer *)
  Table1.Edit;
  Table1.Post;
}
  Table1.Delete;
end;

procedure TForm1.Table1BeforeDelete(DataSet: TDataset);
begin
  With Table2 do
  begin
    DisableControls;

    First;
    WHILE not Eof Do
      Delete;

    EnableControls;
  end;
end;

procedure TForm1.Table1F_NUMEROValidate(Sender: TField);
begin
  exit;

  if Table3.FindKey([Table1F_NUMERO.AsString])
    then begin
        Table1.Cancel;
        Abort;
      end
    else begin
        With Table2 do
        begin
          DisableControls;

          First;
          WHILE not Eof Do
          begin
            Edit;
            Table2I_NUM_FACT.AsInteger:= Table1F_NUMERO.AsInteger;
            Post;
          end;

          EnableControls;
        end;
      end;
end;

procedure TForm1.Table1F_NUMEROSetText(Sender: TField; const Text: String);
begin
  Table1F_NUMERO.AsString:= Text;
  exit;

  if Table3.FindKey([Text])
    then begin
        Table1.Cancel;
        ShowMessage('Dj '+ Text);
        Abort;
      end
    else begin
        With Table2 do
        begin
          ShowMessage('OK');
          DisableControls;

          First;
          WHILE not Eof Do
          begin
            Edit;
            Table2I_NUM_FACT.AsString:= Text;
            Post;
          end;

          EnableControls;
        end;

        Table1F_NUMERO.AsString:= Text;
        Table1.Post;
      end;
end;

procedure TForm1.Table1BeforePost(DataSet: TDataset);
begin
  exit;

  if Table3.FindKey([Table1F_NUMERO.AsString])
    then begin
        Table1.Cancel;
        ShowMessage('Dj '+ Text);
        Abort;
      end
    else begin
        With Table2 do
        begin
          DisableControls;

          First;
          WHILE not Eof Do
          begin
            Edit;
            Table2I_NUM_FACT.AsInteger:= Table1F_NUMERO.AsInteger;
            Post;
          end;

          EnableControls;
        end;
      end;
end;

end.


