(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)

(* 001 u_md_mod *)

(*$r+*)
unit U_md_mod;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Table1F_NUMERO: TFloatField;
    Table1F_CLIENT: TStringField;
    Table1F_TOTAL: TFloatField;
    Table2I_NUM_FACT: TFloatField;
    Table2I_NUMERO: TFloatField;
    Table2I_LIBELLE: TStringField;
    Table2I_PRIX: TFloatField;
    Table2I_QUANTITE: TFloatField;
    Table3: TTable;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    procedure Table1F_NUMEROValidate(Sender: TField);
    procedure Table1BeforeEdit(DataSet: TDataset);
    procedure Button1Click(Sender: TObject);
    procedure Table1BeforePost(DataSet: TDataset);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  exit;

  if Table1.FindKey([StrToInt(Edit1.Text)])
    then begin
        With Table2 do
        begin
          DisableControls;

          First;
          WHILE not Eof Do
          begin
            Edit;
            Table2I_NUM_FACT.AsString:= Edit2.Text;

            Post;
          end; (* while *)

          EnableControls;
        end; (* with Table2 *)

        Table1.Edit;
        Table1F_NUMERO.AsString:= Edit2.Text;
        Table1.Post;
      end;
end;

function f_cle_existe(p_cle: Integer): Boolean;
  begin
    With Form1 do
      f_cle_existe:= Table3.FindKey([Table1F_NUMERO.AsString])
  end; (* f_cle_existe *)

const vi_cle_avant_edit: Integer= 0;

procedure TForm1.Table1BeforeEdit(DataSet: TDataset);
begin
  vi_cle_avant_edit:= Table1F_NUMERO.AsInteger;
end;

procedure TForm1.Table1BeforePost(DataSet: TDataset);
begin
  exit;

  if f_cle_existe(Table1F_NUMERO.AsInteger)
    then begin
        Table1.Cancel;
        ShowMessage('Dj '+ Text);
        Abort;
      end
    else begin
        With Table2 do
        begin
          DisableControls;

          SetRange([vi_cle_avant_edit], [vi_cle_avant_edit]);

          First;
          WHILE not Eof Do
          begin
            Edit;
            Table2I_NUM_FACT.AsInteger:= Table1F_NUMERO.AsInteger;
            Post;
          end;

          EnableControls;
        end;
      end;
end;

procedure TForm1.Table1F_NUMEROValidate(Sender: TField);
begin
  case Table1.State of
    dsEdit : begin
               if f_cle_existe(Table1F_NUMERO.AsInteger)
                 then begin
                     if Table1F_NUMERO.AsInteger<> vi_cle_avant_edit
                       then begin
                           ShowMessage('Dj '+ Table1F_NUMERO.AsString);
                           Table2.SetRange([vi_cle_avant_edit], [vi_cle_avant_edit]);
                           Abort;
                         end;
                   end
                 else begin
                     With Table2 do
                     begin
                       DisableControls;

                       First;
                       WHILE not Eof Do
                       begin
                         Edit;
                         Table2I_NUM_FACT.AsInteger:= Table1F_NUMERO.AsInteger;
                         Post;
                       end;

                       EnableControls;
                     end; (* with Table2 *)
                   end;
             end;
    dsInsert : Begin
                 if f_cle_existe(Table1F_NUMERO.AsInteger)
                   then begin
                       ShowMessage('Dj '+ Table1F_NUMERO.AsString);
                       Abort;
                     end;
               end;
  end; (* case *)
end;

end.


