(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_dbgloc *)

unit U_dbgloc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, DBLookup;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1I_NUM_FACT: TFloatField;
    Table1I_CODE: TFloatField;
    Table1I_PRIX: TFloatField;
    Table1I_QUANTITE: TFloatField;
    Table2: TTable;
    ComboBox1: TComboBox;
    Table3: TTable;
    Table1_description: TStringField;
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure DBGrid1ColExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Exit(Sender: TObject);
    procedure Table1CalcFields(DataSet: TDataset);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  With Table2, ComboBox1 do
  begin
    Items.Clear;
    Sorted:= True;

    First;
    While not Eof do
    begin
      Items.add(FieldByName('A_DESCRIPT').AsString);
      Next;
    end;
  end;

end;

const vi_nom_champ= 'I_CODE';

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
var l_indice: Integer;
    l_texte: String;
begin
  If (Field.FieldName = vi_nom_champ) and (gdFocused in State)
    then begin
        ComboBox1.Left := Rect.Left + DBGrid1.Left + 2;
        ComboBox1.Top := Rect.Top + DBGrid1.top + 2;
        ComboBox1.Width := Rect.Right - Rect.Left - 2;
        ComboBox1.Height := Rect.Bottom - Rect.Top - 1;

        If Table2.FindKey([Table1I_CODE.AsInteger])
          then begin
              l_texte:= Table2.FieldByName('A_DESCRIPT').AsString;
              l_indice:= ComboBox1.Items.IndexOf(l_texte);
              ComboBox1.ItemIndex:= l_indice;
            end;

        ComboBox1.Visible:= True;
      end;
end;

procedure TForm1.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if (key <> chr(9))
      and (dbGrid1.SelectedField.FieldName = vi_nom_champ)
    then begin
        ComboBox1.SetFocus;
        (* -- le premier caractre de slection est envoy au combo *)
        SendMessage(ComboBox1.Handle, WM_Char, Ord(Key), 0);
      end
end;

procedure TForm1.ComboBox1Exit(Sender: TObject);
var l_code: Integer;
begin
  If Table3.FindKey([ComboBox1.Items[ComboBox1.ItemIndex]])
    then begin
         l_code:= Table3.FieldByName('A_CODE').AsInteger;
         if Table1I_CODE.AsInteger<> l_code
           then begin
                Table1.Edit;
                Table1I_CODE.AsInteger:= l_code;
                Table1.Post;
              end;
      end;

  dbGrid1.SetFocus;
  SendMessage(dbGrid1.Handle, WM_KeyDown, vk_Tab, 0);
end;

procedure TForm1.DBGrid1ColExit(Sender: TObject);
begin
  If dbGrid1.SelectedField.FieldName = vi_nom_champ
    then ComboBox1.Visible:= False;
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
begin
  If Table2.FindKey([Table1I_CODE.AsInteger])
    then Table1_description.AsString:= Table2.FieldByName('A_DESCRIPT').AsString;
end;

end.


