(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_grafie *)

unit U_grafie;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, ExtCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Table1B_NUMERO: TFloatField;
    Table1B_GRAPHIC: TBlobField;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBImage1: TDBImage;
    GraphicField_LfF: TButton;
    GraphicField_Assign: TButton;
    dbImage_PfC: TButton;
    Image1: TImage;
    GraphicField_StF: TButton;
    Bitmap_Assign: TButton;
    bit_StS_BlobStr: TButton;
    ListBox1: TListBox;
    bit_LfS_BlobStr: TButton;
    Image2: TImage;
    dbImage_CtC: TButton;
    Button1: TButton;
    procedure GraphicField_LfFClick(Sender: TObject);
    procedure GraphicField_AssignClick(Sender: TObject);
    procedure dbImage_PfCClick(Sender: TObject);
    procedure GraphicField_StFClick(Sender: TObject);
    procedure Bitmap_AssignClick(Sender: TObject);
    procedure bit_StS_BlobStrClick(Sender: TObject);
    procedure bit_LfS_BlobStrClick(Sender: TObject);
    procedure dbImage_CtCClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses ClipBrd;

{$R *.DFM}

(* -- BlobStream *)

procedure TForm1.bit_StS_BlobStrClick(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_bitmap: tBitMap;
    l_flux_memoire: tMemoryStream;
begin
  Table1.Edit;
  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmWrite);
{
  (* OK *)
  Image1.Picture.BitMap.SaveToStream(l_flux_blob);
}

  l_flux_memoire:= tMemoryStream.Create;
  Image1.Picture.BitMap.SaveToStream(l_flux_memoire);
  ListBox1.Items.Add(IntToStr(l_flux_memoire.Size));
{

  (* NON OK, car dbute aux champs objet *)
  l_flux_blob.Write(l_bitmap, l_flux_memoire.Size);
}
  l_flux_memoire.SaveToStream(l_flux_blob);

  l_flux_memoire.Free;

  l_flux_blob.Free;
  Table1.Post;
end;

procedure TForm1.bit_LfS_BlobStrClick(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  l_flux_blob:= tBlobStream.Create(Table1B_GRAPHIC, bmRead);
  Image2.Picture.Bitmap.LoadFromStream(l_flux_blob);
  l_flux_blob.Free;
end;

(* -- GraphicField *)

procedure TForm1.GraphicField_LfFClick(Sender: TObject);
begin
  Table1.Edit;
  Table1B_GRAPHIC.LoadFromFile('C:\Delphi\demos\data\cus1.Bmp');
  Table1.Post;
end;

procedure TForm1.GraphicField_StFClick(Sender: TObject);
begin
  Table1B_GRAPHIC.SaveToFile('resu.Bmp');
end;

procedure TForm1.GraphicField_AssignClick(Sender: TObject);
var l_bitmap: tBitmap;
begin
  l_bitmap:= tBitmap.Create;
  l_bitmap.LoadFromFile('C:\Delphi\demos\data\cus2.Bmp');

  Table1.Edit;
{
  Table1B_GRAPHIC.Assign(l_bitmap);
}
  (* ou : *)
  Table1B_GRAPHIC.Assign(Image1.Picture);

  Table1.Post;

  l_bitmap.Free;
end;

procedure TForm1.Bitmap_AssignClick(Sender: TObject);
begin
  Image2.Picture.Assign(Table1B_GRAPHIC);

  (* -- ou stocke dans une BitMap *)
end;

(* -- dbImage *)

procedure TForm1.dbImage_PfCClick(Sender: TObject);
var l_bitmap: tBitmap;
begin

  (* -- mettre quelque chose dans le presse papier *)
  l_bitmap:= tBitmap.Create;
  l_bitmap.LoadFromFile('C:\Delphi\demos\data\cus3.Bmp');

  Image1.Picture.Bitmap.Assign(l_bitmap);


{
  (* -- ne marche pas *)
  ClipBoard.Clear;
  ClipBoard.Assign(Image1.Picture.Bitmap);
}

{
  (* -- compile pas *)
  Image1.Picture.Bitmap.CopyToClipBoard;
  Image1.Picture.CopyToClipBoard;
  Image1.CopyToClipBoard;
}

{
  Image2.Picture.Bitmap.Assign(ClipBoard);
  l_bitmap.Free;
}

  (* -- taper Alt-Impr-cran *)

  (* -- si AutoEdit pas ncessaire *)
  Table1.Edit;

  dbImage1.PasteFromClipboard;

  Table1.Post;
end;

procedure TForm1.dbImage_CtCClick(Sender: TObject);
begin
{
  (* OK *)
  dbImage1.CopyToClipBoard;
}
  (* OK *)
  ClipBoard.Assign(dbImage1.Picture.BitMap);
end;

procedure TForm1.Button1Click(Sender: TObject);
var l_presse_papier: tClipBoard;
begin
  l_presse_papier:= tClipBoard.Create;
  if l_presse_papier.HasFormat(cf_BitMap)
    then ListBox1.Items.Add('cf_bitmap');
  if l_presse_papier.HasFormat(cf_Palette)
    then ListBox1.Items.Add('cf_palette');
  l_presse_papier.Free ;
end;

end.
