(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_flusq2 *)

unit U_flusq2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, DBCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Query1: TQuery;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    ouvre: TButton;
    lis: TButton;
    ecris: TButton;
    procedure ouvreClick(Sender: TObject);
    procedure lisClick(Sender: TObject);
    procedure ecrisClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ouvreClick(Sender: TObject);
begin
  With Query1, SQL do
  begin
    Close;
    DatabaseName:= 'Flix';
    Clear;

    Add('SELECT * FROM "LES_BLOB.DBF"');
    Open;
  end;
end;

procedure TForm1.lisClick(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  l_flux_blob:= tBlobStream.Create(Query1.FieldByName('B_GRAPHIC') As tBlobField, bmRead);
  ListBox1.Items.LoadFromStream(l_flux_blob);
  l_flux_blob.Free;
end;

procedure TForm1.ecrisClick(Sender: TObject);
var l_flux_blob: tBlobStream;
    l_texte: String;
begin
  Query1.Edit;
  l_flux_blob:= tBlobStream.Create(Query1.FieldByName('B_GRAPHIC') As tBlobField, bmWrite);

  l_texte:= 'ccc'+ chr(13)+ chr(10);
  l_flux_blob.Write(l_texte[1], Length(l_texte));

  l_flux_blob.Free;
  Query1.Post;
end;

end.

