(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_pillan *)

unit U_pillan;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var l_nom_pilote, l_nom_table: String;
    l_nom_langage: String;
    l_fichier: File;
    l_octet: Byte;
    l_poignee: Integer;
begin
  with ListBox1.Items do
  begin
    Table1.Open;
    l_nom_pilote:= 'DBASE'+ chr(0);
    l_nom_langage:= 'zzz'+ chr(0);

    (* -- rien
    l_nom_table:= 'C:\OASCAR\CHAINE.DBF'+ chr(0);
    l_nom_table:= 'CHAINE'+ chr(0);

    DbiGetLdName(@l_nom_pilote[1], @l_nom_table[1], @l_nom_langage[1]);
    *)
    DbiGetLdName(@l_nom_pilote[1], nil, @l_nom_langage[1]);
    ListBox1.Items.Add(StrPas(@l_nom_langage[1]));


    DbiGetLdNameFromDb(Table1.Database.Handle, nil, @l_nom_langage[1]);
    ListBox1.Items.Add(StrPas(@l_nom_langage[1]));
{
    (* NIL pour pilote ? *)
    DbiGetLdNameFromDb(Table1.Database.Handle, @l_nom_pilote[1], @l_nom_langage[1]);
    ListBox1.Items.Add(StrPas(@l_nom_langage[1]));

    (* -- err DOS -5  *)
    l_poignee:= FileOpen('c:\OSCAR\CHAINE.DBF', fmOpenRead);
}
    l_poignee:= FileOpen('c:\OSCAR\CHAINE.DBF', fmOpenRead+ fmShareDenyNone);
    if l_poignee<= 0
      then ShowMessage('pb Open '+ IntToStr(l_poignee));
    if FileSeek(l_poignee, 29, 0)<> 29
      then ShowMessage('pb Seek');

    FileRead(l_poignee, l_octet, 1);
    FileClose(l_poignee);
    ListBox1.Items.Add(IntToStr(l_octet));

    Table1.Close;

    System.Assign(l_fichier, 'c:\OSCAR\CHAINE.DBF');
    Reset(l_fichier, 1);
    Seek(l_fichier, 29);
    BlockRead(l_fichier, l_octet, 1);
    System.Close(l_fichier);

    ListBox1.Items.Add(IntToStr(l_octet));
  end; (* with *)
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_chaine: String;
    l_chaine_ANSI: String;
    l_chaine_OEM: String;

function f_hexa(p_chaine: String): String;
  var l_indice: Integer;
      l_hexa: String;
  begin
    Result:= '';
    for l_indice:= 1 to Length(p_chaine) do
      Result:= Result+ IntToHex(ord(p_chaine[l_indice]), 2)+ ' ';
  end;

const vi_booleen: array[False..True] of String= ('False', 'True');

begin
  with ListBox1.Items do
  begin
    l_chaine_ANSI:= chr($C9)+ 't';

    l_chaine:= l_chaine_ANSI;

    l_chaine_ANSI:= l_chaine_ANSI+ chr(0);
    AnsiToOEM(@l_chaine_ANSI[1], @l_chaine_OEM[1]);

    l_chaine_OEM[0]:= chr(Length(l_chaine_ANSI)- 1);
    Add('AnsiToOem('+ l_chaine+ ', '+ l_chaine_OEM+
       ') ('+ f_hexa(l_chaine_ANSI)+ '-> '+ f_hexa(l_chaine_OEM+ chr(0))+ ')');

    NativeToAnsiBuf(Table1.Locale, @l_chaine_OEM[1], @l_chaine_ANSI[1], 3);
    l_chaine_ANSI[0]:= chr(3);
    Add('NativeToAnsiBuf(Loc, '+ l_chaine_OEM+ ', '+ l_chaine+
       ', 3) ('+ f_hexa(l_chaine_OEM)+ '-> '+ f_hexa(l_chaine_ANSI)+ ')');

    Add(''+ '<'+ 'f :'+ vi_booleen[''<'e']);
    Add('AnsiCompareStr(, f)= '+ IntToStr(AnsiCompareStr('', 'f')));

    Add('AnsiUpperCase()= '+ AnsiUpperCase(''));
    Add('AnsiUpperCase('+ chr($E5)+ ')= '+ AnsiUpperCase(chr($E5)));
    Add('AnsiLowerCase('+chr($C9)+')= '+ AnsiLowerCase(chr($C9)));

    Add('UpperCase()= '+ UpperCase(''));
    Add('UpperCase('+ chr($E5)+ ')= '+ UpperCase(chr($E5)));
    Add('LowerCase('+chr($C9)+')= '+ LowerCase(chr($C9)));
  end; (* with *)
end;

end.
