(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_trim *)

unit U_trim;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    ListBox1: TListBox;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  const k_tab= chr(9);

  function LTrim(Const c_chaine: String): String;
    var a_taille: Byte absolute c_chaine;
        l_indice: Integer;
    begin
      l_indice := 1;
      while (l_indice <= a_taille) and (c_chaine[l_indice] in [' ', k_tab]) do
        Inc(l_indice);
      LTrim := Copy(c_chaine, l_indice, a_taille- l_indice)
    end {LTrim};

  function RTrim(p_chaine: String): String;
    var a_taille: Byte absolute p_chaine;
    begin
      while p_chaine[a_taille] in [' ', k_tab] do
        Dec(a_taille);
      RTrim := p_chaine
    end {RTrim};

  function Trim(p_chaine: String): String;
     begin
       Trim := LTrim(RTrim(p_chaine))
     end {Trim};

  function RightStr(Const c_chaine: String; p_droite: Word): String;
    var a_taille: Byte absolute c_chaine;
    begin
      if p_droite> a_taille
        then p_droite := a_taille;
      RightStr:= Copy(c_chaine, a_taille- p_droite+ 1, p_droite);
    end {Rightc_chaine};

  function LeftStr(Const c_chaine: String; p_gauche: Word): String;
    begin
      LeftStr:= Copy(c_chaine, 1, p_gauche);
    end {Leftc_chaine};

  function MidStr(Const c_chaine: String; p_taille: Word): String;
    var a_taille: Byte absolute c_chaine;
     begin
       if p_taille> a_taille
         then p_taille:= a_taille;
       MidStr:= Copy(c_chaine, ((a_taille- p_taille) div 2)+1, p_taille)
     end {Midc_chaine};

procedure TForm1.Button1Click(Sender: TObject);
begin
  With ListBox1, Items do
  begin
    Add('RTrim('+ Edit1.Text+ ')= '+ RTrim(Edit1.Text)+ '<');
    Add('LTrim('+ Edit1.Text+ ')= '+ LTrim(Edit1.Text)+ '<');
    Add('Trim('+ Edit1.Text+ ')= '+ Trim(Edit1.Text)+ '<');
    Add('RightStr('+ Edit1.Text+ ', '+ Edit2.Text+')= '+ RightStr(Edit1.Text, StrToInt(Edit2.Text))+ '<');
    Add('LeftStr('+ Edit1.Text+ ', '+ Edit2.Text+')= '+ LeftStr(Edit1.Text, StrToInt(Edit2.Text))+ '<');
    Add('MidStr('+ Edit1.Text+ ', '+ Edit2.Text+')= '+ MidStr(Edit1.Text, StrToInt(Edit2.Text))+ '<');
  end;
end;

end.
