(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_datfor *)

unit U_datfor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var l_texte: String;
    l_mois, l_jour: Integer;
begin
  With ListBox1, Items do
  begin
    Clear;
    Add('DateSeparator '+ DateSeparator+ ', TimeSeparator '+ TimeSeparator);
    Add('ShortDateFormat >'+ ShortDateFormat+ '<');
    Add('LongDateFormat >'+ LongDateFormat+ '<');
    Add('ShortTimeFormat >'+ ShortTimeFormat+ '<');
    Add('LongTimeFormat >'+ LongTimeFormat+ '<');

    l_texte:= '';
    for l_jour:= 1 to 7 do
      l_texte:= l_texte+ ShortDayNames[l_jour]+ ' ';
    Add('ShortDayNames: '+ l_texte);
    l_texte:= '';
    for l_jour:= 1 to 7 do
      l_texte:= l_texte+ LongDayNames[l_jour]+ ' ';
    Add('LongDayNames: '+ l_texte);

    l_texte:= '';
    for l_mois:= 1 to 12 do
      l_texte:= l_texte+ ShortMonthNames[l_mois]+ ' ';
    Add('ShortMonthNames: '+ l_texte);
    l_texte:= '';
    for l_mois:= 1 to 12 do
      l_texte:= l_texte+ LongMonthNames[l_mois]+ ' ';
    Add('LongMonthNames: '+ l_texte);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
  var l_date: tDateTime;
      l_sauve_separateur: Char;

  procedure ajoute(p_gabarit: String);
    begin
      With ListBox1, Items do
        Add(p_gabarit+ ' '+ FormatDateTime(p_gabarit, l_date));
    end;

begin
  l_date:= EncodeDate(1996, 1, 25)+ EncodeTime(13, 1, 2, 234);

  With ListBox1, Items do
  begin
{
    Clear;
    ajoute('D     ');
    ajoute('DD    ');
    ajoute('DDD   ');
    ajoute('DDDD  ');
    ajoute('M     ');
    ajoute('MM    ');
    ajoute('MMM   ');
    ajoute('MMMM  ');
    ajoute('YY    ');
    ajoute('YYYY  ');

    ajoute('DDDDD ');
    ajoute('DDDDDD');
    ajoute('H     ');
    ajoute('HH    ');
    ajoute('T     ');
    ajoute('TT    ');
    ajoute('C     ');

    ajoute('DD MMM YY    ');
    ajoute('H N S        ');
    ajoute('HH NN SS     ');
    ajoute('');
    ajoute('"Nice, le "DDDD D MMMM (YY)" ');
    ajoute('"il est "H:M:S');
}
    l_sauve_separateur:= DateSeparator;
    DateSeparator:= '%';
    ajoute('C          ');
    ajoute('DD/MMM/YY  ');
    DateSeparator:= l_sauve_separateur;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
  var l_date: tDateTime;

  procedure ajoute_date(p_chaine_date: String);
    begin
      With ListBox1, Items do
        Add(p_chaine_date+ FormatDateTime('= dd/MM/yyy', StrToDate(p_chaine_date)));
    end; (* ajoute_date *)

  procedure ajoute_heure(p_chaine_heure: String);
    begin
      With ListBox1, Items do
        Add(p_chaine_heure+ FormatDateTime('= hh:mm:ss', StrToTime(p_chaine_heure)));
    end; (* ajoute_heure *)

begin (* Button3Click *)
  l_date:= EncodeDate(1996, 1, 25)+ EncodeTime(13, 1, 2, 234);

  With ListBox1, Items do
  begin
    Clear;
    ajoute_date('25/01/1995');
    ajoute_date('25/1/1995');
    ajoute_date('25/1/95');
    ajoute_heure('1:2:3');
    Try
      ajoute_date('25/z/95');
    Except
      on e: eConvertError do
        ShowMessage('pb');
    end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ListBox1.Items.SaveToFile('f.pas');
end;

end.

