(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_valdat *)

unit U_valdat;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1NAISSANCE: TDateField;
    procedure Table1NAISSANCEGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table1NAISSANCESetText(Sender: TField; const Text: String);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Table1NAISSANCEGetText(Sender: TField;
  var Text: OpenString; DisplayText: Boolean);
begin
  If Table1NAISSANCE.IsNull
    then Text:= '  /   /  '
    else Text:= FormatDateTime(Table1NAISSANCE.DisplayFormat, Table1NAISSANCE.AsDateTime);
end;

procedure TForm1.Table1NAISSANCESetText(Sender: TField;
  const Text: String);
var l_jour, l_mois, l_annee: String;
    l_indice, l_numero_mois: Integer;
    l_a_trouve: Boolean;
begin
  IF Text= '  /   /  '
    Then Begin
        Table1NAISSANCE.Clear;
        Exit; 
      end;

  l_jour:= Copy(Text, 1, 2);
  l_mois:= Copy(Text, 4, 3);
  l_annee:= Copy(Text, 8, 2);

  (* -- vrifie le nom du mois *)
  l_indice:= 1; l_numero_mois:= -1;
  For l_indice:= 1 to 12 do
    if UpperCase(ShortMonthNames[l_indice])= UpperCase(l_mois)
      then l_numero_mois:= l_indice;

  if l_numero_mois= -1
    then begin
        ShowMessage('nom du mois incorrect '+ l_mois);
        Abort;
      end;

  (* -- ne vrifie pas les annes: sera bien entre 00 et 99 *)

  (* -- les autres exceptions ne peuvent venir que du jour *)
  Try
    Table1NAISSANCE.AsDateTime:= EncodeDate(StrToInt(l_annee), l_numero_mois, StrToInt(l_jour));
  Except
    ShowMessage('quantime incorrect '+ l_jour);
    Abort;
  end;
end;

end.
