(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_flofor *)

unit U_flofor;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1POIDS: TFloatField;
    DisplayFormat_: TButton;
    EditFormat_: TButton;
    EditMask_: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Memo1: TMemo;
    procedure DisplayFormat_Click(Sender: TObject);
    procedure EditFormat_Click(Sender: TObject);
    procedure EditMask_Click(Sender: TObject);
    procedure Table1POIDSSetText(Sender: TField; const Text: String);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure affiche;
  begin
    With Form1, Form1.Memo1.Lines do
    begin
      Add(Table1.FieldByName('POIDS').DisplayText);
      Add(Table1.FieldByName('POIDS').Text);
    end;
  end;

procedure TForm1.DisplayFormat_Click(Sender: TObject);
begin
  Table1POIDS.DisplayFormat:= Edit1.Text;
  affiche;
end;

procedure TForm1.EditFormat_Click(Sender: TObject);
begin
  Table1POIDS.EditFormat:= Edit2.Text;
  affiche;
end;

procedure TForm1.EditMask_Click(Sender: TObject);
begin
  Table1POIDS.EditMask:= Edit3.Text;
  affiche;
end;

procedure TForm1.Table1POIDSSetText(Sender: TField; const Text: String);
var l_indice: Integer;
    l_texte: String;
begin
  l_indice:= 1;
  l_texte:= Text;
  while l_indice< Length(l_texte) do
    if l_texte[l_indice]= ThousandSeparator
      then Delete(l_texte, l_indice, 1)
      else inc(l_indice);
  Try
    Table1POIDS.AsString:= l_texte;
  Except
    On e: eDatabaseError do
      begin
        ShowMessage('pas un nombre');
        Abort;
      end;
  end;
end;

end.


procedure TForm1.DBEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key= '1'
    then begin
        With ListBox1.Items do
        begin
          Add(dbEdit1.Text);
          Add(dbEdit1.EditText);
          Add(Table1.FieldByName('POIDS').EditMask+ '<');
        end;
      end;
end;


