(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_flostr *)

unit U_flostr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var g_chaine_numerique: String;

procedure TForm1.Button1Click(Sender: TObject);
begin
  With ListBox1.Items do
  begin
    Add(Table1.FieldByName('POIDS').AsString);
    Add(FloatToStrF(Table1.FieldByName('POIDS').AsFloat, ffNumber, 12, 1));
    g_chaine_numerique:= FormatFloat('#,#.00000', Table1.FieldByName('POIDS').AsFloat);
    Add(g_chaine_numerique);
  end; (* with Table *)
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_chaine: String;
    l_indice: Integer;
    l_nombre: Double;
begin
  l_nombre:= StrToFloat(g_chaine_numerique);
  l_chaine:= '';
  for l_indice:= 1 to Length(g_chaine_numerique) do
    if g_chaine_numerique[l_indice] in ['0'..'9', ',']
      then l_chaine:= l_chaine+ g_chaine_numerique[l_indice];

  l_nombre:= StrToFloat(l_chaine);
  Table1.Edit;
  Table1.FieldByName('POIDS').AsString:= l_chaine;
  Table1.Post;
end;

end.
