(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_nombre *)

unit U_nombre;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);

  procedure ajoute(p_chaine: String; p_reel: Extended; p_format: tFloatFormat; p_precision, p_chiffres: Integer);
    begin
      With ListBox1, Items do
      begin
        Add(p_chaine+ '= '+ FloatToStrF(p_reel, p_format, p_precision, p_chiffres));
      end; (* with *)
    end; (* ajoute *)

begin
  ListBox1.Items.Clear;

  ajoute('1234.5678, ffGeneral, 15, 0 ' , 1234.5678, ffGeneral, 15, 0);
  ajoute('1234.5678, ffExponent, 15, 0', 1234.5678, ffExponent, 15, 0);
  ajoute('1234.5678, ffFixed, 15, 0   ', 1234.5678, ffFixed, 15, 0);
  ajoute('1234.5678, ffNumber, 15, 0  ', 1234.5678, ffNumber, 15, 0);
  ajoute('1234.5678, ffCurrency, 15, 0', 1234.5678, ffCurrency, 15, 0);
end;


procedure TForm1.Button2Click(Sender: TObject);

  procedure ajoute(p_gabarit, p_nombre: String; p_reel: Extended);
    begin
      With ListBox1, Items do
      begin
        Add(p_gabarit+ p_nombre+ '= >'+ FormatFloat(p_gabarit, p_reel)+ '<');
      end; (* with *)
    end; (* ajoute *)

begin
  ListBox1.Items.Clear;
  ajoute('000.00      ', '1.2      ', 1.2);
  ajoute('0.0         ', '12.345   ', 12.345);

  ajoute('###.##      ', '1.2       ', 1.2);
  ajoute('#.#         ', '12.345    ', 12.345);

  ajoute('###.##      ', '1.2       ', 1.2);
  ajoute('#.###.##    ', '1234.567  ', 1234.567);
  ajoute('000.00      ', '1.2       ', 1.2);
  ajoute('0.000.00    ', '1234.567  ', 1234.567);

  ajoute('00,00.00    ', '1.2       ', 1.2);
  ajoute('0.000,00    ', '1234.567  ', 1234.567);

  (* -- partie entire *)
  ajoute('0.0         ', '1.2       ', 1.2);
  ajoute('0.0         ', '12.3      ', 12.3);
  ajoute('#.0         ', '1.2       ', 1.2);
  ajoute('#.0         ', '0.3       ', 0.3);

  (* -- partie dcimale *)
  (* -- arrondi *)
  ajoute('0           ', '1.2       ', 1.2);
  ajoute('0           ', '1.5       ', 1.5);
  ajoute('0.0         ', '1.35      ', 1.35);
  ajoute('0.00        ', '0.125     ', 0.125);
  ajoute('0           ', '1.6       ', 1.6);
  ajoute('#           ', '1.2       ', 1.2);
  ajoute('#           ', '1.5       ', 1.5);
  ajoute('#           ', '1.6       ', 1.6);
  ajoute('#           ', '0.1       ', 0.1);

  (* -- E *)
  ajoute('0.0E+0      ', '123456.7  ', 123456.7);
  ajoute('0.0E+00     ', '123456.7  ', 123456.7);
  ajoute('0.0E+0      ', '0.0123    ', 0.0123);
  ajoute('0.0E-0      ', '0.0123    ', 0.0123);
  ajoute('0.0E-0      ', '123.4     ', 123.4);

  ajoute('0.0;#.#;0   ', '-1.2      ', -1.2);  
end;

procedure TForm1.Button3Click(Sender: TObject);

  procedure ajoute(p_chaine: String);
    begin
      With ListBox1, Items do
      begin
        Add(p_chaine+ FloatToStr( StrToFloat(p_chaine)) );
      end; (* with *)
    end; (* ajoute *)

var reel: Double;

begin
  ajoute('+1,3');
  Try
    reel:= StrToFloat('1 234,56');
  except
{
    ShowMessage(Message);
}
  end;
end;

end.

