(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_valflo *)

unit U_valflo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBEdit1: TDBEdit;
    Edit1: TEdit;
    Table1NUMERO: TFloatField;
    Table1POIDS: TFloatField;
    Button1: TButton;
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure DBEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  dbEdit1.Perform(em_LimitText, 5, 0);
end;

procedure TForm1.DBEdit1KeyPress(Sender: TObject; var Key: Char);
var l_masque: String;
    l_indice: Integer;
begin
  with Table1POIDS do
  begin
{
    l_masque:= FormatFloat(Table1POIDS.EditFormat, Table1POIDS.AsFloat);
}
    l_masque:= Table1POIDS.Text;
    Edit1.Text:= l_masque;
    l_indice:= dbEdit1.SelStart;

    (* -- affiche le caractre courant dans Edit1 *)
    Edit1.SelStart:= l_indice;
    Edit1.SelLength:= 1;

    If (l_masque[l_indice+ 1] in ['0'..'9']) and (Key in ['0'..'9'])
     then begin
         (* -- remplace le caractre actuel par celui tap *)
         dbEdit1.SelLength:= 1;
       end
     else
       if l_masque[l_indice+ 1]= Key
         then begin
             if Key= ' '
               then dbEdit1.SelStart:= l_indice+ 1
               else dbEdit1.SelLength:= 1;
           end
         else begin
           ShowMessage('pb '+ l_masque[l_indice]+ ' '+ Key);
           Abort;
         end;
  end;
end;

procedure TForm1.DBEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  (* -- affiche le caractre courant dans Edit1 *)
  Edit1.SelStart:= dbEdit1.SelStart;
  Edit1.SelLength:= 1;
end;

procedure TForm1.DBEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Key= vk_Delete
    then Key:= 0;
end;

end.
