(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_memsql *)

unit U_memsql;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    Table1B_NUMERO: TFloatField;
    Table1B_MEMO: TMemoField;
    live_: TButton;
    modifie: TButton;
    Query1: TQuery;
    ajoute: TButton;
    DBMemo1: TDBMemo;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    DBMemo2: TDBMemo;
    Refresh_: TButton;
    non_live_: TButton;
    procedure live_Click(Sender: TObject);
    procedure modifieClick(Sender: TObject);
    procedure ajouteClick(Sender: TObject);
    procedure Refresh_Click(Sender: TObject);
    procedure non_live_Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)

{$R *.DFM}

procedure TForm1.live_Click(Sender: TObject);
var l_flux_blob: tBlobStream;
begin
  Query1.Close;
  Query1.SQL.Clear;
{
  Query1.SQL.Add('Select * FROM "LES_BLOB.DBF" ');
}
  Query1.SQL.Add('Select B_NUMERO, B_MEMO FROM "LES_BLOB.DBF" ');
  Query1.RequestLive:= True;
  Query1.Open;

{
  (* OK *)
  l_flux_blob:= tBlobStream.Create(Table1B_MEMO, bmRead);
  Memo1.Lines.LoadFromStream(l_flux_blob);
  l_flux_blob.Free;
}
{
 (* OK *)
  Memo1.Lines.Assign(Table1B_MEMO);
}
  dbMemo1.DataField:= 'B_MEMO';
end;

procedure TForm1.non_live_Click(Sender: TObject);
begin
  Query1.Close;
  Query1.SQL.Clear;
  Query1.SQL.Add('Select B_NUMERO, B_MEMO FROM "LES_BLOB.DBF" ');
  Query1.SQL.Add('  ORDER BY B_NUMERO');
  Query1.Open;

  dbMemo1.DataField:= 'B_MEMO';
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  (* -- exemple d'affectation de lignes  Memo *)
  Table1.FindKey([Query1.FieldByName('B_NUMERO').AsInteger]);
  Memo1.Lines.Assign(Table1B_MEMO);
end;

procedure TForm1.modifieClick(Sender: TObject);
begin
  Table1.Edit;
  Table1.FieldByName('B_MEMO').Assign(Memo1.Lines);
  Table1.Post;
  Query1.Close; Query1.Open;
end;

procedure TForm1.ajouteClick(Sender: TObject);
begin
  Query1.Close;
  Query1.SQL.Clear;
  Query1.Sql.Add('INSERT INTO "LES_BLOB.DBF" ');
  Query1.Sql.Add('  (B_NUMERO) ');
  Query1.Sql.Add('  VALUES (13) ');
  Query1.ExecSql;

  Table1.FindKey([13]);
  Table1.Edit;
  Table1.FieldByName('B_MEMO').Assign(Memo1.Lines);
  Table1.Post;
end;

procedure TForm1.Refresh_Click(Sender: TObject);
begin
  Table2.Refresh;
end;

end.

