(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_com *)

unit U_db_com;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    DBComboBox1: TDBComboBox;
    DBComboBox2: TDBComboBox;
    DBComboBox3: TDBComboBox;
    Button2: TButton;
    charge: TButton;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    procedure DBComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure DBComboBox1Enter(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure chargeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBComboBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBComboBox1Change(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.chargeClick(Sender: TObject);
var l_chaines: tStringList;
begin
  l_chaines:= tStringList.Create;
  l_chaines.Sorted:= True;
  l_chaines.Duplicates:= DupIgnore;
  Table1.First;
  While not Table1.Eof do
  begin
    l_chaines.Add(Table1.FieldByName('PRENOM').AsString);
    Table1.Next;
  end;
  dbComboBox1.Items.Assign(l_chaines);
  dbComboBox2.Items.Assign(l_chaines);
  dbComboBox3.Items.Assign(l_chaines);

  l_chaines.Free;

  SendMessage(dbComboBox1.Handle, cb_ShowDropDown, 1, 0);
  SendMessage(dbComboBox2.Handle, cb_ShowDropDown, 1, 0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SendMessage(dbComboBox1.Handle, cb_ShowDropDown, 1, 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{
  dbComboBox1.Text:= 'ace';
}
end;

(* -- recherche incrmentale *)

var g_texte: String;
    g_indice_selection: Integer;

procedure TForm1.DBComboBox1Enter(Sender: TObject);
begin
  g_texte:= dbComboBox1.Text;
  (* sert  rien
  g_indice_selection:= Length(g_texte);
  dbComboBox1.SelLength:= 0;
  *)
  SendMessage(dbComboBox1.Handle, cb_ShowDropDown, 1, 0);
end;

procedure TForm1.DBComboBox1Change(Sender: TObject);
begin
  Memo1.Lines.Add('Change '+ dbComboBox1.Text+ ' '+ dbComboBox1.Items[dbComboBox1.ItemIndex] );
  g_texte:= dbComboBox1.Text;
end;

  procedure cherche;
    var l_indice, l_item, l_item_ok: Integer;
        l_fini: Boolean;
        l_texte, l_partie_item, l_partie_texte: String;
        l_indice_selection: Integer;
    begin
      With Form1 do
      begin
{
        Memo1.Lines.Clear;
}
        Memo1.Lines.Add('');
        Memo1.Lines.Add('cherche '+ g_texte);

        Memo1.Lines.Add('cherche '+ g_texte);
        l_texte:= UpperCase(g_texte);

        l_fini:= False;
        l_item:= 0; l_indice:= 1; l_item_ok:= 0;
        While not l_fini and (l_item<= dbComboBox1.Items.Count) do
        begin
{
          Memo1.Lines.Add('>'+ IntToStr(l_item_ok));
}
          l_partie_item:= UpperCase(Copy(dbComboBox1.Items[l_item], 1, l_indice));
          l_partie_texte:= Copy(l_texte, 1, l_indice);

          if l_partie_item< l_partie_texte
            then inc(l_item)
            else
              if l_partie_item> l_partie_texte
                then l_fini:= True
                else begin
                    l_item_ok:= l_item;
                    if l_indice= Length(l_texte)
                      then l_fini:= True
                      else inc(l_indice);
                  end;
        end; (* While *)

{
        Memo1.Lines.Add(IntToStr(l_item_ok)+ ' '+ IntToStr(g_indice_selection));
        Memo1.Lines.Add(l_partie_item+ ' '+ l_partie_texte);
}
        dbComboBox1.ItemIndex:= l_item_ok;
        l_partie_item:= UpperCase(Copy(dbComboBox1.Items[l_item_ok], 1, g_indice_selection));
        l_partie_texte:= Copy(l_texte, 1, g_indice_selection);
        Memo1.Lines.Add(l_partie_item+ ' '+ l_partie_texte);

        if (l_partie_item= l_partie_texte)
          then begin
              Memo1.Lines.Add('OK ');
              g_texte:= dbComboBox1.Text;
            end
          else begin
              dbComboBox1.Text:= g_texte;
            end;
      end;
    end; (* cherche *)

procedure TForm1.DBComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  g_indice_selection:= dbComboBox1.SelStart;
  case Key of
    ' '..#255 : begin
                  if g_indice_selection< Length(g_texte)
                    then begin
                        g_texte[g_indice_selection+ 1]:= Key;
                      end
                    else begin
                        Insert(Key, g_texte, dbComboBox1.SelStart+ 1);
                      end;
                  inc(g_indice_selection);
                  cherche;
                  (* -- APRES cherche, pour ajout en fin *)
                  dbComboBox1.SelStart:= g_indice_selection;
                  Key:= chr(0);
                end;
    #8 : begin
           delete(g_texte, dbComboBox1.SelStart, 1);
           dec(g_indice_selection);
           cherche;
           dbComboBox1.SelStart:= g_indice_selection;
           Key:= chr(0);
         end;
  end; (* case *)
end;

procedure TForm1.DBComboBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case Key of
    vk_Delete : begin
                  g_indice_selection:= dbComboBox1.SelStart;
                  delete(g_texte, g_indice_selection+ 1, 1);
                  cherche;
                  dbComboBox1.SelStart:= g_indice_selection;
                  Key:= 0;
                end;
  end;
end;

end.


