(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_lol *)

unit U_db_lol;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DB, StdCtrls, Mask, DBCtrls, dblookup, Grids,
  DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    DBLookupList1: TDBLookupList;
    Table2A_CODE: TFloatField;
    Table2A_DESCRIPT: TStringField;
    Table1I_NUM_FACT: TFloatField;
    Table1I_NUMERO: TFloatField;
    Table1I_LIBELLE: TStringField;
    Table1I_CODE: TFloatField;
    Table2A_POIDS: TFloatField;
    Query1: TQuery;
    Query_: TButton;
    BatchMove1: TBatchMove;
    Table21: TTable;
    DataSource21: TDataSource;
    Options_: TButton;
    Table22: TTable;
    DataSource22: TDataSource;
    DBGrid22: TDBGrid;
    Table22A_CODE: TFloatField;
    Table22A_DESCRIPT: TStringField;
    Memo1: TMemo;
    Table22A_LIBELLE: TStringField;
    Table23: TTable;
    DataSource3: TDataSource;
    Table1_DESCRIPTION: TStringField;
    Table24: TTable;
    procedure Query_Click(Sender: TObject);
    procedure Options_Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DataSource22DataChange(Sender: TObject; Field: TField);
    procedure DataSource2DataChange(Sender: TObject; Field: TField);
    procedure DBLookupList1Click(Sender: TObject);
    procedure Table1CalcFields(DataSet: TDataset);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Query_Click(Sender: TObject);
begin
  Query1.CLose;
  Query1.DataBaseName:= 'Flix';
  Query1.Sql.Clear;
  Query1.Sql.Add('SELECT DISTINCT A_CODE, A_DESCRIPT FROM "ARTICLE.DBF"');

  Query1.Open;

  Table21.DatabaseName:= 'Flix';
  Table21.TableName:= 'RESU.DBF';
  Table21.TableType:= ttdBase;

  BatchMove1.Source:= Query1;
  BatchMove1.Destination:= Table21;
  BatchMove1.Mode:= batCopy;
  BatchMove1.Execute;

  Table21.AddIndex('R_I_CODE', 'A_CODE', []);
  Table21.IndexName:= 'R_I_CODE';

  DataSource21.DataSet:= Table21;
  Table21.Open;
  dbLookupList1.LookupSource:= DataSource21;
end;

procedure TForm1.Options_Click(Sender: TObject);
begin
  tdbGrid(dbLookupList1).Options:=
      tdbGrid(dbLookupList1).Options+ [dgIndicator];
{
  tDrawGrid(dbLookupList1).RowHeights[0]:= 45;
}
end;

(* -- Lookup via notre dbGrid *)

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  Memo1.Lines.Add('1');

{
  Table22.SetKey;

  Table22.FieldByName('A_LIBELLE').AsString:= Table1.FieldByName('I_LIBELLE').AsString;
  Table22.FieldByName('A_CODE').AsInteger:= Table1.FieldByName('I_CODE').AsInteger;

  if Table22.GotoKey
    then dbGrid22.Options:= dbGrid22.Options+ [dgAlwaysShowSelection]
    else dbGrid22.Options:= dbGrid22.Options- [dgAlwaysShowSelection];
}

  Table23.SetKey;
  Table23.FieldByName('A_CODE').AsInteger:= Table1.FieldByName('I_CODE').AsInteger;

  if Table23.GotoKey
    then begin
        Table22.GotoCurrent(Table23);
        dbGrid22.Options:= dbGrid22.Options+ [dgAlwaysShowSelection];
      end
    else dbGrid22.Options:= dbGrid22.Options- [dgAlwaysShowSelection];
end;

function f_booleen(p_booleen: Boolean): String;
  begin
    if p_booleen
      then f_booleen:= 'vrai'
      else f_booleen:= 'faux';
  end;

procedure TForm1.DataSource22DataChange(Sender: TObject; Field: TField);
begin
  Memo1.Lines.Add('22 '+ f_booleen(dbGrid22.Focused));
  If dbGrid22.Focused and (Table22.State= dsBrowse)
    then begin
        DataSource1.OnDataChange:= nil;

        If not (Table1.State= dsEdit)
          then Table1.Edit;

        Table1.FieldByName('I_LIBELLE').AsString:= Table22.FieldByName('A_LIBELLE').AsString;
        Table1.FieldByName('I_CODE').AsInteger:= Table22.FieldByName('A_CODE').AsInteger;

        DataSource1.OnDataChange:= DataSource1DataChange;
      end;
end;

procedure TForm1.DataSource2DataChange(Sender: TObject; Field: TField);
begin

  Memo1.Lines.Add('Aj Data2');
end;

procedure TForm1.DBLookupList1Click(Sender: TObject);
begin
  Memo1.Lines.Add('Click');
  Table1.FieldByName('I_CODE').AsInteger:= Table2.FieldByName('A_CODE').AsInteger;
end;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
begin
  Memo1.Lines.Add('Calc');

  Table24.SetKey;
  Table24.FieldByName('A_CODE').AsInteger:= Table1.FieldByName('I_CODE').AsInteger;

  if Table24.GotoKey
    then begin
        Table1.FieldByName('_DESCRIPTION').AsString:= Table24.FieldByName('A_DESCRIPT').AsString;
      end
end;

end.


