(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_db_mem *)

unit U_db_mem;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    AutoDisplay: TButton;
    modifie: TButton;
    selection: TButton;
    Memo1: TMemo;
    numero_ligne: TButton;
    CopyToClipboard: TButton;
    procedure AutoDisplayClick(Sender: TObject);
    procedure modifieClick(Sender: TObject);
    procedure selectionClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DBMemo1Change(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DataSource1UpdateData(Sender: TObject);
    procedure numero_ligneClick(Sender: TObject);
    procedure CopyToClipboardClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

function f_booleen(p_booleen: Boolean): String;
  begin
    if p_booleen
      then f_booleen:= 'vrai'
      else f_booleen:= 'faux';
  end;

procedure TForm1.AutoDisplayClick(Sender: TObject);
begin
  if AutoDisplay.Caption= 'AutoDisplay'
    then begin
        AutoDisplay.Caption:= 'pas_AutoDisplay';
        dbMemo1.AutoDisplay:= False;
      end
    else begin
        AutoDisplay.Caption:= 'AutoDisplay';
        dbMemo1.AutoDisplay:= True;
      end;
end;

procedure TForm1.modifieClick(Sender: TObject);
begin
{
  Table1.Edit;
}
  dbMemo1.Lines[0]:= 'aha';
end;

procedure TForm1.selectionClick(Sender: TObject);
begin
  dbMemo1.SelStart:= 1;
  dbMemo1.SelLength:= 2;
  dbMemo1.Update;
{
  dbMemo1.SelText:= 'zz';
}
{
  tMemo(dbMemo1).HideSelection;
  Memo1.HideSelection;
  Edit1.HideSelection:= True;
}
  (* -- sert  rien *)
  tMemo(dbMemo1).HideSelection:= True;
{
  dbMemo1.AlwaysShowSelection;
}
  dbMemo1.SetFocus;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  affiche(f_booleen(dbMemo1.Modified));
end;

procedure TForm1.DBMemo1Change(Sender: TObject);
begin
  affiche('OnChange '+ dbMemo1.Lines[0]+ ' '+ dbMemo1.Lines[1]);
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  affiche('OnDataChange');
end;

procedure TForm1.DataSource1UpdateData(Sender: TObject);
begin
  affiche('OnUpdateData');

end;

procedure TForm1.numero_ligneClick(Sender: TObject);
var l_numero: Integer;
begin
  l_numero:= dbMemo1.Perform(em_LineFromChar, $FFFF, 0);
  affiche(IntToStr(l_numero));
end;

procedure TForm1.CopyToClipboardClick(Sender: TObject);
begin
  dbMemo1.CopyToClipboard;
end;

end.
