(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ascii *)

(*$r+*)
unit U_ascii;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBTables, Grids, DBGrids, DB;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    Memo1: TMemo;
    DBF_Bat_Copy: TButton;
    cree_ascii: TButton;
    affiche_SCH: TButton;
    affiche_TXT: TButton;
    efface_ascii: TButton;
    cree_FIXED: TButton;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1PRENOM: TStringField;
    Table1POIDS: TFloatField;
    Table1NAISSANCE: TDateField;
    TXT_Bat_Copy: TButton;
    cree_delimite: TButton;
    lis_TXT: TButton;
    cree_et_lis_TXT: TButton;
    DataSource2: TDataSource;
    DBGrid3: TDBGrid;
    ouvre_ascii: TButton;
    DBF_Bat_App: TButton;
    cree_SCH: TButton;
    affiche_DBF: TButton;
    BatchMove1: TBatchMove;
    Table3: TTable;

    procedure DBF_Bat_CopyClick(Sender: TObject);
    procedure cree_asciiClick(Sender: TObject);

    procedure affiche_SCHClick(Sender: TObject);
    procedure affiche_TXTClick(Sender: TObject);

    procedure efface_asciiClick(Sender: TObject);

    procedure cree_FIXEDClick(Sender: TObject);
    procedure TXT_Bat_CopyClick(Sender: TObject);
    procedure cree_delimiteClick(Sender: TObject);
    procedure lis_TXTClick(Sender: TObject);
    procedure cree_et_lis_TXTClick(Sender: TObject);
    procedure ouvre_asciiClick(Sender: TObject);
    procedure DBF_Bat_AppClick(Sender: TObject);
    procedure cree_SCHClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure affiche_DBFClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses inifiles;

{$R *.DFM}

procedure affiche(p_texte: String);
  const vi_nombre: Integer= 1;
  begin
    Form1.Memo1.Lines.Add(Format('%2d %s ', [vi_nombre, p_texte]));
    inc(vi_nombre);
  end;

procedure affiche_ligne;
  begin
    Form1.Memo1.Lines.Add('');
  end;

var g_nom: String;

procedure TForm1.FormCreate(Sender: TObject);
begin
  g_nom:= Table2.TableName;
  Delete(g_nom, Length(g_nom)- 3, 4);
end;

procedure TForm1.cree_asciiClick(Sender: TObject);
begin
  Table2.Close;
  Table2.CreateTable;
end;

procedure TForm1.cree_SCHClick(Sender: TObject);
var l_texte: System.Text;
begin
  System.Assign(l_texte, 'C:\OSCAR\'+ g_nom+ '.SCH');
  Rewrite(l_texte);

  Writeln(l_texte, '[LE_TEXTE]');
  writeln(l_texte, 'FILETYPE=FIXED');
  writeln(l_texte, 'CHARSET=ASCII');
  writeln(l_texte, 'FIELD1=NUMERO,FLOAT,20,04,00');
  writeln(l_texte, 'FIELD2=NOM,CHAR,10,00,20');
  writeln(l_texte, 'FIELD3=PRENOM,CHAR,07,00,30');
  writeln(l_texte, 'FIELD4=POIDS,FLOAT,20,04,37');
  writeln(l_texte, 'FIELD5=NAISSANCE,DATE,11,00,57');

  System.Close(l_texte);
end;

procedure TForm1.efface_asciiClick(Sender: TObject);
begin
  Table2.Close;
  Table2.DeleteTable;
end;

procedure TForm1.ouvre_asciiClick(Sender: TObject);
begin
  Table2.Active:= Not Table2.Active;
end;

procedure TForm1.DBF_Bat_CopyClick(Sender: TObject);
var l_nombre: LongInt;
begin
  l_nombre:= Table2.BatchMove(Table1, BatCopy);

  affiche('nombre '+ IntToStr(l_nombre));
  Table2.Open;
end;

procedure TForm1.DBF_Bat_AppClick(Sender: TObject);
var l_nombre: LongInt;
begin
  l_nombre:= Table2.BatchMove(Table1, BatAppend);

  affiche('nombre '+ IntToStr(l_nombre));
  Table2.Open;
end;

procedure TForm1.affiche_SCHClick(Sender: TObject);
begin
  Memo1.Lines.LoadFromFile('C:\OSCAR\'+ g_nom+ '.SCH');
end;

procedure TForm1.affiche_TXTClick(Sender: TObject);
begin
  Memo1.Lines.LoadFromFile('c:\OSCAR\'+ g_nom+ '.txt');
end;

procedure TForm1.cree_FIXEDClick(Sender: TObject);
const k_taille_nom= 10;
      k_taille_numero= 3;
      k_taille_naissance= 10;
      k_taille_poids= 9; k_decimales_poids= 3;
var l_texte: System.Text;
    l_chaine_poids: String;
begin
  System.Assign(l_texte, 'C:\OSCAR\'+ g_nom+ '.SCH');
  Rewrite(l_texte);

  Writeln(l_texte, '[LE_TEXTE]');
  writeln(l_texte, 'FILETYPE=FIXED');
  writeln(l_texte, 'CHARSET=ASCII');
{
  writeln(l_texte, 'FIELD1=xNOM,CHAR,'+ IntToStr(k_taille_nom)+ ',0,0');
  writeln(l_texte, 'FIELD2=xNUMERO,NUMBER,'+ IntToStr(k_taille_numero)+ ',0,'+ IntToStr(k_taille_nom));
  writeln(l_texte, 'FIELD3=xNDATE,10,0,10+ 3');
}
  writeln(l_texte, 'FIELD1=xNOM,CHAR,'+ IntToStr(k_taille_nom)+ ',0,0');
  writeln(l_texte, 'FIELD2=xNUMERO,NUMBER,'+ IntToStr(k_taille_numero)+ ',0,'+ IntToStr(k_taille_nom));
  writeln(l_texte, 'FIELD3=xNAISSANCE,DATE,'+ IntToStr(k_taille_naissance)+ ',0,'+ IntToStr(k_taille_nom+ k_taille_numero));
  writeln(l_texte, 'FIELD4=xPOIDS,FLOAT,'+ IntToStr(k_taille_poids)+ ','+ IntToStr(k_decimales_poids)+ ','
      + IntToStr(k_taille_nom+ k_taille_numero+ k_taille_naissance));
  System.Close(l_texte);
{
  With BatchMove1 do
  begin
    Mappings.Clear;
    Mappings.Add('xNOM=Nom');
    Mappings.Add('xNUMERO=NUMERO');
    Mappings.Add('xNAISSANCE=NAISSANCE');
    Mappings.Add('xPOIDS=POIDS');

    Execute;
    Table2.Open;
  end;
  exit;
}
  System.Assign(l_texte, 'C:\OSCAR\'+ g_nom+ '.TXT');
  Rewrite(l_texte);

  With Table1 do
  begin
    Open;
    First;

    while not eof do
    begin
{
      Writeln(l_texte, Format('%-10s%3d%-10s',
          [FieldByName('NOM').AsString, FieldByName('NUMERO').AsInteger,
            FieldByName('NAISSANCE').AsString]) );
}
{
      Writeln(l_texte, Format('%-'+ IntToStr(k_taille_nom)+ s',
          [FieldByName('NOM').AsString]));
}

      l_chaine_poids:= FloatToStrF(FieldByName('POIDS').AsFloat, ffFixed, 9, 3);
      Writeln(l_texte, Format('%-'+ IntToStr(k_taille_nom)+ 's%'+ IntToStr(k_taille_numero)+ 'd'
            + '%-'+ IntToStr(k_taille_naissance)+ 's'
            + '%'+ IntToStr(k_taille_poids)+ 's',
          [FieldByName('NOM').AsString,
           FieldByName('NUMERO').AsInteger,
           FieldByName('NAISSANCE').AsString,
           l_chaine_poids]));
      Next;
    end; (* while *)
  end; (* with *)

  Write(l_texte, chr(26));
  System.Close(l_texte);
end;

procedure TForm1.cree_delimiteClick(Sender: TObject);
const k_delimiteur= '"';
      k_separateur= ';';
var l_texte: System.Text;
begin
  System.Assign(l_texte, 'C:\OSCAR\'+ g_nom+ '.SCH');
  Rewrite(l_texte);

  Writeln(l_texte, '[LE_TEXTE]');
{
  writeln(l_texte, 'FILETYPE=kiki');
}
  writeln(l_texte, 'FILETYPE=VARYING');
  writeln(l_texte, 'DELIMITER='+ k_delimiteur);
  writeln(l_texte, 'SEPARATOR='+ k_separateur);
  writeln(l_texte, 'CHARSET=ASCII');
  writeln(l_texte, 'FIELD1=xNOM,CHAR,20,0,0');
  writeln(l_texte, 'FIELD2=xNUMERO,NUMBER,15,0,0');
  writeln(l_texte, 'FIELD3=xNAISSANCE,DATE,20,0,0');
  writeln(l_texte, 'FIELD4=xPOIDS,FLOAT,20,0,0');

  System.Close(l_texte);
{
  With BatchMove1 do
  begin
    Mappings.Clear;
    Mappings.Add('xNOM=Nom');
    Mappings.Add('xNUMERO=NUMERO');
    Mappings.Add('xNAISSANCE=NAISSANCE');
    Mappings.Add('xPOIDS=POIDS');

    Execute;
    Table2.Open;
  end;
  exit;
}
  System.Assign(l_texte, 'C:\OSCAR\'+ g_nom+ '.TXT');
  Rewrite(l_texte);

  With Table1 do
  begin
    Open;
    First;

    while not eof do
    begin
{
      DecimalSeparator:= '.';
}
      Writeln(l_texte, k_delimiteur+ FieldByName('NOM').AsString+ k_delimiteur,
         + k_separateur+ FieldByName('NUMERO').AsString
         + k_separateur+ FieldByName('NAISSANCE').AsString
         + k_separateur+ FieldByName('POIDS').AsString
         );
{
      DecimalSeparator:= ',';
}

      Next;
    end; (* while *)
  end; (* with *)

  Write(l_texte, chr(26));
  System.Close(l_texte);
end;

procedure TForm1.TXT_Bat_CopyClick(Sender: TObject);
begin
  Table3.BatchMove(Table2, BatCopy);
end;

  type t_extrais= record
                    ligne: String;
                    separateur, delimiteur: Char;
                    taille_ligne, indice_ligne: Integer;
                    mot: String;
                  end;

  var g_tailles: array[0..99] of Word;

  function f_extrais(var pv_extrais: t_extrais): String;
    var l_indice_debut: Integer;
    begin
      with pv_extrais do
      begin
        while (indice_ligne<= taille_ligne) and (ligne[indice_ligne]= ' ') do
          inc(indice_ligne);

        if indice_ligne<= taille_ligne
          then begin
              if ligne[indice_ligne]= delimiteur
                then begin
                    inc(indice_ligne);
                    l_indice_debut:= indice_ligne;
                    while (indice_ligne<= taille_ligne) and (ligne[indice_ligne]<> delimiteur) do
                      inc(indice_ligne);
                    Move(ligne[l_indice_debut], mot[1], indice_ligne- l_indice_debut);
                    mot[0]:= chr(indice_ligne- l_indice_debut);
                    inc(indice_ligne);
                  end
                else begin
                    l_indice_debut:= indice_ligne;
                    while (indice_ligne<= taille_ligne) and (ligne[indice_ligne]<> separateur) do
                      inc(indice_ligne);
                    Move(ligne[l_indice_debut], mot[1], indice_ligne- l_indice_debut);
                    mot[0]:= chr(indice_ligne- l_indice_debut);
                  end;

              (* -- saute le sparateur *)
              inc(indice_ligne);
            end;

        Result:= mot;
      end; (* with *)
    end; (* f_extrais *)

  procedure cree_table(p_sch: tStrings);
    var l_indice_sch: Integer;
        l_cle, l_numero: String;
        l_extrais: t_extrais;
        l_nom, l_chaine_type: String;
        l_type: tFieldType;
        l_taille, l_position: Integer;
        l_indice_champ: Integer;
    begin
      with Form1 do
      begin
        Table3.Close;
        Table3.FieldDefs.Clear;

        with p_sch, l_extrais do
        begin
          delimiteur:= chr(0);
          l_indice_champ:= 0;

          for l_indice_sch:= 0 to Count- 1 do
          begin
            ligne:= p_sch[l_indice_sch];
            System.Move(ligne[1], l_cle[1], 5);
            l_cle[0]:= chr(5);

            if UpperCase(l_cle)= 'FIELD'
              then begin
                  affiche(l_cle);
                  (* -- suppose que pas espace aprs FIELDxxx *)
                  indice_ligne:= 1; taille_ligne:= Length(ligne);
                  separateur:= '=';
                  f_extrais(l_extrais);
                  l_numero:= Copy(ligne, 6, Length(mot)+ 1- 6);
                  affiche(mot+ ' '+ l_numero+ '<');

                  separateur:= ',';
                  l_nom:= f_extrais(l_extrais);

                  l_chaine_type:= UpperCase(f_extrais(l_extrais) );
                  if l_chaine_type= 'CHAR'
                    then l_type:= ftString
                    else
                      if l_chaine_type= 'FLOAT'
                        then l_type:= ftFloat
                        else
                          if l_chaine_type= 'NUMBER'
                            then l_type:= ftSmallInt
                            else
                              if l_chaine_type= 'LONGINT'
                                then l_type:= ftInteger
                                else
                                  if l_chaine_type= 'DATE'
                                    then l_type:= ftDate
                                    else
                                      if l_chaine_type= 'BOOL'
                                        then l_type:= ftBoolean;

                  f_extrais(l_extrais);
                  l_taille:= StrToInt(mot);
                  (* -- pour les formats fixes *)
                  g_tailles[l_indice_champ]:= l_taille;
                  if l_type<> ftString
                    then l_taille:= 0;

                  affiche(l_nom+ ' '+ IntToStr(Ord(l_type))+ ' '+ IntToStr(l_taille));

                  Table3.FieldDefs.Add(l_nom, l_type, l_taille, True);
                  inc(l_indice_champ);
                end;
          end; (* for l_indice *)

          Table3.CreateTable;
          Table3.Open;
        end; (* with l_chaines *)
      end; (* with *)
    end; (* cree_table *)

  procedure traite_fixe(p_nom_txt: String);
    var l_texte: System.Text;
        l_extrais: t_extrais;
        l_resultat: String;
        l_indice_champ: Integer;
    begin (* traite_delimite *)
      System.Assign(l_texte, p_nom_txt);
      Reset(l_texte);

      with l_extrais do
        While not Eof(l_texte) do
        begin
          Readln(l_texte, ligne);

          taille_ligne:= Length(ligne); indice_ligne:= 1;
          l_resultat:= '/';

          Form1.Table3.Append;
          l_indice_champ:= 0;

          While indice_ligne<= taille_ligne do
          begin
            Move(ligne[indice_ligne], mot[1], g_tailles[l_indice_champ]);
            mot[0]:= chr(g_tailles[l_indice_champ]);
            l_resultat:= l_resultat+ mot+ '/';

            Form1.Table3.Fields[l_indice_champ].AsString:= mot;

            inc(indice_ligne, g_tailles[l_indice_champ]);
            inc(l_indice_champ);
          end;
{
          for l_indice_champ:= 0 to Form1.Table3.FieldCount- 1 do
            l_resultat:= l_resultat+ IntToStr(g_tailles[l_indice_champ])+ '/';
}
          affiche(l_resultat);

          Form1.Table3.Post;
        end; (* while *)

      System.Close(l_texte);
    end; (* traite_fixe *)

  procedure traite_delimite(p_nom_txt: String; p_delimiteur, p_separateur: Char);
    var l_texte: System.Text;
        l_extrais: t_extrais;
        l_resultat: String;
        l_indice_champ: Integer;
    begin (* traite_delimite *)
      System.Assign(l_texte, p_nom_txt);
      Reset(l_texte);
      if p_delimiteur<> chr(0)
        then affiche('Dlim >'+ p_delimiteur+ '<');
      if p_separateur<> chr(0)
        then affiche('Spar >'+ p_separateur+ '<');

      with l_extrais do
      begin
        delimiteur:= p_delimiteur; separateur:= p_separateur;

        While not Eof(l_texte) do
        begin
          Readln(l_texte, ligne);

          taille_ligne:= Length(ligne); indice_ligne:= 1;
          l_resultat:= '/';

          Form1.Table3.Append;
          l_indice_champ:= 0;

          While indice_ligne<= taille_ligne do
          begin
            f_extrais(l_extrais);
            l_resultat:= l_resultat+ mot+ '/';

            Form1.Table3.Fields[l_indice_champ].AsString:= mot;
            inc(l_indice_champ);
          end;

          affiche(l_resultat);
          Form1.Table3.Post;
        end; (* while *)
      end;

      System.Close(l_texte);
    end; (* traite_delimite *)

  procedure relis(p_nom_sch, p_nom_txt: String; p_cree: Boolean);
    var l_format: tIniFile;
        l_chaines: tStringList;
        l_separateur, l_delimiteur: Char;
    begin
      l_format:= tIniFile.Create(p_nom_sch);
      l_chaines:= tStringList.Create;

      l_format.ReadSectionValues(g_nom, l_chaines);
      Form1.Memo1.Lines.Assign(l_chaines);

      cree_table(l_chaines);

      if l_chaines.Values['FILETYPE']= 'FIXED'
        then traite_fixe(p_nom_txt)
        else begin
            if Length(l_chaines.Values['DELIMITER'])> 0
              then l_delimiteur:= l_chaines.Values['DELIMITER'][1]
              else l_delimiteur:= chr(0);
            If Length(l_chaines.Values['SEPARATOR'])> 0
              then l_separateur:= l_chaines.Values['SEPARATOR'][1]
              else l_separateur:= chr(0);

            traite_delimite(p_nom_txt, l_delimiteur, l_separateur );
          end;

      l_chaines.Free;
      l_format.Free;
    end;

procedure TForm1.lis_TXTClick(Sender: TObject);
begin
  relis('C:\OSCAR\'+ g_nom+ '.SCH', 'C:\OSCAR\'+ g_nom+ '.TXT', False)
end;

procedure TForm1.cree_et_lis_TXTClick(Sender: TObject);
begin
  relis('C:\OSCAR\'+ g_nom+ '.SCH', 'C:\OSCAR\'+ g_nom+ '.TXT', True)
end;

procedure TForm1.affiche_DBFClick(Sender: TObject);
begin
  Table1.Close;

  DataSource1.DataSet:= Table3;
  Table3.Open;
  dbGrid1.Update;
end;

end.

