(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_cleres *)

unit U_cleres;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    cree_cles: TButton;
    Table1: TTable;
    genere: TButton;
    Memo1: TMemo;
    ajoute_cle: TButton;
    procedure cree_clesClick(Sender: TObject);
    procedure genereClick(Sender: TObject);
    procedure ajoute_cleClick(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  procedure affiche(p_texte: String);
    const vi_numero: Integer= 0;
    begin
      Form1.Memo1.Lines.Add(Format('%3d ', [vi_numero])+ p_texte);
      inc(vi_numero)
    end;

procedure TForm1.cree_clesClick(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='CLES.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('TABLE', ftString, 8, True);
    FieldDefs.Add('CLE', ftInteger, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_TABLE', 'TABLE', []);

    CreateTable;

    Open;
  end;
end;

procedure TForm1.ajoute_cleClick(Sender: TObject);
begin
  with Table1 do
  begin
    Close;
    Exclusive:= True;
    Open;
    if FindKey(['FACTURE'])
      then affiche('existe dj')
      else begin
          AppendRecord(['FACTURE', 0]);
        end;
    Close;
    Exclusive:= False;
  end;
end;

  function f_est_verrouillee: Boolean;
    begin
      try
        Form1.Table1.Edit;
        Result:= True;
      except
        On eDatabaseError do
          result:= False;
      end;
    end; (* f_est_verrouillee *)

  function f_cle(p_nom_table: String): LongInt;
    begin
      with Form1, Table1 do
      begin
        Open;
        if FindKey(['FACTURE'])
          then begin
              While not f_est_verrouillee do
                Table1.Refresh;

              With FieldByName('CLE') do
              begin
                Result:= AsInteger;
                AsInteger:= AsInteger+ 1;
              end;
              Post;
            end
          else begin
              affiche('ajouter numro pour '+ p_nom_table);
              Result:= -1;
            end;
      end; (* with *)
    end; (* f_cle *)

procedure TForm1.genereClick(Sender: TObject);
begin
  affiche(IntToStr(f_cle('FACTURE')));
end;

end.
