(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_maidet *)

unit U_maidet;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Memo1: TMemo;
    Table2I_NUM_FACT: TFloatField;
    Table2I_LIBELLE: TStringField;
    Table2I_PRIX: TFloatField;
    Table2I_QUANTITE: TFloatField;
    procedure Table2BeforePost(DataSet: TDataset);
    procedure Table2AfterPost(DataSet: TDataset);
    procedure Table2BeforeEdit(DataSet: TDataset);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

  function f_espaces(p_nombre: Integer): String;
    begin
      Result:= Format('%'+ IntToStr(p_nombre)+ 's', ['']);
    end; (* f_espaces *)

  procedure affiche(p_texte: String);
    const vi_numero: Integer= 0;
    begin
      Form1.Memo1.Lines.Add(Format('%3d ', [vi_numero])+ p_texte);
      inc(vi_numero)
    end;

var g_total_precedent: Double;

procedure TForm1.Table2BeforeEdit(DataSet: TDataset);
begin
  with Table2 do
    g_total_precedent:= Table2I_PRIX.AsFloat* Table2I_QUANTITE.AsFloat;
end;

const vi_nombre: Integer= 0;

procedure TForm1.Table2BeforePost(DataSet: TDataset);
const vi_a_fini: Boolean= False;
begin
  affiche('');
  affiche(f_espaces(vi_nombre* 2)+ 'Dtail.OnBeforePost');
  inc(vi_nombre);
  vi_a_fini:= False;

  if vi_nombre> 3
    then begin
        affiche('BUG abort');
        Abort;
      end;

  if vi_nombre= 1
    then begin
        Table1.Edit;
        (* -- ici Dtail est Post *)

        (* -- fin du traitement sur Matre *)
        affiche(f_espaces(vi_nombre* 2)+ 'finis Matre');
        Table1.FieldByName('F_TOTAL').AsFloat:=
            Table1.FieldByName('F_TOTAL').AsFloat
            + Table2I_PRIX.AsFloat* Table2I_QUANTITE.AsFloat
            - g_total_precedent;

        Table1.Post;

        dec(vi_nombre);
        if vi_a_fini
          then Abort;
      end
    else begin
        (* traitements sur Dtail avant Post *)
        affiche(f_espaces(vi_nombre* 2)+ 'traite Dtail av post ');
      end;

  dec(vi_nombre);
  vi_a_fini:= True;
end;

procedure TForm1.Table2AfterPost(DataSet: TDataset);
begin
  affiche(f_espaces(vi_nombre* 2)+ 'Dtail.OnAfterPost');
end;

end.
