(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_tabloc *)

unit U_tabloc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    confirme: TButton;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1NOM: TStringField;
    Table1MONTANT: TFloatField;
    debute: TButton;
    procedure confirmeClick(Sender: TObject);
    procedure debuteClick(Sender: TObject);
  private
    procedure Table2NOMValidate(Sender: TField);
    procedure Table2VALEURValidate(Sender: TField);
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Table2NOMValidate(Sender: TField);
begin
  If Table1.FindKey([Sender.AsString])
    then begin
        Table2.FieldByName('MONTANT').AsFloat:= Table1.FieldByName('MONTANT').AsFloat;

        dbGrid2.Invalidate;
        dbGrid2.Update;
      end
    else begin
        ShowMessage('pas cl');
        Abort;
      end;
end;

procedure tForm1.Table2VALEURValidate(Sender: TField);
begin
  If Table1.FindKey([Table2.FieldByName('NOM').AsString])
    then begin
        Table2.FieldByName('MONTANT').AsFloat:=
            Table1.FieldByName('MONTANT').AsFloat
            + Table2.FieldByName('VALEUR').AsFloat;

        dbGrid2.Invalidate;
        dbGrid2.Update;
      end
    else begin
        ShowMessage('pas cl');
        Abort;
      end;
end;

procedure TForm1.debuteClick(Sender: TObject);
begin
  With Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='RESEAU_2.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('VALEUR', ftFloat, 0, True);
    FieldDefs.Add('MONTANT', ftFloat, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;
    IndexName:= 'IND_NOM';

    Open;
    FieldByName('NOM').OnValidate:= Table2NOMValidate;
    FieldByName('VALEUR').OnValidate:= Table2VALEURValidate;
  end;
end;

procedure TForm1.confirmeClick(Sender: TObject);
begin
  With Table2 do
  begin
    First;
    While not Eof do
    begin
      If Table1.FindKey([Table2.FieldByName('NOM').AsString])
        then begin
            Table1.Edit;
            Table1.FieldByName('MONTANT').AsFloat:=
              FieldByName('MONTANT').AsFloat;
          end;
      Next;
    end;
  end; (* with *)
end;

end.


