(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_cfg *)
(* 21 aou 95 *)

(*$r+*)
unit U_cfg;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, dbConsts;

{$R *.DFM}

function f_verifie_dbi(p_valeur: Integer): Boolean;
  var l_chaine_z: array[0..DbiMaxMsgLen] of char;
      l_chaine: String;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);

          l_chaine:= StrPas(l_chaine_z);
          l_chaine:= IntToStr(p_valeur)+ ' '+ l_chaine;
          ShowMessage('erreur Dbi: '+ l_chaine);
        end;

    f_verifie_dbi:= p_valeur= 0;
  end; (* f_verifie_dbi *)

procedure recupere_info(p_chemin: String; p_chaines: tStrings);
(* -- a fourni la cl. Rcupre uniquement l'information *)
var l_curseur_dbi: hDbiCur;
    l_descripteur: CfgDesc;
begin
  p_chaines.CLear;

  p_chemin:= p_chemin+ chr(0);
  if f_verifie_dbi(DbiOpenCfgInfoList(nil, DbiReadOnly, cfgPersistent,
      @p_chemin[1], l_curseur_dbi))
    then
      while DbiGetNextRecord(l_curseur_dbi, dbiNOLOCK, @l_descripteur, nil) = 0 do
        with l_descripteur do
          p_chaines.Add(StrPas(szNodeName)+ '='+ StrPas(szValue)+ '<');
  end; (* recupere_info *)

procedure recupere_cfg(p_chemin: String; p_niveau: Integer; p_chaines: tStrings);
var l_curseur_dbi: hDbiCur;
    l_descripteur: CfgDesc;
    l_chemin, l_sous_chemin: String;
    l_resultat: Integer;
begin
  if p_niveau= 0
    then p_chaines.CLear;

  l_chemin:= p_chemin+ chr(0);

  l_resultat:= DbiOpenCfgInfoList(nil, DbiReadOnly, cfgPersistent,
      @l_chemin[1], l_curseur_dbi);

  if l_resultat= 0
    then begin
        while DbiGetNextRecord(l_curseur_dbi, dbiNOLOCK, @l_descripteur, nil) = 0 do
          with l_descripteur do
          begin
            if p_chemin[Length(p_chemin)]<> '\'
              then p_chaines.Add(p_chemin+ '    '+ StrPas(szNodeName)+ '='+ StrPas(szValue));

            l_sous_chemin:= p_chemin+ StrPas(szNodeName);
            recupere_cfg(l_sous_chemin+ '\', p_niveau+ 2, p_chaines);
          end; (* while, with *)
      end
    else begin
        if p_chemin[Length(p_chemin)]= '\'
          then begin
               Delete(p_chemin, Length(p_chemin), 1);
               recupere_cfg(p_chemin, p_niveau, p_chaines);
             end
      end;
  end; (* recupere_cfg *)

(* -- exemples d'utilisation *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  recupere_info('\SYSTEM\INIT', ListBox1.Items);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  recupere_info(Edit1.Text, ListBox1.Items);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  recupere_cfg('\', 0, ListBox1.Items);
end;

(* -- copie disque *)

procedure TForm1.Button4Click(Sender: TObject);
begin
  ListBox1.Items.SaveToFile('a:CFG.PAS');
end;

end.




