(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_alicfg *)
(* 25 aou 95 *)

(*$r+*)
unit U_alicfg;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    ListBox2: TListBox;
    ListBox3: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
  private
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs, dbConsts;

{$R *.DFM}

function f_verifie_dbi(p_valeur: Integer): Boolean;
  var l_chaine_z: array[0..DbiMaxMsgLen] of char;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);

          ShowMessage('erreur Dbi: '+ IntToStr(p_valeur)+ ' '+ StrPas(l_chaine_z));
        end;

    f_verifie_dbi:= p_valeur= 0;
  end; (* f_verifie_dbi *)

procedure recupere_info(p_chemin: String; p_chaines: tStrings);
(* -- a fourni la cl. Rcupre uniquement l'information *)
var l_curseur_dbi: hDbiCur;
    l_descripteur: CfgDesc;
begin
  p_chaines.Clear;

  p_chemin:= p_chemin+ chr(0);
  if f_verifie_dbi(DbiOpenCfgInfoList(nil, DbiReadOnly, cfgPersistent,
      @p_chemin[1], l_curseur_dbi))
    then
      while DbiGetNextRecord(l_curseur_dbi, dbiNOLOCK, @l_descripteur, nil) = 0 do
        with l_descripteur do
          p_chaines.Add(StrPas(szNodeName)+ '='+ StrPas(szValue)+ '<');
  end; (* recupere_info *)

(* -- exemples d'utilisation *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  recupere_info('\DATABASES', ListBox1.Items);
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var l_cle: String;
begin
  l_cle:= ListBox1.Items[ListBox1.ItemIndex];
  (* -- supprime =< *)
  Delete(l_cle, Length(l_cle)- 1, 2);

  recupere_info('\DATABASES\'+ l_cle, ListBox2.Items);
end;

procedure TForm1.ListBox2Click(Sender: TObject);
var l_cle_1, l_cle_2: String;
begin
  l_cle_1:= ListBox1.Items[ListBox1.ItemIndex];
  Delete(l_cle_1, Length(l_cle_1)- 1, 2);

  l_cle_2:= ListBox2.Items[ListBox2.ItemIndex];
  Delete(l_cle_2, Length(l_cle_2)- 1, 2);

  recupere_info('\DATABASES\'+ l_cle_1+ '\'+ l_cle_2, ListBox3.Items);
end;

end.




