(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* -- dfinit un alias temporaire avec composant DataBase *)
(* -- que conception *)

unit U_databa;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Database1: TDatabase;
    Table1: TTable;
    Table2: TTable;
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Database2: TDatabase;
    Table3: TTable;
    Button3: TButton;
    Table4: TTable;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private-dclarations }
    procedure affiche(p_database: tDatabase);
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.affiche(p_database: tDatabase);
  begin
    With p_database, ListBox1, Items do
    begin
      Clear;
      Items.Assign(Params);
      Insert(0, 'AliasName: '+AliasName);
      Insert(1, 'DatabaseName: '+ DatabaseName);
      Insert(2, 'DriverName: '+ DriverName);
      Insert(3, 'Params: ');
    end;
  end; (* affiche *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  affiche(Table2.Database);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  affiche(Table3.Database);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  affiche(Table1.Database);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  affiche(Table4.Database);
end;

end.
