(* 001 u_creifo *)

unit U_creifo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    Query1: TQuery;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Database1: TDatabase;
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiErrs;

{$R *.DFM}

(*$i ..\..\u\f_errdbi *)

procedure TForm1.Button1Click(Sender: TObject);
var l_erreur: String;
begin
  Table1.DatabaseName:= 'FlixFox';
{
  If Not Assigned(Table1.Database)
    then begin
      MessageBeep(0);
      exit;
    end;
}
  Table1.Database.LoginPrompt:= False;
  Table1.Open;
  exit;


  Query1.Sql.Clear;

{
  Query1.Sql.Add('CREATE TABLE CREE_ISQ.DBF"');
}
  Query1.Sql.Add('CREATE TABLE "CREEISQ"');
  Query1.Sql.Add(' (NOM CHAR(5),  AGE NUMERIC(3,0), HAUTEUR FLOAT(7,5))');
  (* NOK
  Query1.Sql.Add('CREATE INDEX [LA x] ON "CREE_ISQ.DBF" (CLIENT)');
  *)

  Query1.ExecSql;

  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix_fox';

    TableName:= 'CREE_I_F.DBF';
{
    TableType:= ttdBase;
}

    TRY
      FieldDefs.Clear;

      FieldDefs.Add('CLIENT', ftString, 10, True);
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            DbiErr_InvalidFieldName : l_erreur:= 'nom zone incorrect';
            else l_erreur:= ' Dbi '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ ' = '+ f_erreur_dbi(ErrorCode) );
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* except *)


    Table1.Open;
  end;
end;

end.
