(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_copdef *)

unit U_copdef;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, StdCtrls, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    Table2: TTable;
    ListBox1: TListBox;
    ListBox2: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListBox2DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var l_indice: Integer;
begin
  with Table1 do
    For l_indice:= 0 to FieldDefs.Count- 1 do
      with FieldDefs[l_indice] do
        ListBox1.Items.Add(Name);
end;

procedure TForm1.ListBox2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept:= True;
end;

procedure TForm1.ListBox2DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  ListBox2.Items.Add(ListBox1.Items[ListBox1.ItemIndex]);
end;

procedure TForm1.Button1Click(Sender: TObject);
var l_indice: Integer;
    l_field_def: tFieldDef;
begin
  With Table2 do
  begin
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:= 'COP_STRU';
    FieldDefs.Clear;

    For l_indice:= 0 to ListBox2.Items.Count- 1 do
    begin
      l_field_def:= Table1.FieldDefs.Find(ListBox2.Items[l_indice]);

      With l_field_def do
        FieldDefs.Add(Name, DataType, Size, Required);
    end; (* for *)

    CreateTable;

    Open;
  end; (* with *)
end;

end.
