(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright 1996 MNEMODYNE -*)


(* 001 u_creide *)

unit U_creide;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiErrs;

{$R *.DFM}

(*$i ..\..\u\f_errdbi *)

procedure TForm1.Button1Click(Sender: TObject);
var l_erreur: String;
begin
  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix';

    TableName:= 'CREE_I_D';
    TableType:= ttdBase;

    TRY
      FieldDefs.Clear;

      FieldDefs.Add('NUMERO', ftSmallInt, 0, True);
      FieldDefs.Add('CLIENT', ftString, 10, True);
      FieldDefs.Add('SOLDE', ftFloat, 0, True);

      IndexDefs.Clear;
      IndexDefs.Add('IND_NUMERO', 'NUMERO', []);

      CreateTable;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            DbiErr_InvalidFieldName : l_erreur:= 'nom zone incorrect';
            else l_erreur:= ' Dbi '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ ' = '+ f_erreur_dbi(ErrorCode) );
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* except *)

    Table1.Open;
  end;
end;

end.
