(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_creisq *)

unit U_creisq;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, DB, DBTables, StdCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    Query1: TQuery;
    Button3: TButton;
    DataSource1: TDataSource;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  Form1: TForm1;

implementation
  uses DbiProcs, DbiTypes, DbiErrs;

{$R *.DFM}

(*$i ..\..\u\i_e_dbi1 *)

procedure TForm1.Button1Click(Sender: TObject);
begin
  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix';

    TableName:= 'CREE_ISQ';
    TableType:= ttdBase;

    FieldDefs.Clear;

    FieldDefs.Add('NUMERO', ftSmallInt, 0, True);
    FieldDefs.Add('CLIENT', ftString, 10, True);
    FieldDefs.Add('SOLDE', ftFloat, 0, True);

    IndexDefs.Clear;
    CreateTable;

    Open;

    AppendRecord([1, 'Joe', 3.14]);
    AppendRecord([2, 'Sam', 3.14]);
    AppendRecord([1, 'Gus', 3.14]);
    AppendRecord([4, 'Joe', 3.14]);
    Close;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin

  Query1.Close;

  Query1.DatabaseName:= 'Flix';

  Query1.Sql.Clear;

  Query1.Sql.Add('CREATE INDEX IND_SQL ON "CREE_ISQ.DBF" (CLIENT)');
  (* NOK
  Query1.Sql.Add('CREATE INDEX [LA x] ON "CREE_ISQ.DBF" (CLIENT)');
  *)

  Query1.ExecSql;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  WITH Table1 DO
  BEGIN
    DatabaseName:= 'Flix';

    TableName:= 'CREE_ISQ';
    TableType:= ttdBase;
    IndexName:= 'IND_SQL';
    Open;
  end;
end;

end.
