(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_affouv *)

unit U_affouv;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    Table2: TTable;
    procedure Button1Click(Sender: TObject);
    procedure open_Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='AFFICHE';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('PRENOM', ftString, 7, True);
    FieldDefs.Add('AGE', ftInteger, 0, True);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);

    CreateTable;

    AddIndex('IND_NOMPRE', 'NOM + PRENOM', [ixExpression]);

    Table1.Open;

    AppendRecord([1, 'MARTIN', 'Jean', 31]);
    AppendRecord([2, 'BELIN', 'Ernest', 6]);
    AppendRecord([4, 'ZOE', 'Alice', 18]);
    AppendRecord([3, 'BELIN', 'Albert', 77]);
  end; (* with Table *)
end;

(*$i ..\..\u\f_errdbi *)

procedure TForm1.open_Click(Sender: TObject);
var l_erreur: String;
    l_mode_erreur: Word;
begin
{
  Table1.Active:= Not Table1.Active;
}
{
    TRY
      Table1.DatabaseName:= 'A:';
      l_mode_erreur:= SetErrorMode(SEM_FailCriticalErrors);
      Table1.Open;
      SetErrorMode(l_mode_erreur);
}
      Table1.DatabaseName:= 'Flix';
      Table1.TableType:= ttdBase;
      Table1.TableName:= 'AFFICHE';

      Table1.Open;
    TRY
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END;

  exit;

  If Table1.Active
    Then begin
        Table1.Close;
        Canvas.TextOut(1, 1, 'ouverte');
      end
    else begin
        Table1.Open;
        Canvas.TextOUt(1, 1, 'Ferme');
      end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_erreur: String;
begin
  With Table2 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='AFFICHE';
    Exclusive:= True;
    TRY
      Open;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END;

  end;
end;

end.
