(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_chenum *)

(*$r+*)
unit U_chenum;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

function f_verifie_dbi(p_valeur: Integer): Boolean;
  var l_chaine_z: array[0..DbiMaxMsgLen] of char;
  begin
    if p_valeur<> 0
      then begin
          DbiGetErrorString(p_valeur, @l_chaine_z);

          ShowMessage('erreur Dbi: '+ IntToStr(p_valeur)+ ' '+ StrPas(l_chaine_z));
        end;

    f_verifie_dbi:= p_valeur= 0;
  end; (* f_verifie_dbi *)

  function f_numero_fiche(p_table: tTable): LongInt;
    var l_attributs: RECProps;
    begin
      p_table.UpdateCursorPos;
      if f_verifie_dbi(DbiGetRecord(p_table.Handle, dbiNOLOCK, nil, @l_attributs))
        then f_numero_fiche:= l_attributs.iPhyRecNum
        else f_numero_fiche:= -1;
    end; (* f_numero_fiche *)

procedure TForm1.Button1Click(Sender: TObject);
var l_erreur: String;
    l_attributs: RECProps;
begin
  Edit1.Text:= IntToStr(f_numero_fiche(Table1));
end;

end.
