(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 creche *)
(* 21 nov 95 *)

(* -- cree la table pour les recherches *)

unit U_creche;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:='CHERCHE';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('PRENOM', ftString, 7, True);
    FieldDefs.Add('POIDS', ftFloat, 0, True);
    FieldDefs.Add('NAISSANCE', ftDate, 0, False);
    FieldDefs.Add('GRAND', ftBoolean, 0, False);

    IndexDefs.Clear;
    IndexDefs.Add('IND_NOM', 'NOM', []);
    IndexDefs.Add('IND_PRENOM', 'PRENOM', []);
    IndexDefs.Add('IND_POIDS', 'POIDS', []);
    IndexDefs.Add('IND_DATE', 'NAISSANCE', []);

    CreateTable;

    AddIndex('IND_NOMPRE', 'NOM + PRENOM', [ixExpression]);
    AddIndex('IND_PREMAJ', 'UPPER(PRENOM)', [ixExpression]);

    Open;

    AppendRecord([1, 'MARTIN', 'Jean', 51.300, '1/2/45', True]);
    AppendRecord([2, 'MARTIN', 'Anna', 51.300, '1/2/45', True]);
    AppendRecord([3, 'BELIN', 'Ernest', 60, '1/3/2010', False]);
    AppendRecord([4, 'MARTIN', 'Ursule', 51.300, '1/2/45', True]);
    AppendRecord([5, 'SCHMITT', 'Sylvie', 1e23, '28/2/95', False]);

{
    AppendRecord([4, 'BELIN', 'Alexandre', 1.23456789, '2/2/64', False]);
    AppendRecord([1, 'MARTINI', 'Jean', 51.300, '1/2/45', True]);
    AppendRecord([0, '', ' AB''C ', 0, '1/1/0']);
    AppendRecord([1, 'MARTE', 'Jean', 51.300, '1/2/45', True]);
}
{
    AppendRecord([1, 'G', 'Jean', 51.300, '1/2/45', True]);
    AppendRecord([1, 'A', 'Jean', 51.300, '1/2/45', True]);
    AppendRecord([4, 'E', 'Alexandre', 1.23456789, '2/2/64', False]);
    AppendRecord([2, 'B', 'Ernest', 60, '1/3/2010', False]);
    AppendRecord([3, 'D', 'Sylvie', 1e23, '28/2/95', False]);
    AppendRecord([0, 'H', ' AB''C ', 0, '1/1/0']);
}
{
    AppendRecord([1, 'A', 'Jean', 51.300, '1/2/45', True]);
    AppendRecord([2, 'B', 'Jean', 51.300, '1/2/45', True]);
    AppendRecord([3, 'C', 'Alexandre', 1.23456789, '2/2/64', False]);
    AppendRecord([4, 'CA', 'Ernest', 60, '1/3/2010', False]);
    AppendRecord([5, 'CB', 'Sylvie', 1e23, '28/2/95', False]);
    AppendRecord([6, 'D', ' C ', 0, '1/1/0']);
}
  end; (* with Table *)
end;

end.
