(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ranex2 *)

unit U_ranex2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    range: TButton;
    Edit2: TEdit;
    compte: TButton;
    Button1: TButton;
    Button2: TButton;
    procedure rangeClick(Sender: TObject);
    procedure compteClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const vi_debut_exclusive: Boolean= False;
      vi_fin_exclusive: Boolean= False;

procedure TForm1.rangeClick(Sender: TObject);
begin
  with Table1 do
  begin
    SetRangeStart;
    KeyExclusive:= vi_debut_exclusive;
    Fields[1].AsString:= Edit1.Text;

    SetRangeEnd;
    KeyExclusive:= vi_fin_exclusive;
    Fields[1].AsString:= Edit2.Text;

    ApplyRange;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  vi_debut_exclusive:= not vi_debut_exclusive;
  if vi_debut_exclusive
    then Button1.Caption:= 'KeyExclusive True'
    else Button1.Caption:= 'KeyExclusive False';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  vi_fin_exclusive:= not vi_fin_exclusive;
  if vi_fin_exclusive
    then Button2.Caption:= 'KeyExclusive True'
    else Button2.Caption:= 'KeyExclusive False';
end;

procedure TForm1.compteClick(Sender: TObject);
var l_nombre: Integer;
begin
  Table1.SetKey;
  Table1.Fields[1].AsString:= Edit1.Text;
  Table1.GotoKey;
  l_nombre:= 0;

  While Not Table1.Eof do
  begin
    inc(l_nombre);
    Table1.Next;
  end;

  compte.Caption:= 'RecordCount '+ IntToStr(Table1.RecordCount)+ ' compte '+ IntToStr(l_nombre);
end;

end.
