(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_esssql *)

unit U_esssql;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button2: TButton;
    Query1: TQuery;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Database1: TDatabase;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (* $i ..\..\u\i_errdbi *)

  var l_erreur: String;


{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  With Table1 do
  begin
    Close;
    DatabaseName:= 'Flix';

    TableType:= ttdBase;
    TableName:='E_SQL';

{
    TableType:= ttParadox;
    TableName:='E_SQL_PX';
}
    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('NOM', ftString, 10, True);
    FieldDefs.Add('PRENOM', ftString, 7, True);
    FieldDefs.Add('POIDS', ftFloat, 0, True);
    FieldDefs.Add('NAISSANCE', ftDate, 0, False);
    FieldDefs.Add('GRAND', ftBoolean, 0, False);

    CreateTable;

    Open;

    AppendRecord([1, 'MARTIN', 'Jean', 51.300, '1/2/45', True]);
    AppendRecord([2, 'MARTIN', 'Anna', 51.300, '1/2/45', True]);
    AppendRecord([3, 'MARTIN', 'Ursule', 51.300, '1/2/45', True]);
    AppendRecord([4, 'BELIN', 'Ernest', 60, '1/3/2010', False]);
    AppendRecord([5, 'SCHMITT', 'Sylvie', 1e23, '28/2/95', False]);
    AppendRecord([3, 'MARSIN', 'Ursule', 51.300, '1/2/45', True]);
  end; (* with Table *)
end;

(*$i ..\..\u\f_errdbi *)

procedure TForm1.Button2Click(Sender: TObject);
begin
  Query1.Close;
  Query1.Sql.Clear;

{
  (* NON *)
  Query1.Sql.Add('SELECT "NU MERO" FROM "E_SQL_PX.DB"');
  (* OK *)
  Query1.Sql.Add('SELECT e_sql_px.''NU MERO'' FROM "E_SQL_PX.DB"');

  (* OK *)
  Query1.Sql.Add('SELECT s."DATE"  FROM "E_SQL.DBF" s');
  (* OK *)
  Query1.Sql.Add('SELECT s."DATE" FROM "E_SQL.DBF" s');
  Query1.Sql.Add(' WHERE s."DATE"= ''MARTIN'' ');
  (* OK *)
  Query1.Sql.Add('SELECT s."DATE" FROM "E_SQL.DBF" AS s');
  Query1.Sql.Add(' WHERE s."DATE"= ''MARTIN'' ');

  (* OK , si alias ouvert *)
  Query1.Sql.Add('SELECT PRENOM FROM ":Flix:E_SQL.DBF"');
  (* OK *)
  Query1.Sql.Add('SELECT PRENOM FROM "C:\OSCAR\E_SQL" ');
  (* OK , si alias ouvert *)
  Query1.Sql.Add('SELECT PRENOM FROM ::Flix::E_SQL');

  (* NON: field x not found *)
  Query1.Sql.Add('SELECT s."PRENOM" AS x FROM "E_SQL.DBF" s');
  Query1.Sql.Add(' WHERE x= ''Jean'' ');
  (* champ existe pas *)
  Query1.Sql.Add('SELECT e_sql."PRENOM" x FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE x= ''Jean'' ');
  Query1.Sql.Add('SELECT e_sql.PRENOM x FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE x= ''Jean'' ');
  (* OK *)
  Query1.Sql.Add('SELECT e_sql.PRENOM x FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  ORDER BY x ');

(* WHERE *)
  (* OK *)
  Query1.Sql.Add('SELECT NOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE GRAND= ''TRUE'' ');
}
{
  (* OK *)
  Query1.Sql.Add('SELECT NOM, NAISSANCE FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NOM= ''eee'' ');
  (* OK *)
  Query1.Sql.Add('SELECT NOM, NAISSANCE FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NAISSANCE= "2/28/95" ');
  (* NON OK *)
  Query1.Sql.Add('SELECT NOM, NAISSANCE FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NAISSANCE= "28/2/95" ');
  (* vide *)
  Query1.Sql.Add('SELECT NOM, NAISSANCE FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NAISSANCE= 2/28/95 ');
  (* OK *)
  Query1.Sql.Add('SELECT NOM, NAISSANCE FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE (NOM= "MARTIN") AND (PRENOM= "Jean") ');
  (* OK *)
  Query1.Sql.Add('SELECT NOM, NAISSANCE FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NOT (NOM= "MARTIN") ');
  (* OR pas compris *)
  Query1.Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE (NOM= "MARTIN") OR (PRENOM<> "Jean") AND (NUMERO=5) ');
  (* idem *)
  Query1.Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE (NOM= "MARTIN") OR ((PRENOM<> "Jean") AND (NUMERO=5))');
  (* OK *)
  Query1.Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE (PRENOM<> "Jean") AND (NUMERO=5) OR (NOM= "MARTIN")');
  (* OK *)
  Query1.Sql.Add('  WHERE (1=1) ');
  (* NOK *)
  Query1.Sql.Add('  WHERE "TRUE" ');
  (* nOK *)
  Query1.Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE ((1=1) AND ( (NOM= "MARTIN") OR ((PRENOM<> "Jean") AND (NUMERO=5))))');
  (* OK *)
  Query1.Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NUMERO in (1, 3,5) ');

(* LIKE *)
  (* OK *)
  Query1.Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NOM LIKE "MAR%" ');
}
  Query1.Sql.Add('SELECT NUMERO, NOM, PRENOM FROM "E_SQL.DBF" ');
  Query1.Sql.Add('  WHERE NOM LIKE "MAR_IN" ');


  try
   Query1.Open;
  EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('Problme: '+ e.Message);
    END; (* TRY *)


end;

end.



