(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajopos *)

unit U_ajopos;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Post_: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Post_Click(Sender: TObject);
    procedure Table1BeforeClose(DataSet: TDataset);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)
  var l_erreur: String;

{$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
  Table1.Active:= Not Table1.Active;
end;

procedure TForm1.Post_Click(Sender: TObject);
begin
 TRY
   Table1.Post;

  EXCEPT
    ON e: eDbEngineError DO
      with eDbEngineError(e), Errors[ErrorCount- 1] do
      begin
        case ErrorCode OF
          DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
          else l_erreur:= '?? '+ e.Message;
        end;
        ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
      end;
    ON e: eDatabaseError DO
      ShowMessage('eDatabaseError: '+ e.Message);
  END; (* TRY *)
end;

procedure TForm1.Table1BeforeClose(DataSet: TDataset);
begin
  If Table1.State in [dsEdit, dsInsert ]
    Then Table1.Post;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  If Table1.State in [dsEdit, dsInsert ]
    Then Table1.Post;
end;

end.


