(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajoca5 *)

unit U_ajoca5;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1LIBELLE: TStringField;
    Table1QUANTITE: TFloatField;
    Table1PRIX: TFloatField;
    DataSource1: TDataSource;
    Table2: TTable;
    Table1POURCENT: TFloatField;
    Table1PRIX_TOTAL: TFloatField;
    procedure Table1CalcFields(DataSet: TDataset);
    procedure Table1QUANTITEValidate(Sender: TField);
    procedure Table1QUANTITEChange(Sender: TField);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const vi_dans_modifie_prix: Boolean= False;

procedure TForm1.Table1CalcFields(DataSet: TDataset);
    (* -- utilise une seconde table pour faire des cumuls *)
const vi_nombre: Integer= 0;
      vi_dans_Post: Boolean= False;
var l_cumul: Real;
begin
  if (Table1.State = dsEdit) and not vi_dans_Post and not vi_dans_modifie_prix
    then begin
        MessageBeep(0);
        inc(vi_nombre);
        if vi_nombre> 5
          then begin
              ShowMessage('pb');
              Abort;
            end;

        vi_dans_Post:= True;
        Table1.Post;
        vi_dans_Post:= False;
        exit;
      end;

  Table1PRIX_TOTAL.AsFloat:= Table1PRIX.AsFloat* Table1QUANTITE.AsFloat;

  with Table2 do
  begin
    ReFresh;

    First;
    l_cumul:= 0;

    while not EOF do
    begin
      l_cumul:= l_cumul+ FieldByName('PRIX').AsFloat* FieldByName('QUANTITE').AsFloat;
       Next;
    end;

    Table1POURCENT.AsFloat:= Int(Table1PRIX_TOTAL.AsFloat / l_cumul* 1000)/ 10 ;
  end;
end;

procedure TForm1.Table1QUANTITEValidate(Sender: TField);
begin
{
  If (Table1QUANTITE.AsInteger< 2) AND (Table1PRIX.AsFloat< 20)
}
  If (Table1QUANTITE.AsInteger< 2)
    then begin
        vi_dans_modifie_prix:= True;
        Table1PRIX.AsFloat:= Table1PRIX.AsFloat* 1.10* 3;
        vi_dans_modifie_prix:= False;

        If dbGrid1.Showing
          then dbGrid1.Invalidate;
      end;
end;

procedure TForm1.Table1QUANTITEChange(Sender: TField);
begin
  exit;

  If (Table1QUANTITE.AsInteger< 2)
    then begin
        vi_dans_modifie_prix:= True;
        Table1PRIX.AsFloat:= Table1PRIX.AsFloat* 1.10;

        vi_dans_modifie_prix:= False;

        If dbGrid1.Showing
          then dbGrid1.Invalidate;
      end;

end;

end.


