(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajocad *)

unit U_ajocad;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Button1: TButton;
    DBGrid1: TDBGrid;
    procedure Button1Click(Sender: TObject);
    procedure Table1CalcFields(DataSet: TDataset);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiTypes, DbiProcs, DbiErrs;

{$R *.DFM}

procedure TForm1.Table1CalcFields(DataSet: TDataset);
begin
  with Table1 do
    FieldByName('PRIX_TOTAL').AsFloat:=
      FieldByName('QUANTITE').AsInteger* FieldByName('PRIX').AsFloat;
end;

procedure TForm1.Button1Click(Sender: TObject);
var l_indice: Integer;
    l_champ: tField;
begin
  if Not Table1.Active
    then Table1.Open;
  Table1.Close;
  for l_indice:= 0 to Table1.FieldDefs.Count- 1 do
    if Table1.FieldDefs.Items[l_indice].Name<> 'CODE'
      then Table1.FieldDefs.Items[l_indice].CreateField(Table1);

  (* -- cration de notre champ *)
  l_champ:= tFloatField.Create(Table1);
  with l_champ do
  begin
    FieldName:= 'PRIX_TOTAL';
    Calculated:= True;
    DataSet:= Table1;
  end;
  Table1.OnCalcFields:= Table1CalcFields;
  Table1.Open;
end;

end.
