(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 u_ajosql *)

unit U_ajosql;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Query1: TQuery;
    modifie: TButton;
    ajoute: TButton;
    efface: TButton;
    Table1: TTable;
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    procedure modifieClick(Sender: TObject);
    procedure ajouteClick(Sender: TObject);
    procedure effaceClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

  uses DbiTypes, DbiProcs, DbiErrs;

  (*$i ..\..\u\f_errdbi *)

  var l_erreur: String;

{$R *.DFM}

procedure TForm1.modifieClick(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    Sql.Clear;

    Sql.Add('UPDATE "AJOUTE.DBF" ');
    Sql.Add('  SET PRIX = PRIX* 1.05');
{
    Sql.Add('  , QUANTITE= 10, CODE= NULL');
}
    Sql.Add('  WHERE PRIX< 30');

    ExecSql;
  end;

  Table1.Refresh;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    Sql.Clear;
{
    (* OK *)
    Sql.Add('UPDATE "AJOUTE.DBF" ');
    Sql.Add('  SET LIBELLE = :augmentation ');
    Sql.Add('  WHERE QUANTITE< :seuil');
    ParamByName('augmentation').AsString:= 'jiji';
    ParamByName('seuil').AsInteger:= StrToInt(Edit2.Text);
}
{
    (* OK *)
    Sql.Add('UPDATE "AJOUTE.DBF" ');
    Sql.Add('  SET CODE = :augmentation ');
    ParamByName('augmentation').AsInteger:= 3;
    Sql.Add('  WHERE QUANTITE< :seuil');
    ParamByName('seuil').AsInteger:= StrToInt(Edit2.Text);
}
{
    (* NOK *)
    Sql.Add('UPDATE "AJOUTE.DBF" ');
    Sql.Add('  SET CODE = :augmentation ');
    (* expr type incorrect *)
    ParamByName('augmentation').AsString:= '3';
    Sql.Add('  WHERE QUANTITE< :seuil');
    ParamByName('seuil').AsInteger:= StrToInt(Edit2.Text);
}

    Sql.Add('UPDATE "AJOUTE.DBF" ');
    Sql.Add('  SET PRIX = PRIX+ :augmentation ');
    Sql.Add('  WHERE QUANTITE< :seuil');
    ParamByName('augmentation').AsInteger:= StrToInt(Edit1.Text);
    ParamByName('seuil').AsFloat:= StrToFloat(Edit2.Text);

    try
      ExecSql;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
  end;

  Table1.Refresh;
end;

procedure TForm1.ajouteClick(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    Sql.Clear;
{
    (* OK *)
    Sql.Add('INSERT INTO "AJOUTE.DBF" ');
    Sql.Add('  (NUMERO, QUANTITE) ');
    Sql.Add('  VALUES (11, 12) ');
}
{
    (* OK *)
    Sql.Add('INSERT INTO "AJOUTE.DBF" ');
    Sql.Add('  (NUMERO, LIBELLE) ');
    Sql.Add('  VALUES (11, "Souris") ');
    (* OK *)
}
    Sql.Add('INSERT INTO "AJOUTE.DBF" ');
    Sql.Add('  (NUMERO, LIBELLE, QUANTITE, CODE, PRIX) ');
    Sql.Add('  VALUES (11, "Souris", 10, 20, 30.5) ');
{
    (* NON OK *)
    Sql.Add('INSERT INTO "AJOUTE.DBF"  ');
    Sql.Add('  VALUES (12, "Souris", 10, 20, 30.5) ');
}
{
    (* NOK *)
    Sql.Add('INSERT INTO "AJOUTE.DBF" ');
    Sql.Add('  (NUMERO, LIBELLE ');
    Sql.Add('  SELECT NUMERO, NOM FROM "AFFICHE.DBF" ');
}
    try
      ExecSql;
    EXCEPT
      ON e: eDbEngineError DO
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur+ f_erreur_dbi(ErrorCode));
        end;
      ON e: eDatabaseError DO
        ShowMessage('eDatabaseError: '+ e.Message);
    END; (* TRY *)
  end;
end;

procedure TForm1.effaceClick(Sender: TObject);
begin
  With Query1 do
  begin
    Close;
    Sql.Clear;
    Sql.Add('DELETE FROM "AJOUTE.DBF" ');
    Sql.Add('  WHERE PRIX > 30 ');
    ExecSql;
  end;
end;

end.


