(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* u_aff_e2 *)

unit U_aff_e2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    Panel1: TPanel;
    Memo1: TMemo;
    Modifie: TButton;
    Table1: TTable;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ModifieClick(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

const vi_action: String= '';
procedure affiche(p_evenement: String; p_type: Char);

const vi_modifie: Boolean= False;

implementation
  uses DbiProcs, DbiTypes, DBConsts, u_eveaj3;

{$R *.DFM}

(*$i ..\..\u\t_table *)
(*$i ..\..\u\i_a_tmpt *)

(*$i ..\..\u\f_state *)
(*$i ..\..\u\f_couran *)

const vi_entier: Integer= 0;
      vi_action_precedente: String= '';
      vi_etat_precedent: String= '';
      vi_tampon_precedent: String= '';
      vi_table_precedent: String= '';
      vi_numero_precedent: String= '';
      vi_eof_precedent: String= ' ';

procedure affiche(p_evenement: String; p_type: Char);
  var l_indente: Integer;
      l_texte: String;
      l_action, l_etat: String;
      l_valeur_tampon: String;
      l_valeur_table: String;
      l_numero: LongInt;
      l_chaine_numero: String;
      l_eof: Char;
      l_modifie: Char;
  begin
    if vi_cree
      then exit;

    case p_type of
      't' : l_indente:= 0;
      'f' : l_indente:= 1;
      's' : l_indente:= 2;
      'd' : l_indente:= 3;
      ' ' : l_indente:= 0;
    end;
    if vi_action<> vi_action_precedente
      then begin
          l_action:= vi_action;
          if vi_action_precedente= ''
            then Form1.Memo1.Lines.Add('');
        end
      else
        if vi_action<> ''
          then l_action:= '   "   '
          else l_action:= '';
    vi_action_precedente:= vi_action;

    l_etat:= f_state(Form2.Table2.State);
    if (l_etat= 'dsBrowse') and (vi_etat_precedent= 'dsEdit')
      then vi_modifie:= true;
    if l_etat= vi_etat_precedent
      then l_etat:= '   "   ';

    vi_etat_precedent:= f_state(Form2.Table2.State);

{
    l_texte:= Format('%3d %-12s %-10s %'+ IntToStr(l_indente* 10)+ 's %-23s',
        [vi_entier, l_action, l_etat, '', p_evenement]);

    l_valeur_tampon:= f_pt_tampon(Form2.Table2, 42, 7);
    l_valeur_tampon:= f_pt_tampon(Form2.Table2, 42+ 3, 8);
}
    l_valeur_tampon:= f_pt_tampon(Form2.Table2, 42+ 3, 8);
    if l_valeur_tampon= '       '
      then l_valeur_tampon:= 'NULL';
    if l_valeur_tampon= vi_tampon_precedent
      then l_valeur_tampon:= '   "'
      else vi_tampon_precedent:= l_valeur_tampon;

    l_numero:= f_courant(Form2.Table2);
    case l_numero of
      99 : l_chaine_numero:= 'f';
      98 : l_chaine_numero:= '?'
      else l_chaine_numero:= IntToStr(l_numero);
    end;
    if l_chaine_numero= vi_numero_precedent
      then l_chaine_numero:= '"'
      else vi_numero_precedent:= l_chaine_numero;

{
    if Form2.Table2.Active
      then
}
        begin
          if Form2.Table2.Eof
            then l_eof:= 'E'
            else l_eof:= 'N';
          if l_eof<> vi_eof_precedent
            then begin
                vi_eof_precedent:= l_eof
              end
            else l_eof:= '"';
        end;

    Form1.Table1.Open;
    Form1.Table1.First;
    Form1.Table1.Refresh;

    if (l_numero> 0) and (l_numero< 96)
      then Form1.Table1.MoveBy(l_numero- 1);
    l_valeur_table:= Form1.Table1.Fields[3].AsString;
    if l_valeur_table= vi_table_precedent
      then l_valeur_table:= '   "'
      else vi_table_precedent:= l_valeur_table;

    if Form2.Table2.Modified
      then l_modifie:= 'M'
      else l_modifie:= '_';

    l_texte:= Format('%3d %-12s %-12s %-2s %1s %1s %-8s %-7s %'+ IntToStr(l_indente* 10)+ 's%-23s',
        [vi_entier, l_action, l_etat, l_chaine_numero, l_eof, l_modifie, l_valeur_tampon, l_valeur_table,
         '', p_evenement]);

    Form1.Memo1.Lines.Add(l_texte);

    inc(vi_entier);

    Form1.ListBox1.Clear;
    Form1.ListBox1.Font.Name:= 'FixedSys';

    Form1.ListBox1.Items.Add(f_pt_tampon(Form2.Table2, 42, 7));
    affiche_tampons(Form2.Table2, 0, 30, Form1.ListBox1.Items);
    vi_action:= '';
  end; (* affiche *)

procedure TForm1.Button1Click(Sender: TObject);
const vi_nom: Char= 'A';
begin
  Memo1.Lines.SaveToFile(vi_nom+ '.PAS');
  vi_nom:= succ(vi_nom);
  Form1.Memo1.Lines.Add('');
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Clear;
  vi_entier:= 0;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.ModifieClick(Sender: TObject);
var l_texte: String;
var l_valeur: Double;
begin
  Form2.Open_Click(Nil);
  Form2.Close_Click(Nil);
  exit;

  vi_action:= 'Modifie';
  affiche('', ' ');

  Table1.Open;
  Table1.First;
  Table1.Edit;
  l_valeur:= Table1.Fields[3].AsFloat;
  MessageBeep(0);
{
  if l_valeur> 4
    then l_valeur:= 1.2345678
    else l_valeur:= 4.2345678;
}
  l_valeur:= l_valeur+ 2.5;
  Table1.Fields[3].AsFloat:= l_valeur;

{
  l_texte:= Table2.Fields[1].AsString;
  if l_texte[1]= 'C'
    then l_texte[1]:= 'D'
    else l_texte[1]:= 'C';
  Table2.Fields[1].AsString:= l_texte;
}
  Table1.Post;
  Table1.Close;
end;

end.
