(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)

(* 001 u_eveaj3 *)

(* analyse les ON de Field *)

unit U_eveaj3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, Mask, DBCtrls,
  DBLookup;

type
  TForm2 = class(TForm)
    Table2: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBEdit1: TDBEdit;

    Open_: TButton;
    Edit: TButton;
    Fields_As: TButton;
    Post: TButton;
    Close_: TButton;
    cree: TButton;
    Button2: TButton;
    Insert: TButton;
    SetFocus_: TButton;
    AppendRecord: TButton;
    InsertRecord: TButton;
    Cancel: TButton;
    Fields_Tx: TButton;
    db_Tx: TButton;
    db: TButton;
    Append: TButton;
    Index: TButton;
    Range: TButton;
    Refresh_: TButton;
    Fields_As__: TButton;
    Field_Tx_: TButton;
    Next_: TButton;
    Delete_: TButton;
    SetKey_: TButton;
    Table2LIBELLE: TStringField;
    Table2PRIX: TFloatField;
    Table2NUMERO: TFloatField;
    Table2QUANTITE: TFloatField;

    Button1: TButton;
    Button3: TButton;
    UpdCurs: TButton;
    Table2CALC: TFloatField;

    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DataSource1StateChange(Sender: TObject);
    procedure DataSource1UpdateData(Sender: TObject);
    procedure Open_Click(Sender: TObject);
    procedure Table2AfterCancel(DataSet: TDataset);
    procedure Table2AfterClose(DataSet: TDataset);
    procedure Table2AfterDelete(DataSet: TDataset);
    procedure Table2AfterEdit(DataSet: TDataset);
    procedure Table2AfterInsert(DataSet: TDataset);
    procedure Table2AfterOpen(DataSet: TDataset);
    procedure Table2AfterPost(DataSet: TDataset);
    procedure Table2BeforeCancel(DataSet: TDataset);
    procedure Table2BeforeClose(DataSet: TDataset);
    procedure Table2BeforeDelete(DataSet: TDataset);
    procedure Table2BeforeEdit(DataSet: TDataset);
    procedure Table2BeforeInsert(DataSet: TDataset);
    procedure Table2BeforeOpen(DataSet: TDataset);
    procedure Table2BeforePost(DataSet: TDataset);
    procedure Table2CalcFields(DataSet: TDataset);
    procedure Table2NewRecord(DataSet: TDataset);

    procedure EditClick(Sender: TObject);
    procedure Fields_AsClick(Sender: TObject);
    procedure PostClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Close_Click(Sender: TObject);
    procedure DBEdit1Change(Sender: TObject);
    procedure Table2LIBELLEChange(Sender: TField);
    procedure Table2LIBELLEGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table2LIBELLESetText(Sender: TField; const Text: String);
    procedure Table2LIBELLEValidate(Sender: TField);
    procedure creeClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Table2PRIXGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table2PRIXSetText(Sender: TField; const Text: String);
    procedure InsertClick(Sender: TObject);
    procedure DBEdit1Enter(Sender: TObject);
    procedure DBEdit1Exit(Sender: TObject);
    procedure SetFocus_Click(Sender: TObject);
    procedure DBEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure AppendRecordClick(Sender: TObject);
    procedure InsertRecordClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure Fields_TxClick(Sender: TObject);
    procedure db_TxClick(Sender: TObject);
    procedure dbClick(Sender: TObject);
    procedure AppendClick(Sender: TObject);
    procedure IndexClick(Sender: TObject);
    procedure RangeClick(Sender: TObject);
    procedure Table2PRIXValidate(Sender: TField);
    procedure Refresh_Click(Sender: TObject);
    procedure Fields_As__Click(Sender: TObject);
    procedure Table2CALCGetText(Sender: TField; var Text: OpenString;
      DisplayText: Boolean);
    procedure Table2CALCSetText(Sender: TField; const Text: String);
    procedure Table2CALCValidate(Sender: TField);
    procedure Field_Tx_Click(Sender: TObject);
    procedure Next_Click(Sender: TObject);
    procedure Delete_Click(Sender: TObject);
    procedure SetKey_Click(Sender: TObject);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure DBGrid1ColExit(Sender: TObject);
    procedure UpdCursClick(Sender: TObject);
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
  private
    { Private-dclarations }
    procedure traite_exceptions(Sender: TObject; E: Exception);
    function f_nom_champ(p_champ: tField): String;
  public
    { Public-dclarations }
  end;

var
  Form2: TForm2;
const vi_cree: Boolean= False;

implementation
  uses dbiErrs, dbiTypes, u_aff_e2;

{$R *.DFM}

  (*$i ..\..\u\f_state *)

  const vi_avec_db_edit: Boolean= False;
        vi_avec_db_grid: Boolean= True;

        vi_PRIX: BOOLEAN= True;
        vi_LIBELLE: BOOLEAN= False;
        vi_CALC: Boolean= False;

  procedure TForm2.traite_exceptions(Sender: TObject; E: Exception);
  begin
{
    if E is EDBEngineError then begin
       err := (E as EDBEngineError).errors[(E as EDBEngineError).errorcount - 1].errorcode;
       if (err = DBIERR_KEYVIOL) then
          showMessage('A Key violation occurred!')
       else if (err = DBIERR_LOCKED) then
          showmessage('Record locked by another user')
       else if (err = DBIERR_FILELOCKED) then
          showmessage('Table locked by someone else')
       else
          showmessage('Other DB Error')
       end
    else
       showmessage('Whoops!: '+E.Message);
}
    if E is EDBEngineError
      then begin
          showmessage('Exc DBI '+ e.Message)
        end
      else
        if e is EDatabaseError
          then begin
              showmessage('Exc database '+ e.Message)
            end
          else showmessage('Exc autre ');
  end;

procedure TForm2.FormCreate(Sender: TObject);
begin
{
  Application.OnException:= traite_exceptions;
}
end;

(* -- vnements *)

procedure TForm2.Table2BeforeOpen(DataSet: TDataset);
begin
  affiche('BeforeOpen', 't');
end;

procedure TForm2.Table2AfterOpen(DataSet: TDataset);
begin
  affiche('AfterOpen', 't');
end;

procedure TForm2.Table2BeforeInsert(DataSet: TDataset);
begin
  affiche('BeforeInsert', 't');
end;

procedure TForm2.Table2AfterInsert(DataSet: TDataset);
begin
  affiche('AfterInsert', 't');
end;

procedure TForm2.Table2BeforeEdit(DataSet: TDataset);
begin
  affiche('BeforeEdit', 't');
end;

procedure TForm2.Table2AfterEdit(DataSet: TDataset);
begin
  affiche('AfterEdit', 't');
end;

procedure TForm2.Table2BeforeDelete(DataSet: TDataset);
begin
  affiche('BeforeDelete', 't');
end;

procedure TForm2.Table2AfterDelete(DataSet: TDataset);
begin
  affiche('AfterDelete', 't');
end;

procedure TForm2.Table2BeforeCancel(DataSet: TDataset);
begin
  affiche('BeforeCancel', 't');
end;

procedure TForm2.Table2AfterCancel(DataSet: TDataset);
begin
  affiche('AfterCancel', 't');
end;

procedure TForm2.Table2BeforePost(DataSet: TDataset);
begin
  if vi_cree
    then exit;

  affiche('BeforePost', 't');

{
  Table2.Cancel;
  SysUtils.Abort;
  affiche('--BeforePost', 't');
}
end;

procedure TForm2.Table2AfterPost(DataSet: TDataset);
begin
  affiche('AfterPost', 't');
end;

procedure TForm2.Table2CalcFields(DataSet: TDataset);
const vi_nombre: Integer= 0;
begin
  affiche('CalcFields', 't');

{
  Table2.Edit;
  Table2Prix.AsFloat:= 5;
  (* "ne peut insrer" ou "dj verrouill" *)
  Table2.Next; Table2.Prior;
}

  Table2CALC.AsFloat:= Table2PRIX.AsFloat* 2;

  Button3.Caption:= IntToStr(vi_nombre);
  inc(vi_nombre);
{
  (* -- exc: pas en mode Edit *)
  Table2.Post;
}
end;

procedure TForm2.Table2NewRecord(DataSet: TDataset);
begin
  affiche('NewRecord', 't');
end;

procedure TForm2.Table2BeforeClose(DataSet: TDataset);
begin
  affiche('BeforeClose', 't');
{
  Table2.Cancel;
  SysUtils.Abort;
}
end;

procedure TForm2.Table2AfterClose(DataSet: TDataset);
begin
  affiche('AfterClose', 't');
end;

(* -- Field Persistent: Table2Nom *)

  function TForm2.f_nom_champ(p_champ: tField): String;
    begin
      if p_champ= nil
        then Result:= 'nil'
        else Result:= p_champ.Name;
    end; (* f_nom *)

procedure TForm2.Table2LIBELLEChange(Sender: TField);
begin
  if vi_LIBELLE OR vi_PRIX OR vi_CALC
    then
      affiche('Change('+ f_nom_champ(Sender)+ ')', 'f');
end;

const vi_booleen: Array[False..True] of String= ('False', 'True');

procedure TForm2.Table2LIBELLEGetText(Sender: TField; var Text: OpenString;
  DisplayText: Boolean);
var l_texte: String;
begin
  if NOT vi_LIBELLE
    then begin
        Text:= Sender.AsString;
      end
    else begin
        l_texte:= LowerCase(Sender.AsString);
        IF DisplayText
          then l_texte[1]:= UpCase(l_texte[1]);
{
  l_texte[1]:= succ(l_texte[1]);
}
        affiche('GetText('+ f_nom_champ(Sender)+ ', -, '+ vi_booleen[DisplayText]+ ') ->'+ l_texte, 'f');
        Text:= l_texte;
      end;
end;

procedure TForm2.Table2LIBELLESetText(Sender: TField; const Text: String);
var l_texte: String;
begin
  if not vi_LIBELLE
    then Sender.AsString:= Text
    else begin
        affiche('SetText('+ f_nom_champ(Sender)+ ', '+ Text+ ')', 'f');

        l_texte:= UpperCase(Text);
{
        l_texte[1]:= succ(l_texte[1]);
}
        Sender.AsString:= l_texte;
      end;
end;

procedure TForm2.Table2LIBELLEValidate(Sender: TField);
var l_texte: String;
    l_valeur: Double;
begin
  if NOT vi_LIBELLE
    then exit;

  affiche('Validate('+ f_nom_champ(Sender)+ ')', 'f');
{
  l_valeurTable2PRIX.AsFloat:= Table2PRIX.AsFloat+ 1;
}
  l_valeur:= Table2PRIX.AsFloat+ 0.1;
end;

procedure TForm2.Table2PRIXGetText(Sender: TField; var Text: OpenString;
  DisplayText: Boolean);
var l_valeur: Double;
    l_texte: String;

begin
{
  ShowMessage('OK');
{
  l_valeur:= Table2PRIX.AsFloat;
  l_valeur:= l_valeur+ 0.5;
  l_texte:= FloatToStr(l_valeur);
  MessageBeep(0);
}
  if NOT vi_PRIX
    then Text:= Sender.AsString
    else begin
        l_texte:= '0'+ Sender.AsString;
        If Not DisplayText
          then l_texte:= '+'+ l_texte;

        affiche('GetText('+ f_nom_champ(Sender)+ ', -, '+ vi_booleen[DisplayText]+ ') ->'+ l_texte, 'f');
        Text:= l_texte;
      end;
end;

procedure TForm2.Table2PRIXSetText(Sender: TField; const Text: String);
var l_valeur: Double;
begin
{
  if NOT vi_PRIX
    then Table2PRIX.AsString:= Text
    else
}
      begin
        MessageBeep(0);
        affiche('SetText('+ f_nom_champ(Sender)+ ', '+ Text+ ')', 'f');

        l_valeur:= StrToFloat(Text);
        l_valeur:= l_valeur- 0.5;

        Sender.AsFloat:= l_valeur;
      end;
end;

procedure TForm2.Table2PRIXValidate(Sender: TField);
begin
  if vi_PRIX
    then
      affiche('Validate('+ f_nom_champ(Sender)+ ') '+ Table2PRIX.AsString, 'f');
end;

procedure TForm2.Table2CALCGetText(Sender: TField; var Text: OpenString;
  DisplayText: Boolean);
var l_valeur: Double;
    l_texte: String;
begin
  if NOT vi_CALC
    then Text:= Sender.AsString
    else begin
        l_texte:= '0'+ Sender.AsString;
        If Not DisplayText
          then l_texte:= '+'+ l_texte;

        affiche('GetText('+ f_nom_champ(Sender)+ ', -, '+ vi_booleen[DisplayText]+ ') ->'+ l_texte, 'f');
        Text:= l_texte;
      end;
end;

procedure TForm2.Table2CALCSetText(Sender: TField; const Text: String);
var l_valeur: Double;
begin
  if NOT vi_CALC
    THEN Sender.AsString:= Text
    else begin
        MessageBeep(0);
        affiche('SetText('+ f_nom_champ(Sender)+ ', '+ Text+ ')', 'f');

        l_valeur:= StrToFloat(Text);
        l_valeur:= l_valeur- 0.5;

        Sender.AsFloat:= l_valeur;
      end;
end;

procedure TForm2.Table2CALCValidate(Sender: TField);
begin
  if vi_CALC
    then
      affiche('Validate('+ f_nom_champ(Sender)+ ') '+ Table2CALC.AsString, 'f');
end;

(* DataSource *)

  function f_nom_objet(p_objet: tObject): String;
    begin
      if p_objet IS tComponent
        then Result:= tComponent(p_objet).Name
        else Result:= '??';
    end;

procedure TForm2.DataSource1UpdateData(Sender: TObject);
begin
  affiche('UpdateData('+ f_nom_objet(Sender)+ ')', 's');
end;

procedure TForm2.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  affiche('DataChange('+ f_nom_objet(Sender)+ ', '+ f_nom_champ(Field)+ ')', 's');
end;

procedure TForm2.DataSource1StateChange(Sender: TObject);
begin
  affiche('StateChange('+ f_nom_objet(Sender)+ ')', 's' );
{
  if vi_modifie and (Table2.State= dsBrowse)
    then begin
        Form2.ModifieClick(nil);
        affiche('--StateChange('+ f_nom_objet(Sender)+ ')', 's' );
      end;
}
end;

(* db_xxx *)

procedure TForm2.DBEdit1Change(Sender: TObject);
begin
  if vi_avec_db_edit or vi_avec_db_grid
    then affiche('Change('+ f_nom_objet(Sender)+ ')', 'd' );
end;

procedure TForm2.DBEdit1Enter(Sender: TObject);
begin
  if vi_avec_db_edit or vi_avec_db_grid
    then affiche('Enter('+ f_nom_objet(Sender)+ ')', 'd' );
end;

procedure TForm2.DBEdit1Exit(Sender: TObject);
begin
  if vi_avec_db_edit or vi_avec_db_grid
    then affiche('Exit('+ f_nom_objet(Sender)+ ')', 'd' );
end;

procedure TForm2.DBEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if vi_avec_db_edit or vi_avec_db_grid
    then begin
        if (chr(Key)= '6') or (chr(Key)= 'X')
          then begin
              vi_action:= 'Chge Focus';
              affiche('', ' ');
              post.SetFocus;
            end;
      end;
end;

procedure TForm2.DBEdit1KeyPress(Sender: TObject; var Key: Char);
var l_texte: String;
begin
  if vi_avec_db_edit or vi_avec_db_grid
    then begin
        if Key in [' '..chr(255)]
          then l_texte:= ''''+ Key+ ''''
          else
            case Key of
              #9 : l_texte:= 'Tab';
              #13 : l_texte:= 'Ret';
              else l_texte:= IntToStr(ord(Key));
            end;

        vi_action:= 'Clavier';
        affiche('KeyPress('+ f_nom_objet(Sender)+ ', '+ l_texte+ ')', 'd' );
      end;
end;

procedure TForm2.DBGrid1ColEnter(Sender: TObject);
begin
  affiche('ColEnter('+ f_nom_objet(Sender)+ ') ='
     + f_nom_champ(dbGrid1.SelectedField), 'd' );
end;

procedure TForm2.DBGrid1ColExit(Sender: TObject);
begin
  affiche('ColExit('+ f_nom_objet(Sender)+ ') ='
      + f_nom_champ(dbGrid1.SelectedField), 'd' );
end;

procedure TForm2.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
var l_texte: String;
begin
  l_texte:= '';
  if gdSelected in State
    then l_texte:= l_texte+ 'Sel ';
  if gdFocused in State
    then l_texte:= l_texte+ 'Foc ';
  if gdFixed in State
    then l_texte:= l_texte+ 'Fix';

  affiche('DrawDataCell('+ f_nom_objet(Sender)+ ') ='
      + f_nom_champ(Field)+ ' '+ l_texte, 'd' );

end;

(* -- actions *)

var g_valeur: Double;

procedure TForm2.Open_Click(Sender: TObject);
begin
  vi_action:= 'Open';
  Table2.Open;
  g_valeur:= Table2PRIX.AsFloat;
end;

procedure TForm2.EditClick(Sender: TObject);
begin
  vi_action:= 'Edit';
  Table2.Edit;
end;

procedure TForm2.InsertClick(Sender: TObject);
begin
  vi_action:= 'Insert';
  Table2.Insert;
end;

procedure TForm2.AppendClick(Sender: TObject);
begin
  vi_action:= 'Append';
  Table2.Append;
end;

procedure TForm2.Fields_AsClick(Sender: TObject);
(* -- affecte une valeur diffrente *)
var l_valeur: Double;
begin
  vi_action:= 'Fields.As_:=';
  Try
{
    Table2.Fields[1].AsString:= 'abcdefghijklm';
}
    if g_valeur> 2
      then l_valeur:= 1.2345678
      else l_valeur:= 2.2345678;


{
    l_valeur:= 1/3;
    l_valeur:= 4.0;
}

    Table2PRIX.AsFloat:= l_valeur;
    g_valeur:= l_valeur;
  except
    showmessage('Fields:= ');
  end;
end;

procedure TForm2.Fields_As__Click(Sender: TObject);
(* -- affecte une valeur identique *)
var l_valeur: Double;
begin
  vi_action:= 'Fields.As_:= =';
  with Form1.Table1 do
  begin
    Open;
    l_valeur:= Table2PRIX.AsFloat;
  end;

  Table2PRIX.AsFloat:= l_valeur;
end;

const vi_field_text: String= '1.2';

procedure TForm2.Field_Tx_Click(Sender: TObject);
begin
  vi_action:= ':=Fields.Tx_';
  vi_field_text:= Table2PRIX.Text;
end;

procedure TForm2.Fields_TxClick(Sender: TObject);
var l_valeur: Double;
    l_valeur_texte: Double;
begin
  vi_action:= 'Fields.Tx_:=';
  with Form1.Table1 do
  begin
    Open;
    l_valeur:= Table2PRIX.AsFloat;
  end;
  l_valeur_texte:= StrToFloat(vi_field_text);
  if l_valeur= l_valeur_texte
    then l_valeur:= l_valeur+ 1;

  Table2PRIX.Text:= FloatToStr(l_valeur);
end;

procedure TForm2.db_TxClick(Sender: TObject);
var l_valeur: Double;
begin
  vi_action:= 'dbEd.Tx_:=';
  affiche('', ' ');

  if g_valeur> 2
    then l_valeur:= 1.2345678
    else l_valeur:= 2.2345678;

end;

procedure TForm2.PostClick(Sender: TObject);
begin
  vi_action:= 'Post';

  Table2.Post;
{
  try
    Table2.Post;
  except
  end;
  affiche('x', 't');
}
end;

procedure TForm2.SetFocus_Click(Sender: TObject);
begin
  vi_action:= 'SetFocus';

  dbEdit1.SetFocus;

end;

procedure TForm2.AppendRecordClick(Sender: TObject);
begin
  vi_action:= 'AppendRecord';
  Table2.AppendRecord([6, 'Souris', '3', 60.23456]);
end;

procedure TForm2.InsertRecordClick(Sender: TObject);
begin
  vi_action:= 'InsertRecord';
  Table2.InsertRecord([9, 'RIRI', 'Ernest', 7.23456, '1/3/2010', False]);
end;

procedure TForm2.CancelClick(Sender: TObject);
begin
  vi_action:= 'Cancel';
  affiche('', ' ');
  Table2.Cancel;
end;

procedure TForm2.Delete_Click(Sender: TObject);
begin
  vi_action:= 'Delete';
  Table2.Delete;
end;

procedure TForm2.Close_Click(Sender: TObject);
begin
  vi_action:= 'Close';
  Table2.Close;
end;

procedure TForm2.creeClick(Sender: TObject);
var l_table: tTable;
begin
  vi_cree:= True;

  l_table:= tTable.Create(Nil);
  With l_table do
  begin
    DatabaseName:= 'Flix';
    TableType:= ttdBase;
    TableName:= 'AJOUTE.DBF';

    FieldDefs.Clear;
    FieldDefs.Add('NUMERO', ftInteger, 0, True);
    FieldDefs.Add('LIBELLE', ftString, 10, True);
    FieldDefs.Add('QUANTITE', ftInteger, 0, True);
    FieldDefs.Add('PRIX', ftFloat, 0, False);

    IndexDefs.Clear;
    IndexDefs.Add('IND_LIBELL', 'LIBELLE', []);

    CreateTable;

    Open;

    AppendRecord([1, 'Tapis', 2, 1.23]);
    AppendRecord([2, 'Srie', 3, 20.23]);
    AppendRecord([3, 'Papier', 1, 30.23]);
    AppendRecord([4, 'Disque dur', 3, 40.23]);
    AppendRecord([5, 'Processeur', 1, 50.23]);

    Close;

    vi_cree:= False;
  end; (* with Table *)

  l_table.Free;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  vi_action:= 'Affiche';
  affiche('', ' ');
end;

procedure TForm2.Refresh_Click(Sender: TObject);
begin
  vi_action:= 'Refresh';
  affiche('', ' ');
  Table2.Refresh;
end;

procedure TForm2.UpdCursClick(Sender: TObject);
begin
  vi_action:= 'UpdateCursorPos';
  affiche('', ' ');
  Table2.UpdateCursorPos;
end;

procedure TForm2.Next_Click(Sender: TObject);
begin
  vi_action:= 'Next';
  Table2.Next;
end;

procedure TForm2.RangeClick(Sender: TObject);
begin
  vi_action:= 'SetRange';
  Table2.IndexName:= 'Ind_LIBELLE';
  Table2.SetRange(['B'], ['T']);
end;

procedure TForm2.SetKey_Click(Sender: TObject);
begin
  With Table2 do
  begin
    vi_action:= 'SetRange';
    IndexName:= 'Ind_LIBELLE';

    Table2.SetRangeStart;
    Table2LIBELLE.AsString:= 'B';
    Table2.SetRangeEnd;
    Table2LIBELLE.AsString:= 'T';
    ApplyRange;
  end;
end;

procedure TForm2.dbClick(Sender: TObject);
begin
  exit;

  Table2LIBELLE.Index:= 3;
  exit;

  vi_avec_db_edit:= not vi_avec_db_edit;
  if vi_avec_db_edit
    then db.Caption:= 'reprendre'
    else begin
        db.Caption:= 'ss db_xxx';
        Table2.Close;

        dbGrid1.DataSource:= Nil;
      end;
end;

procedure TForm2.IndexClick(Sender: TObject);
begin
  Table2.IndexName:= 'Ind_LIBELLE';
end;

end.




