(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 ajocan *)
(* 21 nov 95 *)

unit U_ajocan;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure Table1BeforePost(DataSet: TDataset);
    procedure FormCreate(Sender: TObject);
  private
    { Private-dclarations }
    procedure traite_exceptions(Sender: TObject; E: Exception);
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation
  uses DbiErrs;

{$R *.DFM}

  type t_exception= Class(Exception);

  procedure TForm1.traite_exceptions(Sender: TObject; E: Exception);
  var l_erreur: String;
  begin
    if E is EDBEngineError
      then 
        with eDbEngineError(e), Errors[ErrorCount- 1] do
        begin
          case ErrorCode OF
            DbiErr_InvalidFileExtn : l_erreur:= 'mauvaise extension';
            else l_erreur:= '?? '+ e.Message;
          end;
          ShowMessage(IntToStr(ErrorCode)+ l_erreur);
        end
      else
        if e is EDatabaseError
          then begin
              showmessage('Exc database '+ e.Message)
            end
          else
            if e is t_exception
              then showmessage('mon exception ')
              else showmessage('Exc autre ');
  end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnException:= traite_exceptions;
end;

procedure TForm1.Table1BeforePost(DataSet: TDataset);
begin
  If MessageDlg('Poster ? ', mtConfirmation, [mbOk, mbNo], 0)<> mrOk
    then begin
        MessageBeep(0);
        Table1.Cancel;
        Raise t_exception.Create('');
{
        Raise t_exception.Create('a avort');
        Abort;
}
      end;
end;

end.
