(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 ajocom *)
(* 21 nov 95 *)

unit U_ajocom;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1LIBELLE: TStringField;
    Table1QUANTITE: TFloatField;
    Table1PRIX: TFloatField;
    Table1CODE: TFloatField;
    ComboBox1: TComboBox;
    procedure ComboBox1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure ComboBox1Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var l_cle: String;
begin
  With Table1 do
  begin
    ComboBox1.Clear;

    First;
    While not Eof do
    begin
      l_cle:= Table1LIBELLE.AsString;
      If (l_cle<> '') and (ComboBox1.Items.IndexOf(l_cle)< 0)
        then begin
            ComboBox1.Items.Add(l_cle);
          end;
      Next;
    end;
    First;
  end; (* with Table1 *)
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
  DataSource1.OnDataChange:= Nil;

  With Table1 do
  begin
    Edit;
    Table1LIBELLE.AsString:= ComboBox1.Text;
    Post;
  end;

  DataSource1.OnDataChange:= DataSource1DataChange;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var l_indice: Integer;
begin
  l_indice:= ComboBox1.Items.IndexOf(Table1LIBELLE.AsString);
  if l_indice>= 0
    then ComboBox1.ItemIndex:= l_indice;
end;

procedure TForm1.ComboBox1Exit(Sender: TObject);
var l_indice: Integer;
    l_texte: String;
begin
  l_texte:= ComboBox1.Text;
  l_indice:= ComboBox1.Items.IndexOf(l_texte);
  if l_indice< 0
    then begin
        ComboBox1.Items.Add(l_texte);

        l_indice:= ComboBox1.Items.IndexOf(l_texte);
        ComboBox1.ItemIndex:= l_indice;

        ComboBox1Click(Sender);
      end;
end;

end.
