(* -- Projet provenant du livre DELPHI dBase de John COLIBRI *)
(* -- INSTITUT PASCAL - 26 rue Lamartine 75009 PARIS - 42.85.10.82 *)
(* -- (C) Copyright MNEMODYNE 1996 -*)


(* 001 ajoli1 *)
(* 21 nov 95 *)

unit U_ajoli1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1NUMERO: TFloatField;
    Table1LIBELLE: TStringField;
    Table1QUANTITE: TFloatField;
    Table1PRIX: TFloatField;
    Button1: TButton;
    ListBox1: TListBox;
    Table1CODE: TFloatField;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  with ListBox1, Items do
  begin
    Items.Clear;

    Add('Tapis');
    Add('Srie');
    Add('Papier');
    Add('Disque dur');
    Add('Processeur');
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  DataSource1.OnDataChange:= Nil;

  With Table1 do
  begin

    Edit;
    Table1LIBELLE.AsString:= ListBox1.Items[ListBox1.ItemIndex];
    Post;
  end;

  DataSource1.OnDataChange:= DataSource1DataChange;
end;

procedure TForm1.Button2Click(Sender: TObject);
var l_cle: String;
    l_BookMark: tBookMark;
begin
  With Table1 do
  begin
    l_bookmark:= GetBookMark;
    ListBox1.Clear;

    First;
    While not Eof do
    begin
      l_cle:= Table1LIBELLE.AsString;
      If (l_cle<> '') and (ListBox1.Items.IndexOf(l_cle)< 0)
        then ListBox1.Items.Add(l_cle);
      Next;
    end;

    GotoBookMark(l_bookmark);
    FreeBookMark(l_bookmark);
  end; (* with Table1 *)
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var l_indice: Integer;
begin
  l_indice:= ListBox1.Items.IndexOf(Table1LIBELLE.AsString);
  if l_indice>= 0
    then ListBox1.ItemIndex:= l_indice;
end;

end.
