(* 001 i_a_tmpt *)

  procedure affiche_tampons(p_table: tDataSet; p_debut, p_quantite: Integer; p_chaines: tStrings);
    type t_pt_char= ^char;
    var l_indice_ligne: Integer;
        l_indice_colonne: Integer;
        l_chaine: String;
        l_caractere: Char;
    begin
      with p_chaines, t_pt_table(p_table)^ do
      begin
        for l_indice_ligne:= 0 to f_buf_list_size- 1 do
        begin
          (*$r-*)
          l_chaine:= '';

          for l_indice_colonne:= p_debut to p_debut+ p_quantite- 1 do
          begin
            l_caractere:= t_pt_caracteres(f_buffer_list^[l_indice_ligne])^[l_indice_colonne];
            case l_caractere of
              #0 : l_caractere:= 'z';
              ' ' : l_caractere:= '_';
            end;

            l_chaine:= l_chaine+ l_caractere;
          end; (* for *)

          Add(l_chaine+ '<');
          (*$r+*)
        end; (* for *)
      end; (* with *)
    end; (* affiche_tampons *)

  function f_pt_tampon(p_table: tDataSet; p_debut, p_quantite: Integer): String;
    var l_indice_ligne, l_indice_colonne: Integer;
        l_chaine: String;
        l_caractere: Char;
    begin
      with t_pt_table(p_table)^ do
      begin
        l_chaine:= '';
        if f_buf_list_size> 0
          then begin
              (*$r-*)
              l_chaine:= '';
              l_indice_ligne:= 0;

              for l_indice_colonne:= p_debut to p_debut+ p_quantite- 1 do
              begin
                l_caractere:= t_pt_caracteres(f_buffer_list^[l_indice_ligne])^[l_indice_colonne];

            l_chaine:= l_chaine+ l_caractere;
          end; (* for *)

          (*$r+*)
        end; (* for *)

        f_pt_tampon:= l_chaine;
      end; (* with *)
    end; (* f_pt_tampon *)

  procedure affiche_key_buffers(p_table: tTable; p_debut, p_quantite: Integer; p_chaines: tStrings);
    type t_pt_char= ^char;
    var l_indice_ligne: Integer;
        l_indice_colonne: Integer;
        l_chaine: String;
        l_caractere: Char;
    begin
      with p_chaines, t_pt_table(p_table)^ do
      begin
        for l_indice_ligne:= 0 to 5 do
        begin
          (*$r-*)
          l_chaine:= '';

          if f_key_buffers[l_indice_ligne]<> nil
            then

          for l_indice_colonne:= p_debut to p_debut+ p_quantite- 1 do
          begin
            l_caractere:= t_pt_caracteres(f_key_buffers[l_indice_ligne])^[l_indice_colonne];
            case l_caractere of
              #0 : l_caractere:= 'z';
              ' ' : l_caractere:= '_';
            end;

            l_chaine:= l_chaine+ l_caractere;
          end; (* for *)
{
          l_chaine:= IntToHex(f_key_buffers[l_indice_ligne], 4);
}
          Add(l_chaine+ '<');
          (*$r+*)
        end; (* for *)

        if f_key_buffer<> nil
          then begin
              (*$r-*)
              l_chaine:= '';

              for l_indice_colonne:= p_debut to p_debut+ p_quantite- 1 do
              begin
                l_caractere:= t_pt_caracteres(f_key_buffer)^[l_indice_colonne];
                case l_caractere of
                  #0 : l_caractere:= 'z';
                  ' ' : l_caractere:= '_';
                end;

                l_chaine:= l_chaine+ l_caractere;
              end; (* for *)
              Add(l_chaine+ '<');
              (*$r+*)
            end;
      end; (* with *)
    end; (* affiche_key_buffers *)

(* fin i_a_tmpt *)

